2003-09-22  Radek Doulik  <rodo@ximian.com>

	* libgtkhtml.pc.in (Cflags): remove a11y lib reference

	* Makefile.am (libgtkhtml_3_0_la_LIBADD): link against a11y lib,
	use GAIL libs

2004-02-18  JP Rosevear <jpr@ximian.com>

	* Makefile.am: remove disable deprecated flags

2003-12-10  Yong Sun <Yong.Sun@sun.com>

	* htmlengine-edit-cursor.c: correct the calculation of 
	cursor's height
	
2003-11-20  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-text.c (upper_lower): use g_utf8 functions to
	lower/upper string

2003-10-15  Frederic Crozat  <fcrozat@mandrakesoft.com>

	* htmlobject.c: (handle_object_data):
	Close comment when saving object data, part 2 (bug #38589)

2003-10-14  Radek Doulik  <rodo@ximian.com>

	* htmlobject.c (select_range): select containers

	* htmlinterval.c (select_object): select range in containers

2003-10-14  Suresh Chandrasekharan <suresh.chandrasekharan@sun.com>
	
	* htmlclueflow.c (search_text): Fixes for supporting forward
	multibyte search, backward search and backward multibyte search.

	(search_set_info): -do-

2003-10-13  Frederic Crozat  <fcrozat@mandrakesoft.com>

	* htmlobject.c: (object_save_data):
	Close comment when saving object data (bug #38589).

2003-07-31  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit.c (html_engine_select_spell_word_editable): fix
	cittation

2003-09-19  Jeremy Katz  <katzj@redhat.com>

	* htmlengine.c (html_engine_get_type): Use GType instead of guint.
	* htmlengine.h: Likewise.

2003-09-05  Antonio Xu  <antonio.xu@sun.com>

	* gtkhtml.c (new_obj_from_uri): Use HTML_IS_PLAIN_PAINTER to judge
	html edit model, and use g_filename_from_uri to get the image file's
	real path, fix bug #47988 #47990.

2003-09-03  Dan Winship  <danw@ximian.com>

	* Makefile.am (testgtkhtml_LDFLAGS): Remove -static again

2003-09-01  Maxx Cao  <maxx.cao@sun.com>

	* htmltextslave.c (get_offset_for_pointer): add consideration for
	one-character text, fix bug #47676.

2003-08-15  Antonio Xu  <antonio.xu@sun.com>

	* htmlengine-edit-movement.c (html_engine_jump_at): add
	gtk_html_im_reset before html_engine_get_object_at, fix bug #47349.

2003-08-15  Antonio Xu  <antonio.xu@sun.com>

	* htmlengine-edit-cut-and-paste.c (insert_object_do): copy cursor
	instead of receate a new cursor, fix bug #45911.

2003-08-12  Antonio Xu  <antonio.xu@sun.com>

	* gtkhtml.c (new_obj_from_uri): Use pixbuf to judge what kind of
	image type being supported by gtkhtml, fix bug #47543.

2003-08-07  Larry Ewing  <lewing@ximian.com>

	* gtkhtml.c (key_press_event): only reset the blinking cursor if
	we are editable.

2003-08-01  Radek Doulik  <rodo@ximian.com>

	* htmlobject.c (get_length): objects not accepting cursor have
	zero length

2003-07-28  Radek Doulik  <rodo@ximian.com>

	* htmltext.c (get_tags): fix color check to save color attribute
	for blue text

2003-07-15  Radek Doulik  <rodo@ximian.com>

	* htmlprinter.c (alloc_font): fallback to 1st available font only
	when default fonts aren't available

2003-07-03  Radek Doulik  <rodo@ximian.com>

	* htmlobject.c (html_object_cursor_backward): allow offset == 0 if
	prev object doesn't accept cursor
	(move_object_downtree_cursor): skip cursor non-accepting objects

	* gtkhtml.c (key_press_event): reset blinking cursor if key was
	used

2003-07-07  Yuedong Du  <yuedong.du@sun.com>

        * gtkhtml.c (add_bindings): remove keybinding for Control+Tab/
        Shift+Control+Tab, fix bug #45825

2003-06-27  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (gtk_html_editor_event): initialize retval to NULL

2003-06-26  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (button_press_event): fix coordinates
	(shift_to_iframe_parent): ditto

2003-06-24  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (parse_body): add helper functions to push/pop clue
	levels.
	(html_engine_finalize): unref the body background.  If the body
	stack isn't empty clear it.

2003-06-20  Larry Ewing  <lewing@ximian.com>

	* gtkhtml.c (gtk_html_editor_event_command): unset the args.
	(gtk_html_editor_event): unset and free the return value.

	* htmlfontmanager.c: fix ref font refcounting problems.

	* htmlgdkpainter.c (unref_font): free the font description.

	* htmlmap.c (html_map_destroy): free the map structure as well.

	* htmlpainter.c (finalize): free the font_face.

	* htmlstyle.c (html_style_add_attribute): keep the correct ref
	count on the color.

	* htmltable.c (divide_into_percented_all): don't leak active.

2003-06-25  Radek Doulik  <rodo@ximian.com>

	* htmlgdkpainter.c (alloc_font): the face now contain family, not
	whole font name

	* htmlengine-print.c (print_with_header_footer): use
	gtk_html_set_fonts

	* gtkhtml.c (gtk_html_set_fonts): new helper function, sets fonts
	from style to painter's font manager, use families rather than
	complete description name for face
	(style_set): use gtk_html_set_fonts

2003-06-13  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (html_engine_finalize): clear some of the various
	state tables.

2003-06-12  Larry Ewing  <lewing@ximian.com>

	* gtkhtml.c (destroy): free base_url.

	* htmltable.c (destroy): free columnFixed array.

2003-06-10  Larry Ewing  <lewing@ximian.com>

	* gtkhtml.c (style_set): free the var_name.
	(selection_get): don't leak the selection string.
	(finalize): free the body_stack.

2003-06-09  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (html_engine_finalize): don't leak body_stack.

2003-05-21  Larry Ewing  <lewing@ximian.com>

	* libgtkhtml.pc.in (Version): set version correctly.

2003-05-20  Larry Ewing  <lewing@ximian.com>

	* htmlimage.c (html_image_resolve_image_url): unset oarg not iarg
	and dup the string.

	* gtkhtml.h: add prototypes.

	* htmlengine-edit-cut-and-paste.c (use_pictograms): use get_magic_smileys.
	(check_magic_link): use get_magic_links.

	* htmlengine-edit.c: use get_inline_spelling.

	* htmlclueflow.c: use get_inline_spelling.

	* gtkhtml.c (gtk_html_set_iframe_parent): use parents
	animate_setting.

        * htmlimage.c: add html_image_factory_get/set_animate and
	html_image_factory_start_animations.
	
        * htmlimage.h: add prototypes.	

	* gtkhtml.c: add gtk_html_get/set_animate.
	
	* gtkhtml.h: add prototypes.
	
	* htmlimage.c (draw_plain): fix the text position, add
	highlighting.

2003-05-19  Larry Ewing  <lewing@ximian.com>

	* gtkhtml-enums.h: make the flags actually be flags.

2003-05-18  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (parse_iframe): fix the margin calculations.

	* htmlframe.c: remove e_scroll_frame ifdef, set scrolled window
	frame type.

	* htmliframe.c: remove e_scroll_frame ifdef, set scrolled window
	frame type.

2003-05-19  Radek Doulik  <rodo@ximian.com>

	* htmlengine.c (html_engine_update_event): set need_update flag
	when not realized
	(html_engine_realize): schedule update if need_update is TRUE
	(html_engine_get_language): make sure return value is non-NULL

2003-05-19  Larry Ewing  <lewing@ximian.com>

	* htmlurl.c: fix some of the url code to make testgtkhtml happier.

2003-05-16  Radek Doulik  <rodo@ximian.com>

	* htmlprinter.c (printer_get_page_width): don't convert value,
	it's not needed
	(printer_get_page_height): use gnome_print_config_get_page_size
	instead of deprecated gnome_print_job_get_page_size_from_config
	(BTW, the gnome_print_config_get_page_size calls this deprecated
	function, funny :)

	* testgtkhtml.c (print_preview_cb): as below
	(printer_get_page_width): ditto
	after discussion with danw I made margins be fixed value (.5")

	* htmlprinter.c (draw_text): descender is negative value in
	gnome2, code updated
	(calc_text_size): ditto
	(calc_text_size_bytes): ditto

	* htmlengine-print.c: remove SPACING_FACTOR - not needed and broken, 

	* htmlprinter.c (TEMP_MARGIN): increase margins a little bit (.5")
	and make them fixed size instead of percentage of width

2003-05-16  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (add_bindings): as below

	* keybindingsrc.emacs: don't use ISO_Left_Tab, Shift Tab is mapped
	to it

2003-05-13  Larry Ewing  <lewing@ximian.com>

	* htmlfontmanager.c (html_font_manager_set_default): clear both
	fonts if fixed font description changes so that if the fixed font
	changes but the variable does not the plain painter will still
	pick up the change.  See bug #41751.

2003-05-08  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (key_press_event): workaround about Shift-TAB
	problem. gtk activates TAB binding even for Shift-TAB. we don't
	call key_press_handler of parent class for Shift-TAB now to avoid
	TAB binding to be activated. I have sent mail to Owen meanwhile
	asking him to help with it on gtk side.

2003-05-07  Larry Ewing  <lewing@ximian.com>

	* gtkhtml.c (button_press_event): pass event->time to
	gdk_pointer_grab instead of 0.
	(button_release_event): pass event->time instead of 0.

2003-05-06  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (drag_data_received): call move_before_paste only
	before first paste
	(drag_data_received): call gtk_drag_finish everytime with success
	set appropriately
	(drag_data_received): fix the len parameter in call to
	html_engine_paste_object

2003-05-02  Radek Doulik  <rodo@ximian.com>

	* htmlsearch.h: make start_pos and end_pos signed

	* htmlclueflow.c (search): handle containers in search, take care
	about start_pos

2003-05-02  Radek Doulik  <rodo@ximian.com>

	* htmlimage.c (html_image_factory_register): insert ip into loaded
	images table even if url == "" so we keep track of all ip's. this
	fixes the crash when inserting html src with image with "" url and
	also doesn't leak ip's

	* gtkhtml.c (gtk_html_set_default_content_type): remove unused
	variable

2003-05-01  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (html_engine_thaw_idle_flush): actually remove the
	idle function when we thaw.

2003-05-01  Radek Doulik  <rodo@ximian.com>

	* htmltext.c (calc_preferred_width): fix width calculation for
	TABS, it fixes the min_width calculation of PRE flows as PRE flows
	calculate theirs min width from child preffered width

2003-04-30  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (html_engine_draw_real): clip the bounds with
	html_engine_intersection instead of the crop_iframe_to_parent.
	(html_engine_intersection): reorder the logic.

	* htmlobject.c (html_object_calc_abs_position): always take any
	frame offset into account when calculating the position of the
	object.

	* htmltext.c: remove extra space at beginning of file.

2003-04-29  Larry Ewing  <lewing@ximian.com>

	* htmltext.c (calc_word_width): walk the string in our own loop
	and use the offsets directly rather than calulating them from the
	pointer.
	(min_word_width_calc_tabs): only calc the tabs in the segment if
	we find a tab in the segment while walking it. 
	(html_text_magic_link): remove broken logic that was running the
	regex over and over and over.

	* htmltextslave.c (get_offset_for_pointer): don't do a linear
	search for the cursor position, measuring the strings is too
	expensive.
	(get_words_width): replace strchr with our own walking loops so
	that we don't have to walk the string twice.
	(get_offset_for_bounded_width): ditto.
	(hts_fit_line): same as above, and make the logic a little easier
	to read.
	(draw_highlighted): only do the measurments and drawing that is
	actually on screen and within this slave.

2003-04-23  Radek Doulik  <rodo@ximian.com>
	
	* htmltextslave.c (get_words_width): fix len calculation, we are
	incrementing the space now so we have to substract 1 here

	* htmlclueflow.c (layout_line): set current object y to let object
	know on what line it lives

2003-04-21  Radek Doulik  <rodo@ximian.com>

	* htmlclueflow.c (html_clueflow_get_line_offset): go forward
	instead of backward from head of line when calculating line offset

	* htmltext.c (html_text_text_line_length): modify line_offset only
	if != -1

2003-04-18  Radek Doulik  <rodo@ximian.com>
 
	* htmltext.c (min_word_width): renamed to express the
	functionality better
	(min_word_width_calc_tabs): renamed as well, fix the
	calculation. the minimal word width is the width of word idx (with
	optional non-breaking prefix) on begin of line

	* htmltextslave.c (get_words_width): locate the right word, do not
	stay at first space
	(get_words_width): don't substract tabs, they are already included
	in len and width has already one space width for each of them

2003-04-24  Radek Doulik  <rodo@ximian.com>

	* htmlengine.c (html_engine_freeze): call gtk_html_im_reset when
	freezing (count == 0)

	* htmlcursor.c: call gtk_html_im_reset whenever we move cursor

	* gtkhtml.c (gtk_html_im_reset): new function, resets im context
	if need_im_reset is TRUE
	(key_press_event): call im context first, set need_im_reset

2003-04-23  Larry Ewing  <lewing@ximian.com>

	* htmlanchor.c (check_point): override the default check_point
	with one that always returns NULL.

2003-04-16  Larry Ewing  <lewing@ximian.com>

	* htmlembedded.c (copy): comment out debug wanring.

	* htmltextarea.c (copy): comment out debug warning.

	* htmlselect.c (copy): comment out debug warning.

	* htmltextinput.c (copy): comment out debug warning.

	* htmlimage.c (html_image_pointer_queue_animation): only queue the
	animation if one hasn't already been queued.
	(html_image_pointer_run_animation): clear the timeout source.

	* htmlstyle.c (html_style_free): actually free the style.

	* gtkhtml-properties.c (gtk_html_class_properties_new): don't dup
	the name string, and don't alloc an uneeded font description.

	* gtkhtml.c (style_set): free the name string, and don't alloc an
	uneeded font description.
	(gtk_html_set_default_content_type): use g_ascii_strdown
	correctly.

2003-04-15  Larry Ewing  <lewing@ximian.com>

	* htmldrawqueue.c (clear): clip the cleared area to the visible
	area.

	* htmliframe.c (calc_size): let the engine know what size we
	decided it was (for later clipping).

	* htmlengine.c (html_engine_intersection): clip to the top iframe
	always.
	(html_engine_get_viewport): simple helper function.

2003-04-14  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (thaw_idle): fix the area passed to the cleanup
	function.
	(clear_changed_area): pass the correct extents to
	::draw_background.
	
	* htmldrawqueue.c (clear): pass the correct extents to
	draw_background.
	(draw_obj): the same.

2003-04-14  Radek Doulik  <rodo@ximian.com>

	* htmlengine.c (html_engine_stream_end): set newPage to false to
	avoid the cursor jumping to home
	(html_engine_set_editable): ditto

2003-04-09  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (html_engine_finalize): remove any pending
	redraw_idle functions;

	* gtkhtml.c (client_notify_widget): remove spell color cruft.

	* gtkhtml-properties.c: remove unused members.

	* gtkhtml-properties.h: remove usless members.

2003-04-09  Radek Doulik  <rodo@ximian.com>

	* htmlengine.c (html_engine_init): set language to NULL
	(html_engine_get_language): new method

	* gtkhtml.c (command): use html_engine_get_language
	(gtk_html_api_set_language): ditto

	* gtkhtml-properties.c (gtk_html_class_properties_new): use
	e_iconv_locale_language as default language

2003-04-09  Larry Ewing  <lewing@ximian.com>

	* gtkhtml.c (style_set): move font setting logic to here, don't
	use the properties setting (styles are per instance).
	(client_notify_widget): remove all the color and font setting
	logic to use per setting styles.
	(gtk_html_set_default_background): removed old broken function.

	* gtkhtml.h: remove prototype of set_default_background.
	
2003-04-08  Larry Ewing  <lewing@ximian.com>

	* htmlgdkpainter.c (alloc_font): don't force monospace fonts to be
	"Monospace" family, this ruins style settings for fixed_font_name.

	* htmlcolorset.c (html_colorset_set_style): make the default
	parsing logic slightly more robust.

2003-04-08  Radek Doulik  <rodo@ximian.com>

	* htmlclueflow.c (set_painter): new method, reset indent_width

	* gtkhtml.c (get_line_height): calc the line height again, was
	disabled during porting

2003-04-08  Larry Ewing  <lewing@ximian.com>

	* gtkhtml-propmanager.h: fix object and class types.

	* gtkhtml-properties.c (gtk_html_class_properties_new): NULL
	protect the widget parameter.

	* gtkhtml.c (style_set): rework the logic to read the style
	property.

	* htmlengine-save.c (html_engine_save_string_append_nonbsp): add
	const.

2003-04-08  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (add_bindings): removed C-space, put it into emacs
	bindings so that Chinese SCIM could catch C-space

	* htmltext.c (get_glyphs): shape only when item->length > 0
	(html_text_op_cut_helper): destroy items when cutting part of text

2003-04-08  Larry Ewing  <lewing@ximian.com>

	* htmlgdkpainter.c (alloc_font): make sure that we end up with a
	valid font description. Fixes #40898.

	* htmlimage.c (html_image_factory_get_missing): helper function to
	load the gtkstock missing image item.
	(draw): add logic to draw missing image icon.

2003-04-07  Larry Ewing  <lewing@ximian.com>

	* gtkhtml.c (style_set): pass the widget instead of the style.

	* htmlcolorset.h: fixup prototype.

	* htmlcolorset.c (html_colorset_set_style): retrieve the color of
	the links and spell error from the style properties.h

2003-04-07  Radek Doulik  <rodo@ximian.com>

	* keybindingsrc.emacs: change Home/End bindings

2003-04-07  Larry Ewing  <lewing@ximian.com>

	* htmltext.c (append_selection_string): use the new helper, this
	is the chosen solution to 37172.
	
	* htmlclueflow.c (save_plain): use the new helper function.

	* htmlengine-save.c (html_engine_save_string_append_nonbsp): add
	helper function.

2003-04-07  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-cut-and-paste.c (delete_object): test for active
	selection after selection update

2003-04-04  Larry Ewing  <lewing@ximian.com>

	* htmlimage.c (html_image_factory_unregister): make sure we always
	clear the factory when we are removed from it, ad guard against
	double removal.  Fixes Ximian #40627

2003-04-03  Larry Ewing  <lewing@ximian.com>

	* gtkhtml.c (selection_received): add UTF8_STRING dnd support.

	* htmlengine.c: don't try to create image inputs with no src url.

2003-04-03  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (gtk_html_set_paragraph_style): if selection is
	active, change style everytime
	(scroll_timeout_cb): don't clamp coordinates if we are already at
	the boundaries

	* htmlengine-edit-cut-and-paste.c (delete_object): update
	selection after cursor/mark move

2003-04-03  Not Zed  <NotZed@Ximian.com>

	** for bug 40450, based on patch from <philip.zhao@sun.com>

	* htmltextslave.c (html_text_slave_nb_width)
	(html_text_slave_remove_leading_space): Remove inline keyword on
	non-static methods.

	* htmlobject.c (html_object_engine_translation): change the //
	comment to a /* comment, // not supported by ansi c.
	(html_object_next_leaf, html_object_prev_leaf,
	html_object_next_cursor, html_object_prev_cursor): Remove inline
	keyword on non-static methods.

2003-04-02  Larry Ewing  <lewing@ximian.com>

	* gtkhtml-propmanager.c (gtk_html_propmanager_get_type): start
	porting to gobject.

2003-04-02  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-cut-and-paste.c (html_engine_delete): fix cursor
	position afterwards

	* gtkhtml.c (gtk_html_im_delete_surrounding_cb): fix cursor
	movement, return to original position if possible
	(key_press_event): call gtk_im_context_filter_keypress only when
	binding not handled
	(key_release_event): ditto

2003-04-02  Larry Ewing  <lewing@ximian.com>

	* htmlimage.c: be more careful about zeroing some of the timeouts.

2003-04-01  Larry Ewing  <lewing@ximian.com>

	* htmlengine-edit-cursor.c (html_engine_draw_cursor_in_area):
	update the im_context cursor location as it moves.

2003-04-01  Radek Doulik  <rodo@ximian.com>

	* htmltextslave.c (hts_fit_line): fix breaking

	* htmlclueflow.c (layout_line): don't force objects to go to next
	line once we reach right margin

	* htmltext.c (calc_min_width): fix one-word texts, update
	surrounding text objects

2003-03-31  Radek Doulik  <rodo@ximian.com>

	* htmltext.c (word_width): fixed for tabs

	* htmltextslave.c (get_words_width): fixed for tabs

	* gtkhtml.c: load emacs keybindings, use them if gconf value of
	/desktop/gnome/interface/gtk_key_theme is Emacs

	* Makefile.am (keybindings_DATA): install keybindings.emacs again

2003-03-27  Larry Ewing  <lewing@ximian.com>

	* Makefile.am (AM_CFLAGS): use AM_CFLAGS instead of CFLAGS
	reformat includes.

2003-03-27  Radek Doulik  <rodo@ximian.com>

	* htmlengine.c (html_engine_get_spell_word): fix move to the
	beginning of a word

	* htmlclueflow.c (end_of_word): fix the logic for citation so
	couldn't is one word and not two

2003-03-26  Radek Doulik  <rodo@ximian.com>

	* htmltextslave.c (draw_spell_errors): as below

	* htmltext.c (html_text_text_line_length): take care about line
	offset -1 (notabs)

2003-03-25  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.h (struct _GtkHTMLEditorAPI): added language argument to
	add_to_personal

2003-03-24  Radek Doulik  <rodo@ximian.com>

	* htmltext.c (html_text_magic_link): avoid uninitialized uc use

	* htmlengine-edit-tablecell.c (move_cell_rd): remember the removed cell

	* gtkhtml.c: declare get/set property inside USE_PROPS #idef block

2003-03-23  Larry Ewing  <lewing@ximian.com>

	* htmlfontmanager.c (get_font_num): make get_font_num more robust
	against invalid styles just in case.

2003-03-20  Larry Ewing  <lewing@ximian.com>

	* htmltextslave.c: remove unused variables.

	* htmltext.c: remove unused variables.

2003-03-19  Larry Ewing  <lewing@ximian.com>

	* htmliframe.c (check_point): fix the point calculation for
	iframes.

2003-03-18  Larry Ewing  <lewing@ximian.com>

	* htmlprinter.c (draw_text): add return value.

	* htmlpainter.c: add missing include.

	* htmlimage.c (html_image_pointer_run_animation): remove unused
	variables.

	* htmlgdkpainter.c (draw_spell_error): remove unsued variable, add
	a return value.

	* htmltable.h (html_table_end_table): add prototype.

	* htmlengine-edit-tablecell.c: remove debug printfs
	(move_cell_rd_undo_free): add a return type.

	* gtkhtml-properties.c (gtk_html_class_properties_new): warning
	cleanups.

	* htmlclueflow.c (calc_size): warning cleanups.

2003-03-18  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (realize): call gtk_im_context_set_client_window
	(unrealize): ditto
	(gtk_html_init): connect new im callbacks

	* Makefile.am: removed gtkhtml-im.[ch]

	* gtkhtml.c (key_press_event): use im context
	(key_release_event): handle this event
	(focus_in_event): use im context
	(focus_out_event): ditto

2003-03-17  Radek Doulik  <rodo@ximian.com>

	* htmlclueflow.c (html_clueflow_get_line_offset): pass line_offset
	to html_text_text_line_length

	* htmltextslave.c (html_get_glyphs_non_tab): make this function
	public

	* htmlgdkpainter.c
	(html_gdk_painter_text_itemize_and_prepare_glyphs): don't count
	tab width

2003-03-14  Radek Doulik  <rodo@ximian.com>

	* htmlgdkpainter.c (draw_spell_error): use shift_items

	* htmlplainpainter.c (draw_text): use shift_items

2003-03-13  Larry Ewing  <lewing@ximian.com>

	* htmliframe.c (check_point): remove incorrect addition of margins
	in point calculation.

2003-03-12  Radek Doulik  <rodo@ximian.com>

	* htmltext.c (html_text_text_line_length): fix line_offset
	calculation

	* htmltextslave.c (html_text_slave_get_line_offset): removed
	line_offset parameter, updated all callers

	* htmlclueflow.c (html_clueflow_get_line_offset): don't allow head
	to be set to NULL

	* htmltextslave.c (calc_width): fix width calculation for tabs

2003-03-11  Radek Doulik  <rodo@ximian.com>

	* htmltextslave.c (get_glyphs_base_text): return glyphs

	* htmlprinter.c (draw_text): fix print_y position

2003-03-10  Larry Ewing  <lewing@ximian.com>

	* htmlprinter.c (print_pixbuf): add a helper function to print
	pixbufs now that gnome print no longer has a print_pixbuf call.

2003-03-09  Larry Ewing  <lewing@ximian.com>

	* htmltextslave.c (get_glyphs_part): fix the check for itmems.

2003-03-08  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (html_engine_timer_event): flush the update timers
	before removing them.

2003-03-07  Radek Doulik  <rodo@ximian.com>

	* Makefile.am (CFLAGS): add -@GTKHTML_RELEASE@ to ICONDIR

2003-03-05  Larry Ewing  <lewing@ximian.com>

	* Makefile.am (uninstall-hook): add unistall-hook to remove
	renamed .pc file.

2003-03-04  Larry Ewing  <lewing@ximian.com>

	* htmltext.c (get_glyphs): use item->offset rather than adding
	lengths to find the current position.

2003-03-04  Radek Doulik  <rodo@ximian.com>

	* htmlengine.c (html_engine_make_cursor_visible): let's keep
	cursor inside borders

	* gtkhtml.c (command): make SCROLL and FOCUS commands work just
	for non editable mode, let SCROLL commands set binding_handled so
	key are not propagated to parent's scrollbars

	* htmltext.c (html_text_request_word_width): destroy cached items
	when HTML_CHANGE_WORD_WIDTH

2003-03-03  Radek Doulik  <rodo@ximian.com>

	* htmltextslave.c (draw_spell_errors): use items cache
	(draw_normal): use get_glyphs_part if posStart > 0

	* htmlgdkpainter.c (draw_spell_error): fixed spell errors drawing

	* htmltext.c (text_len): change passed string instead of
	text->text, update all callers, fixes #38964

2003-03-02  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (html_engine_thaw_idle_flush): change idle_reset to
	idle_flush so that we always thaw the changes.

2003-02-28  Larry Ewing  <lewing@ximian.com>

	* htmlimage.c (html_image_resolve_image_url): fix the GValue usage.

	* htmlclueflow.c (copy): actually commit the copy fix.

	* htmlengine.c: turn off debug log that accidenetally got turned on.

	* gtkhtml.c (gtk_html_api_set_language): change assertion to check.

2003-02-27  Larry Ewing  <lewing@ximian.com>

	* htmlclueflow.c (end_of_word): make sure we check for the end of
	the buffer.

	* htmltokenizer.c (add_unichar_validated): new helper function to
	checkvalidity of unichar before adding it to the stream.
	(in_entity): use add_unichar_validated here to make sure that
	invalid entity references don't corrupt the utf8 stream.

2003-02-27  Radek Doulik  <rodo@ximian.com>

	* htmltext.c (text_len): replace invalid utf8 with [?]

	* htmltokenizer.c (in_entity): extend the max length of number to
	10 digits (0xffffffff = 4294967295)

	* htmltext.c (forward_get_nb_width): reverse prev/next to avoid
	infinite loops in broken html documents (where empty text objects
	are created)

2003-02-25  Larry Ewing  <lewing@ximian.com>

	* htmlpainter.c: remove h_utf8*

	* htmltext.c: same.

	* htmltextslave.c: same.

2003-02-24  Larry Ewing  <lewing@ximian.com>

	* htmlgdkpainter.c (draw_pixmap): remove helper function.

	* gtkhtml.c: add a couple more properties.

	* htmlclueflow.c (relayout): add engine offsets to the draw call.

2003-02-24  Radek Doulik  <rodo@ximian.com>

	* gtkhtml-properties.c (gtk_html_class_properties_new): don't free
	fixed_name, it's stored in p

	* gtkhtml.c: don't use keybindings_theme, hardcode keybindings as
	gtk does (they could be changed in gtkrc file)

	* gtkhtml-properties.c: removed keybindings_theme

	* Makefile.am: removed keybindingsrc.* files parts

2003-02-23  Larry Ewing  <lewing@ximian.com>

	* gtkhtml.c: stub in some gobject property code.

	* gtkhtml-properties.c (gtk_html_class_properties_new): read the
	settings from from the style.

	* gtkhtml.c (gtk_html_class_init): add style properties for colors
	and fixed font.

2003-02-21  Larry Ewing  <lewing@ximian.com>

	* htmlimage.c: refactor animation drawing, remove broken
	HTMLImageAnimation structure, fix drawing while scrolling.
	
	* gtkhtml.c (gtk_html_begin_full): pass priv->content_type if the
	arg is NULL.

2003-02-20  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c: correct the drawing region for the offsets.

2003-02-20  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (set_fonts_idle): don't set font's in iframe, parent
	gtkhtml takes care of it

	* htmltext.c (html_utf8_strnchr): new helper function
	(html_text_text_line_length): use own html_utf8_strnchr, this
	increases speed really dramatically ;-)

	* gtkhtml.c (style_set): don't set fonts in idle time, but right
	now, this avoids recalculating whole document (after content is
	loaded)

	* htmltext.c (html_text_text_line_length): modify line_offset
	parameter
	(translated_len): new helper function
	(calc_word_width): correct offsets fot tabs

	* htmlpainter.c (html_painter_translate_text): dereference
	line_offset

	* htmltext.c (get_glyphs): translate special characters

2003-02-19  Radek Doulik  <rodo@ximian.com>

	* htmlplainpainter.c (draw_text): prepare temporary items and
	glyphs when needed

	* htmltextslave.c (get_glyphs_part): translate text before shaping
	(get_glyphs): ditto

	* htmlpainter.c (html_painter_translate_text): new function,
	exports painter text translation
	(calc_translated_text_bytes): return bytes length instead of delta
	(html_painter_calc_text_size): use bytes return value from
	calc_translated_text_bytes, this saves us one walk thru the whole
	text, removed unnecessary (forgotten?) second call to
	calc_translated_text_bytes
	(html_painter_draw_text): use bytes instead of delta as above

2003-02-18  Radek Doulik  <rodo@ximian.com>

	* htmltext.c (calc_word_width): use cached items only for non
	empty texts to make pango shape happy

	* htmltextslave.c (calc_width): use cached items and glyphs

	* htmltext.c (calc_word_width): use cached items and call shape
	just once
	(html_text_get_items): return items just for gdk and plain painter
	so printing works right again

	* htmltextslave.c (get_items): use html_text_get_items
	(draw_highlighted): use cached items and glyphs

	* htmlengine.c (parse_i): don't pass possibly uninitialized memory
	to tokenizer

2003-02-07  Larry Ewing  <lewing@ximian.com>

	* htmlclueflow.c (draw_quotes): move the plain painter check out
	of the loop.

2003-02-05  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (parse_f): no pending para for forms.

	* htmlclueflow.c: use new painter methods that cache the indent
	widths.
	
	* htmlfontmanager.h: add cache for indent memebers.

	* htmlfontmanger.c: add cache members to html_font_new.

	* htmlpainter.h: add accessors for indent caches.

	* htmlpainter.c: add accessors for indent caches.

	* htmlgdkpainter.c: calc widths of block indents.

	* htmlprinter.c: calc widths of block indents.
	
2003-02-04  Larry Ewing  <lewing@ximian.com>

	* htmlclueflow.c (get_indent): cache the indent level since this
	gets called a lot.

	* htmlclueflow.h: add indent_width member.

2003-01-29  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-cursor.c (html_engine_draw_cursor_in_area):
	updated for changed coordinates

2003-01-28  Radek Doulik  <rodo@ximian.com>

	* gtkhtml-properties.c (gtk_html_class_properties_new): get
	default print font faces from style

	* htmlprinter.c (alloc_font): remove workaround for old gimp print

2003-01-22  Radek Doulik  <rodo@ximian.com>

	* testgtkhtml.c (print_preview_cb): close print job before
	creating preview

2003-01-21  Larry Ewing  <lewing@ximian.com>

	* htmltextslave.c (hts_fit_line): make sure we never call strchr
	on a NULL string.  This tends to happen if two consecutive spaces
	enter the token stream.

2003-01-18  Larry Ewing  <lewing@ximian.com>

	* htmlselect.c (html_select_set_text): make sure we have a longest
	string.

2003-01-17  Larry Ewing  <lewing@ximian.com>

	* gtkhtml.c (style_set): get the new size when the style changes.

	* gtkhtml-properties.c: disable gconf for the font settings use
	the style values instead.

2003-01-16  Larry Ewing  <lewing@ximian.com>

	* htmltablecell.c (draw_background_helper): don't poke into the
	table for the background, tables draw their own background now.

	* htmltable.c (draw_background_helper): draw table backgrounds the
	way mozilla does.

	* gtkhtml.c (gtk_html_set_magnification): only try to change the
	clue if it exists.

2003-01-15  Larry Ewing  <lewing@ximian.com>

	* htmlgdkpainter.c (html_gdk_painter_new): initialize the style.
	(alloc_font): use the style as a fallback, use
	pango_font_description_from_string to get the font description.

	* gtkhtml.c (style_set): update the font when the style changes.

	* gtkhtml-properties.c (gtk_html_class_properties_new): use the
	style font description.

2003-01-15  Radek Doulik  <rodo@ximian.com>

	* htmlengine.c (html_engine_draw_real): set Engine::expose
	(html_engine_add_expose): added expose parameter, use struct
	HTMLEngineExpose to store expose parameter as well

	* htmlembedded.c (draw): queue widget draw only when we aren't
	drawing on expose event request because it's already handled in
	gtk_container code and was causing infinite loops

	* gtkhtml.c (expose): use html_engine_expose

	* htmlengine.c (html_engine_expose): new function, used from
	expose event handler

2003-01-14  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (key_press_event): paste text only when event->length > 0

2003-01-13  Larry Ewing  <lewing@ximian.com>

	* htmlengine-edit-table.c (html_engine_goto_table): pass arguments
	not prototypes.

2002-12-16  Larry Ewing  <lewing@ximian.com>

	* htmlshape.c: fix parsing of negative numbers.

	* htmlstyle.h: add prototypes. 

	* htmlstyle.c (html_style_add_background_image): add background
	iumage property.
	(html_style_add_background_color): add background color property.

2002-12-14  Larry Ewing  <lewing@ximian.com>

	* htmlimage.c (html_image_factory_register): make sure we add an
	aimation to the image.

2002-12-13  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-cursor.c (draw_cursor_rectangle): fix color
	allocation

2002-12-10  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-tablecell.c (expand_rspan): move remaining cells
	(expand_cspan): ditto
	(move_cell_rd): helper function, move cell right/down

2002-12-06  Larry Ewing  <lewing@ximian.com>

	* htmlengine-edit-table.h (html_table_insert_column): fix the insert
	row/column prototypes so that gtkhtml builds again.

2002-12-06  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-table.c (html_table_insert_column): make it work
	with rspan/cspan
	(html_table_insert_row): ditto

2002-12-05  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (gtk_html_editor_event_command): init GValue before
	use

	* htmlimage.c (html_image_resolve_image_url): init GValue before
	use

	* htmlengine-edit-tablecell.c (html_engine_set_cspan): new method
	(html_engine_set_rspan): ditto, TODO
	(expand_cspan): ditto, not finished yet
	(collapse_cspan): ditto, TODO

	* htmlengine-edit-table.c (html_table_insert_column): renamed, now
	is public
	(html_table_insert_row): ditto

	* htmltablecell.c (html_table_cell_is_empty): new method, moved
	from htmltable.c, it's now public

	* htmlengine-edit-cut-and-paste.c (html_engine_delete):
	reimplemented, make it work better with tables

2002-12-02  Radek Doulik  <rodo@ximian.com>

	* htmlimage.c (move_image_pointers): emit url requested signal, so
	moved image pointers are loaded

2002-11-27  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (button_press_event): return TRUE so we could
	g_connect_after in control

2002-11-26  Larry Ewing  <lewing@ximian.com>

	* htmltablecell.c (draw_background_helper): don't try to get a
	pixbuf from a NULL animation.

	* gtkhtml.c (gtk_html_insert_html_generic): re-add the form
	pasting fix tht seems to have been lost somewhere..

2002-11-26  Not Zed  <NotZed@Ximian.com>

	* htmlembedded.c (draw): Dont do a queue_redraw if we're ever
	asked to draw.  Hack-fix to stop evolution-mail hanging so often.
	Added FIXME about it.

2002-11-21  Radek Doulik  <rodo@ximian.com>

	* htmlplainpainter.c (draw_text): use lower level pango iface

	* htmlgdkpainter.c
	(html_gdk_painter_text_itemize_and_prepare_glyphs): exported

	* htmltextslave.c (get_words_width): make sure we don't read
	word_width [-1]

	* htmlclueflow.c (object_nb_width): fixed typo, use
	html_text_slave_get_nb_width instead of html_text_slave_nb_width

2002-11-20  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (parse_i): parse style args.

	* htmlstyle.c: add missing includes.

	* htmlstyle.h: add missing prototypes.

	* htmllinktext.c (get_font_style): stop forcing an underline.

	* htmlengine.c: change push_span to push_element. Make current_*
	skip elements with no style set.  Make elements that restore
	alignment use the e->divAlign not pAlign and clear pAlign whenever
	we push a block.
	(parse_a): parse style attribute on a element.
	(parse_b): parse style attribute on b element.
	(parse_h): pop ID_HEADER blocks before starting a new header.
	
	* htmlstyle.c: added.  Moves the style setting logic into a
	separate file. Add demonstration parser for style attributes (a
	real parser will come later).

	* htmlstyle.h: added.

	* Makefile.am: add htmlstyle.[ch]

2002-11-19  Not Zed  <NotZed@Ximian.com>

	* htmlclosures.list: BOOL:POINTER -> BOOL:OBJECT
	removed VOID:POINTER,POINTER
	VOID:POINTER,POINTER,POINTER -> VOID:STRING,STRING,STRING

	* htmlengine.c (html_engine_class_init): change
	marshal_BOOL_POINTER -> BOOL__OBJECT for object_requested signal.
	(html_engine_class_init): submit -> STRING_STRING_STRING.

	* gtkhtml.c (gtk_html_class_init): change marshal_BOOL__POINTER ->
	BOOL__OBJECT for object_requested.   Also changed marshaller for
	iframe_created signal to be VOID__OBJECT.
	(gtk_html_class_init): url_requested -> STRING__POINTER.
	(gtk_html_class_init): submit -> STRING_STRING_STRING

2002-11-18  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (parse_body): pop things off the body stack in the
	proper order.
	(check_prev): make sure we make a new linktext if the url is
	different.

2002-11-18  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c: Merge the various text styles into a span style
	and fix the current_* functions to pull the values from there.
	This fixes some obscure style bugs and cleans up the code a lot.

	* htmlenging.h: remove a bunch of unused stacks and variables.

2002-11-17  Chris Toshok  <toshok@ximian.com>

	* gtkhtml.c (gtk_html_set_iframe_parent): remove extra 0 from
	g_signal_emit.

2002-11-15  Radek Doulik  <rodo@ximian.com>

	* Makefile.am: generate htmlmarshal.[ch] from htmlclosures.list by
	glib-genmarshal

	* htmlclosures.list: new file

2002-11-14  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (gtk_html_command): fix GEnumClass retrieval

2002-11-13  Larry Ewing  <lewing@ximian.com>

	* htmlimage.c (html_image_factory_register): small cleanups for
	new stream logic.

	* gtkhtml-enums.h: add begin types enum.

	* gtkhtml.h: begine to move some items into a group that we can
	hopefully remove.

	* gtkhtml.c (gtk_html_begin_full): add the start of a replacement
	for gtk_html_begin_content.

2002-11-13  Not Zed  <NotZed@Ximian.com>

	* htmltokenizer.h: Use g object cast checks, not gtk object ones.

2002-11-11  Larry Ewing  <lewing@ximian.com>

	* gtkhtml.c (idle_handler): flush the draw queue before we scroll
	to reduce drawing artifacts

2002-11-11  Radek Doulik  <rodo@ximian.com>

	* htmlgdkpainter.c (draw_text): fixed
	GTK_HTML_FONT_STYLE_STRIKEOUT

2002-11-07  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (parse_o): free the value.

	* htmlselect.c (html_select_set_text): free the placeholder before
	we overwrite it.

	* htmlgdkpainter.c (draw_text): free the glyphs and items we
	create.

2002-11-07  Radek Doulik  <rodo@ximian.com>

	* htmltext.c (calc_word_width): calc ascent/descent for empty
	texts

2002-11-07  Larry Ewing  <lewing@ximian.com>

	* htmlselect.c (html_select_set_text): clear the requisition size
	whenever we add a string.

	* htmltextinput.c: fix the requested width calculation.

2002-11-06  Radek Doulik  <rodo@ximian.com>

	* htmlgdkpainter.c: use lower level pango iface

	* libgtkhtml.pc.in (gtkhtml_datadir): added gtkhtml_datadir
	(NotZed)

2002-11-05  Larry Ewing  <lewing@ximian.com>

	* gtkhtml.c (selection_received): pad citations with a <br> to
	avoid agressive merging.

	* htmlobject.c: remove html_object_calc_intersection and replace
	with html_object_intersect that uses GdkRectangle.

	* htmlobject.h: fix prototypes.
	
	* htmlimage.c: replace ArtIRect with GdkRectangle.

	* htmltable.c: replace ArtIRect with GdkRectangle.

	* htmltablecell.c: replace ArtIRect with GdkRectangle.

	* htmltextslave.c: replace ArtIRect with GdkRectangle.

	* htmlframe.c: replace ArtIRect with GdkRectangle.

	* htmlframeset.c: replace ArtIRect with GdkRectangle.

	* htmliframe.c: replace ArtIRect with GdkRectangle.

	* htmlplainpainter.c: replace ArtIRect with GdkRectangle.

2002-11-05  Larry Ewing  <lewing@ximian.com>

	* htmlimage.c (draw): protect the draw function from images that
	are not loaded.

	* htmlclueflow.c (draw_quotes): fix printing.

	* htmlgdkpainter.c (draw_background): use GdkRectangles instead of
	ArtIRects, support full alpha on table and body bg images.
	(draw_pixmap): use GdkRectangles.

	* htmlclueflow.c (draw_quotes): use GdkRectangles.

2002-11-05  Radek Doulik  <rodo@ximian.com>

	* htmlframe.c (frame_submit): use g_signal_emit_by_name
	(frame_object_requested): ditto
	(calc_size): use set_size_request
	(html_frame_set_size): ditto
	(html_frame_init): ditto

	* htmliframe.c (iframe_object_requested): use
	g_signal_emit_by_name
	(calc_size): use set_size_request
	(html_iframe_init): ditto

	* htmltextinput.c (html_text_input_key_pressed): use
	g_signal_stop_emission_by_name
	(html_text_input_init): use set_size_request

	* htmltextarea.c (html_textarea_init): use set_size_request

	* htmlselect.c (html_select_init): use set_size_request
	(html_select_init): ditto
	(html_select_init): use gtk_editable_set_editable
	(html_select_set_text): use set_size_request
	(html_select_set_text): ditto

	* htmlprinter.c (draw_embedded): use g_signal_emit_by_name
	(ref_font): use g_object_ref
	(unref_font): use g_object_unref
	(html_printer_new): use g_object_ref

	* htmlobject.c (html_object_set_data): don't use
	g_quark_from_string, it's already used in g_datalist_set_data_full
	macro

	* htmlfontmanager.c (manager_alloc_font): removed
	get_name_from_face, simplified

	* htmlgdkpainter.c (draw_embedded): use g_signal_emit_by_name

	* htmlengine.c (update_embedded): use g_object_get_data

	* htmlengine-print.c (print_with_header_footer): use g_object_ref

	* gtkhtml-embedded.c (gtk_html_embedded_new): use set_size_request
	instead of deprecated set_usize
	(gtk_html_embedded_changed): use g_signal_emit
	(gtk_html_embedded_new): use g_object_new

	* testgtkhtml.c: ported from 1.2 version

	* Makefile.am: reenabled testgtkhtml

2002-11-04  Larry Ewing  <lewing@ximian.com>

	* htmlclueflow.c (draw_item): fix the x position of the bullet.

2002-10-10  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-cut-and-paste.c (check_flows): set style just
	when needed (beginning flow will end empty so it should get style
	from last one)

	* htmlclueflow.c (op_cut): update item numbers only on cut
	boundaries
	(merge): removed style copying as it is no more needed

	* htmlengine-edit-clueflowstyle.c (undo_or_redo): set style before
	item_type so item_numbers will be updated right

2002-10-08  Radek Doulik  <rodo@ximian.com>

	* htmlengine.c (parse_l): set flow item color

	* htmlclueflow.c (destroy): unref color
	(html_clueflow_init): set item_color to NULL
	(html_clueflow_set_item_color): new method for setting item_color
	(draw_item): use item color
	(html_clueflow_style_equals): new method compares two flows,
	returns TRUE if they have the same style

	* htmlclueflow.h: added item_color

	* htmlgdkpainter.c (font_name_substitute_attr): removed asserts,
	could return NULL, name could be NULL as well
	(e_font_from_face): handle NULL from substitute

	* htmlengine-edit.c (html_engine_indent_paragraph): renamed, allow
	indentation of non PRE paragraphs as well
	(go_to_begin_of_para): take care of table boundaries
	(html_engine_indent_paragraph): ditto

2002-09-19  Radek Doulik  <rodo@ximian.com>

	* htmlclueflow.c (get_pre_padding): don't add pre padding for
	non-items flows following items with the same level
	(write_flow_tag): add <BR> for non-item flows following items with
	the same level

2002-11-03  Larry Ewing  <lewing@ximian.com>

	* htmlgdkpainter.c (draw_pixmap): fix coloring logic.
	(create_temporary_pixbuf): clear the pixbuf before we use it.

	* htmlimage.c (html_image_factory_types): add disabled code to use
	gtk-pixbuf features in gtk+-2.2

	* htmltext.c (append_selection_string): use g_string_function that
	exists now.

	* htmlgdkpainter.c (draw_pixmap): remove a bunch of code now that
	gdk can do real alpha blending.
	(html_gdk_painter_realize): use html_painter_alloc_color instead
	of doing ourselves.
	(alloc_color): get the color from the gdkrgb color cube, don't try
	to alloc it ourselves.
	(free_color): don't need to do anything here now.  The color code
	can be vastly simplified now with the new interfaces but we should
	do a step by step refactoring and this is the first step.

	* htmlimage.c: move the timeout into the image_pointer so that we
	only queue one per url, refactor start, stop and timeout functions
	for the new logic.
	(html_image_pointer_run_animation): don't try to draw images
	without animations (happens in c&p images).

	* htmlimage.h: move animation timeout from HTMLImage to
	HTMLImagePointer.

2002-11-03  Larry Ewing  <lewing@ximian.com>

	* htmlimage.h: remove pixbuf argument from HTMLImagePointer, we
	use animations for holding everything now.  Add an iter structure.

	* htmlimage.c: add initial support for animations back into html
	image.

	* htmltablecell.c (draw_background_helper): use animation
	structure now.

	* htmlengine.c (html_engine_draw_background): use animation
	structure now.

2002-11-02  Larry Ewing  <lewing@ximian.com>

	* gtkhtml.c (ucs2_order): fix the names of UCS-2BE and UCS-2LE,
	and captialize the rest for fun.
	(selection_get): use the new gtk functions to convert strings
	for selections and clean up logic.
	(selection_received): use the new gtk functions to handle charset
	conversion and clean up logic.
	(scroll_timeout_cb): add the offsets.
	(motion_notify_event): remove the offsets.
	(button_release_event): remove the offsets.

	* htmlfontmanager.c (get_name_from_face): disable all the logic
	here.  Rodo, can you look at this, is it still needed?

	* gtkhtml.c (selection_received): protect ouselves from failed
	conversions.

2002-10-28  Larry Ewing  <lewing@ximian.com>

	* htmlselect.c (html_select_set_text): only measure the string if
	there is one.

	* htmliframe.c (check_page_split): Initialize the engine from the
	the proper pointer.

	* htmlfontmanager.c (html_font_manager_set_default): add header to
	silence warning.

	* htmlgdkpainter.c (find_font_with_similar_size): silence
	warnings.
	
	* htmlclueflow.c (update_line_positions): silence warning.

2002-10-27  Larry Ewing  <lewing@ximian.com>

	* htmlgdkpainter.c (e_font_from_face): use helper function to
	lookup fonts in the fontset and build a new fontset.
	(e_font_lookup_face): helper function that handles the font
	lookup.

	* htmltable.c (check_point): return with warning if we haven't had
	calc_size called yet.

2002-10-25  Larry Ewing  <lewing@ximian.com>

	* keybindingsrc.ms: remove C-s binding for strikethrough.

	* htmlclueflow.c (draw_quotes): use draw_gt_line to fill draw >s
	along the edge of the flow.  Fixes #29570.
	(draw_gt_line): helper function.

2002-10-23  Larry Ewing  <lewing@ximian.com>

	* htmlclueflow.c (need_blockquote_padding): add new helper
	function to sort out the level padding issue.

2002-10-25  Larry Ewing  <lewing@ximian.com>

	* gtkhtml.c (button_release_event): don't clear in_selection until
	we are done with it.

2002-10-18  Radek Doulik  <rodo@ximian.com>

	* htmlengine.c (parse_p): <p>, </p> create new flows here to have
	right flow attributes
	(html_engine_init): init avoid_para to FALSE so <p>abc is rendered
	right
	(html_engine_parse): ditto

2002-10-17  Radek Doulik  <rodo@ximian.com>

	* htmlengine.c: set pending_para to FALSE
	call close_flow as well
	(parse_o): use finish_flow in <ol>
	(parse_u): use finish_flow in <ul>

2002-10-16  Radek Doulik  <rodo@ximian.com>

	* htmlengine.c (parse_b): use finish_flow instead of close_flow to
	avoid unwanted empty flows

2002-10-11  Radek Doulik  <rodo@ximian.com>

	* htmlengine.c (fix_last_clueflow): renamed from
	ensure_last_clueflow, discard last flow if empty
	(parse_u): close flow and add new empty one on </ul>
	(parse_o): as above for </ol>
	(parse_body): discard last flow if empty

2002-10-16  Radek Doulik  <rodo@ximian.com>

	* htmlengine.c: (parse_body): save & restore e->pending_para and
	e->avoid_para
	(parse_c): close flow only if non empty, otherwise just set its
	halign
	(parse_f): don't set pending para on <form>, just close flow if
	non empty
	(parse_table): don't add pending paragraph on end of cells
	(form_begin): new extracted function
	(form_end): ditto
	(parse_i): if form is NULL create new default form around to at
	least render it (as mozilla does)

2002-10-04  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (gtk_html_get_paragraph_indentation): new method,
	exports engine functionality

2002-10-04  Radek Doulik  <rodo@ximian.com>

	* htmlcluev.c (draw): fixed calculation of x,y for aligned objects
	drawing

2002-10-03  Radek Doulik  <rodo@ximian.com>

	* testgtkhtml.c (goto_url): set base before loading

2002-10-07  Radek Doulik  <rodo@ximian.com>

	* htmltextslave.c (get_offset_for_pointer): fix for utf8, start on
	right beginning of slave (Larry)

	* htmltext.c (get_cursor_base): check for offset > slave->posStart
	(get_cursor_base): move to next text only if it doesn't start with
	' '
	(get_cursor): ditto

	* htmltable.c (html_table_end_table): return number of cells in
	table

	* htmlengine.c (parse_table): check if table has any cell after
	html_table_end_table

2002-10-01  Radek Doulik  <rodo@ximian.com>

	* htmltextslave.c (get_offset_for_pointer): fixed offset
	computation, use utf8 functions instead of using byte positions

2002-09-30  Radek Doulik  <rodo@ximian.com>

	* htmlprinter.c (draw_text): removed unused local variable

	* htmlengine.c (update_embedded): removed unused local variable

	* gtkhtml.c (gtk_html_insert_html_generic): check tmp formlist
	instead of html one

2002-09-24  Radek Doulik  <rodo@ximian.com>

	* htmlobject.c (move_object_cursor): continue move to next in case
	we can't find any leaf accepting cursor. this fixes cursor
	navigation in documents containing empty iframes

	* htmltextslave.c (get_offset_for_pointer): check for space to be
	!= NULL

	* htmlclueflow.c (layout_line): do not wrap in PRE paragraphs

	* gtkhtml.c (load_keybindings): removed Esc bindinding

2002-09-20  Radek Doulik  <rodo@ximian.com>

	* htmltablecell.c (save): check for self->parent

2002-09-19  Radek Doulik  <rodo@ximian.com>

	* htmlengine.c (html_engine_draw_real): crop iframes to avoid
	whole iframes drawing
	(update_embedded): crop iframe size here as well

2002-09-18  Radek Doulik  <rodo@ximian.com>

	* htmltextslave.c (calc_size): split just long words

2002-09-18  Radek Doulik  <rodo@ximian.com>

	* htmlprinter.c (draw_text): use gnome_print_show_sized

	* htmltext.c (get_tags): write opening tags for next text to
	closing tags of this one
	(get_tags): simplified and corrected <font> tag saving, it's not
	optimal in space, but at least correct

2002-09-16  Radek Doulik  <rodo@ximian.com>

	* htmlengine.c (parse_body): push/pop block here to fix
	<table><tr><td><font color=white>aaa</tr></td></table>
	(html_engine_selection_contains_link): new method
	(html_engine_selection_contains_object_type): new method

	* htmlengine-edit-cut-and-paste.c (append_flow): don't move whole
	flows, just object in them to preserve flow attributes

2002-09-13  Radek Doulik  <rodo@ximian.com>

	* htmlengine.c: reimplemented font style parsing to allow non
	nested font style tags

2002-09-12  Bastien Nocera  <hadess@hadess.net>

	* gtkhtml.c: (get_line_height): hack around use of
	html_painter_calc_ascent and html_painter_calc_descent so that we're
	able to compile it.

2002-09-12  Radek Doulik  <rodo@ximian.com>

	* htmltext.c (get_tags): don't get next/prev text objects across
	cluev boundaries
	(get_tags): fix </FONT> duplication and restoring right attributes

	* htmlengine.c (parse_a): don't push color for links
	(close_anchor): don't pop color
	(insert_text): use right default color for links

2002-09-05  Radek Doulik  <rodo@ximian.com>

	* htmliframe.c (op_copy): set iframe's clue parent

	* htmlobject.c (html_object_op_copy): added parent parameter

	* htmliframe.c (copy): copy html and clue as well, initialize
	_painter
	(destroy): unref painter just when non-NULL
	(op_copy): implemented
	(copy): don't copy content here, but in op_copy

2002-09-04  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (set_focus_child): call parent's set_focus_child
	method
	(gtk_html_insert_html_generic): delete selection first

2002-08-30  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (insert_tab_or_next_cell): paste text instead of
	inserting it

2002-08-28  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (client_notify_widget): spell check or clear spell
	checking errors on live_spell_check flag change
	(command): added scroll-bod, scroll-eod commands
	(command): allow copy in non editing mode and bind it to C-c

2002-08-27  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c: fix scroll behavior, work around layout
	page_increment = height / 2

2002-08-26  Radek Doulik  <rodo@ximian.com>

	* htmlobject.c (move_object_cursor): don't allow objects not
	capable of accepting cursor to accept it

2002-08-23  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-cut-and-paste.c (validate_tables): new function,
	inserts new line in case we end with invalid flow layout after
	delete

2002-08-22  Radek Doulik  <rodo@ximian.com>

	* htmltext.c: allow + in user name in mail addres and don't allow
	wwwblabla, ftpbla, ...

	* gtkhtml.c (drag_begin): select dragged object
	(dnd_link_set): no dnd in edit mode
	(dnd_link_unset): ditto

	* htmlengine.c (html_engine_stream_write): in case size == -1
	calculate length of buffer

2002-08-21  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (set_focus_child): test if object is not an frame
	before setting it as focus_object

2002-08-20  Radek Doulik  <rodo@ximian.com>

	* htmlprinter.c (alloc_font): scale width using new macro

	* htmlprinter.h (SCALE_GNOME_PRINT_FONT_TO_ENGINE): new macro for
	scaling font width

2002-08-19  Radek Doulik  <rodo@ximian.com>

	* htmlcluev.c (draw): fixed width and height of aligned objects
	drawing

2002-07-30  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-cut-and-paste.c (use_pictograms): don't put
	pictograms in the middle of words

2002-07-17  Radek Doulik  <rodo@ximian.com>

	* htmltext.c (get_tags): optimized output

2002-07-29  Radek Doulik  <rodo@ximian.com>

	* htmlengine.c (html_engine_focus): make sure embedded object
	widget is non NULL

2002-07-26  Radek Doulik  <rodo@ximian.com>

	* htmlobject.c (handle_object_data): don't clear class data here
	as it could break hash foreach loop
	(clear_data): clear them later here

2002-07-25  Radek Doulik  <rodo@ximian.com>

	* htmlobject.c (next_prev_cursor_object): use html_cursor_init
	(copy_data): duplicate the key
	(html_object_set_data): use _full version with g_free
	(copy_data): use _full version with g_free

	* htmlcursor.c (html_cursor_init): new function to initialize all
	cursor fields

	* htmlclueflow.c (layout_line): update height just when really needed

2002-07-24  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (insert_tab_or_next_cell): insert 4 &nbsp;'s when no
	TAB available

2002-07-18  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit.c (html_engine_set_title): emit TITLE_CHANGED
	signal

2002-07-15  Radek Doulik  <rodo@ximian.com>

	* htmlclueflow.c (layout_line): fix new line condition

2002-07-12  Radek Doulik  <rodo@ximian.com>

	* htmlengine.c (html_engine_set_class_data): return if class_name
	is NULL
	(get_class_table): ditto
	(parse_d): be more careful when class_name is NULL

2002-07-09  Radek Doulik  <rodo@ximian.com>

	* htmltable.c (divide_upto_preferred_width): fixed part
	calculation

	* htmltextslave.c (get_offset_for_pointer): fixed offset
	calculation

2002-07-08  Radek Doulik  <rodo@ximian.com>

	* htmlclueflow.c (draw_item): use first slave for postion
	calculation instead of text object, this fixes item drawing with
	new layouting

2002-07-05  Radek Doulik  <rodo@ximian.com>

	* keybindingsrc.ms: added C-backspace and C-delete for delete
	{forward,backward} word

	* htmlengine-edit-fontstyle.c (get_url_or_target_from_selection):
	removed obsolete assert

	* htmlclueflow.c (update_top_height): fixed align=top
	(end_of_word): fix citations and spell checking 'spell check' is
	no more marked as mispelled

2002-07-03  Radek Doulik  <rodo@ximian.com>

	* htmlimage.c (html_image_get_actual_width): use max_width instead
	of engine view width

2002-07-02  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (focus): disabled link navigation in editing mode

2002-06-25  Radek Doulik  <rodo@ximian.com>

	* htmltextslave.c (hts_fit_line): take care about line breaking
	here as well as we don't usually calculate min width anymore.

2002-06-20  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c:  update focus_object to work properly with frames
	(focus): try to be clever about borders

	* htmlengine.c: update focus_object to work properly with frames

	* htmlgdkpainter.c (alloc_e_font_try): use gdk_fontset_load only
	when necessary, otherwise use gdk_font_load

	* htmlobject.c (html_object_engine): new function, returns engine
	which contains clue which object directly (no frames on way from
	clue to object)
	(html_object_calc_abs_position): correct calculation, take care of
	frames and thus border size

2002-06-18  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (focus): fixed horizontal offset calculation

2002-06-06  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (gtk_html_insert_html_generic): added tmp parameter,
	which when non-null is used as source of insertion, it's destroyed
	afterwards
	(gtk_html_insert_gtk_html): new method, takes to_be_destroyed
	gtkhtml widget and inserts its content into html gthtml

2002-05-30  Radek Doulik  <rodo@ximian.com>

	* htmltable.c (draw): call get_body with table coordinates

	* htmlengine.c (html_engine_draw_real): substract borders from
	engine height before comparing with engine clue height

2002-05-28  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (gtk_html_init): set default content type to
	"html/text; charset=utf-8"

2002-05-23  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c: moved properties initialization to instance init,
	suggested by Michael Meeks

2002-05-24  Larry Ewing  <lewing@ximian.com>

	* gtkhtml.c (selection_get): handle pasting text/html.
	(init): add text/html target.

2002-05-22  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (gtk_html_set_paragraph_style): fix the styles equal
	condition

2002-05-20  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-clueflowstyle.c
	(html_engine_set_clueflow_style): added dir parameter, fixed undo

	* htmlengine-edit-cut-and-paste.c (check_flows): new helper
	functions, takes care about clueflow's style changes

2002-05-17  Larry Ewing  <lewing@ximian.com>

	* gtkhtml.c (skip_host): fix this for base_urls with hosts but
	without trailing /s.

2002-05-16  Radek Doulik  <rodo@ximian.com>

	* libgtkhtml.pc.in (Cflags): fix include directory

2002-05-13  Radek Doulik  <rodo@ximian.com>

	* gtkhtml-properties.c (gtk_html_class_properties_update): suggest
	gconf sync

2002-05-09  Radek Doulik  <rodo@ximian.com>

	* htmlgdkpainter.c: create PangoLayout just once

2002-05-07  Radek Doulik  <rodo@ximian.com>

	* Makefile.am: fixed .la versioning

	* libgtkhtml.pc.in (Libs): added a11y lib

	* gtkhtml.c (client_notify_widget): use /keybindings_theme in
	widget and not class notify

2002-04-18  Radek Doulik  <rodo@ximian.com>

	* htmlprinter.c (insure_paper): use default paper name in case of
	wrong translation

2002-04-16  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (drag_data_received): allow drop just links of known
	protocols

2002-03-25  Radek Doulik  <rodo@ximian.com>

	* htmlplainpainter.c (html_plain_painter_new): create and ref
	pango context

	* htmlimage.c (html_image_factory_end_pixbuf): unref loader once
	not needed
	(free_image_ptr_data): close loader before unrefing

	* htmlclueflow.c (end_of_word): don't check for *cn to recognize
	one char length words

	* htmlengine.c (html_engine_calc_size): use border when setting
	e->clue coordinates

2002-03-18  Radek Doulik  <rodo@ximian.com>

	* htmlengine.c (html_engine_set_focus): test for clue before
	calling html_object_forall on clue

2002-03-11  Radek Doulik  <rodo@ximian.com>

	* htmlprinter.c (calc_text_width): use correct len (in bytes) for
	gnome print function

	* htmlpainter.c (html_painter_calc_text_width_bytes): new method
	(correct_width): new optimized helper function, replaces old
	rewritting functions used in non-bytes version

	* htmltext.c (calc_word_width): use bytes version

	* htmlprinter.c (calc_text_width_bytes): new implementation

	* htmlgdkpainter.c (calc_text_width_bytes): new implementation

	* htmlpainter.c (html_painter_calc_text_width_bytes): new function
	which uses byte len instead of uc-char len (index)

	* htmlfontmanager.c (html_font_new): added nbsp and space width to
	the font structure

2002-03-07  Larry Ewing  <lewing@ximian.com>

	* htmltextslave.c (html_text_slave_get_text): cache this result.
	(split): pass an optional charStart setting to allow filling the
	above cache without recomputing the pointer from the offset.
	(hts_fit_line): update the start position cache as we walk
	forward.  And pass the start pointer to the split call.
	(draw_highlighted): opitmize the pointer offset calculations.
	(html_text_slave_init): initialize that cache value to NULL.

	* htmltextslave.h: add charStart cache entry.

2002-03-06  Larry Ewing  <lewing@ximian.com>

	* htmltextslave.c: undo the s/g_utf8/h_utf8/ use a #define instead.
	Add comment explaining this choice.

	* htmltext.c: same as above.
	
	* htmltextslave.c: optimize, I'll be more specific when I'm done.

	* htmltext.c: see above.

2002-03-05  Larry Ewing  <lewing@ximian.com>

	* htmlbutton.c (html_button_init): mark strings for translation.
	Add missing includes for _() definition.

	* htmlselect.c: convert from utf8 properly and use needs_update
	boolean to postpone setting the popdown strings until they are
	needed.  Because of how GtkCombo is implemented setting popdown
	strings is extremely expensive.

	* htmlselect.h: add update boolean.

	* htmltextinput.c: handle utf8 strings correctly.

	* htmltextarea.c (html_textarea_set_text): convert string to gtk
	charset before setting gtk widget.

	* htmlbutton.c (html_button_init): convert to gtk string before
	creating label.

2002-02-26  Larry Ewing  <lewing@ximian.com>

        * gtkhtml.c: rename to gtk_html_get_url_blah, still bad but a
	little better.

	* gtkhtml.h: ditto.

	* htmliframe.c: fix for renaming.

	* htmlframe.c: same as above.
	
2002-02-26  Larry Ewing  <lewing@ximian.com>

	* htmliframe.c: remove the unused on_url and link_clicked handlers
	and add note that these signals do not cascade.  Use
	gtk_html_get_base_relative in set_base now.

	* htmlframe.c: same as above.

	* gtkhtml.c: make link_clicked and on_url resolve urls relative to
	the frame they are in.  moved the relative url code in here.
	gtk_html_get_base_relative and gtk_html_get_object_relative
	function for the relative url parsing.  These should probably get
	better names.

	* gtkhtml.h: add the new function prototypes.

2002-02-25  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-cut-and-paste.c (use_pictograms): set ALT text
	to picto image
	(html_engine_insert_text): don't use smiley's in plain text mode

	* htmlimage.c (calc_size): draw ALT text with PLAIN painter
	(calc_size): update for ALT text and PLAIN painter

	* htmlengine-edit-cursor.c (html_engine_draw_image_cursor): fixed
	rectangle calculation

2002-02-24  Larry Ewing  <lewing@ximian.com>

	* gtkhtml.c (html_engine_url_requested_cb): expand urls relative
	to the document url.

	* htmlframe.c (html_frame_init): request the initial url on the
	parent.
	(html_frame_url_requested): let the widget expand the relative
	urls.

	* htmliframe.c (html_frame_init): request the initial url on the
	parent.
	(html_iframe_url_requested): let the widget expand the relative
	urls.

2002-02-23  Larry Ewing  <lewing@ximian.com>

	* htmlframe.c: change relative url lookup.

	* htmliframe.c: change relative url handling.  Fix check_url logic
	for scrolled case.

	* gtkhtml.c (gtk_html_set_base): remove the old parsing logic.

2002-02-22  Radek Doulik  <rodo@ximian.com>

	* htmlimage.c (update_or_redraw): don't draw or schedule engine
	update in blocking mode

2002-02-15  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (new_obj_from_uri): don't remove http:// from link text
	(new_obj_from_uri): don't be too smart about URL's, people don't
	like ;-)
	(idle_handler): don't just check for thaw idle handler scheduled,
	but also if html engine isn't actually frozen
	(button_press_event): unset button1_pressed flag for 2x and 3x
	click, it fixes word and line selection in iframes

	* htmlinterval.c (html_point_max): handle case, when one point's
	object is container of another (as could happen with tables)

2002-02-14  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (command): set return value for cursor-{forward,backward}

2002-02-12  Radek Doulik  <rodo@ximian.com>

	* htmlclueflow.c (write_list_finish_tags): new helper method,
	takes care about writing right list ending tags
	(write_pre_tags): use write_list_finish_tags
	(write_post_tags): ditto
	(get_end_tag_item): extracted helper function
	(get_end_tag): use get_end_tag_item

	* htmlimage.c (html_image_animation_timeout): test if delay is >
	0 (before we have been testing for != 0)

	* gtkhtml.c (gtk_html_has_undo): renamed from gtk_html_is_dirty

	* htmlundo.c (html_undo_has_undo_steps): renamed from
	html_undo_is_dirty

2002-02-11  Radek Doulik  <rodo@ximian.com>

	* htmlselection.c (html_engine_select_interval): don't activate
	PRIMARY selection
	(html_engine_update_selection_active_state): new helper function

	* gtkhtml.c (key_press_event): set event_time
	(button_press_event): if we are provider of PRIMARY, copy
	selection to primary object
	(button_release_event): don't copy to primary, just in case we are
	provider of PRIMARY
	(button_release_event): update selection active state, don't copy
	to primary object
	(selection_get): if primary is non-NULL, use it, otherwise get
	selection from engine
	(selection_received): don't copy primary, just use it directly and
	reset it to NULL
	(cursor_move): update selection active state
	(move_selection): ditto
	(gtk_html_select_word): ditto
	(gtk_html_select_line): ditto
	(gtk_html_select_paragraph): ditto
	(gtk_html_select_paragraph_extended): ditto
	(gtk_html_select_all): ditto, don't copy to primary

	* gtkhtml-private.h: added event_time

2002-02-11  Larry Ewing  <lewing@ximian.com>

	* htmltokenizer.c (in_script_or_style): fix obvious error in
	growing the scriptCode buffer, use g_realloc instead.

2002-02-06  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (drag_data_received): remove \n\r in the end of url's
	(drag_data_received): allow dropping of uri lists instead of just
	one uri, implemented image dropping

2002-02-05  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (realize): changed defaults to all
	(drag_data_received): when dropped on selection, it pastes over it
	fix cursor position

2002-01-31  Radek Doulik  <rodo@ximian.com>

	* keybindingsrc.*: removed paragraph formatting bindings, so now
	it works thru menu bindings

2002-01-29  Radek Doulik  <rodo@ximian.com>

	* htmlengine.c: added close_flow to few places to avoid empty
	clueflows in tree

	* htmlselection.c (html_engine_select_all): as below

	* htmlengine-edit-cut-and-paste.c (html_engine_copy_object): check
	if e->clue is not empty

2002-01-28  Radek Doulik  <rodo@ximian.com>

	* htmlengine-print.c (print_page): fix header printing

2002-01-27  Larry Ewing  <lewing@ximian.com>

	* gtkhtml.h: add set_title prototype.

	* gtkhtml.c: add gtk_html_set_title to match gtk_html_get_title.

2002-01-25  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit.c (html_engine_set_title): new method for title setting

2002-01-24  Larry Ewing  <lewing@ximian.com>

	* htmlpainter.c: remove uneeded semicolons after
	DEFINE_UNIMPLEMENTED definitions.  They are spurious and cause
	some compilers to complain.  Thanks to Tim Mooney
	<mooney@dogbert.cc.ndsu.nodak.edu> for the patch.  Fixes
	http://bugzilla.ximian.com/show_bug.cgi?id=19189
	
2002-01-14  Larry Ewing  <lewing@ximian.com>

	* htmlengine-edit-cursor.c (html_engine_draw_cursor_in_area): wrap
	im call in #ifdef GTK_HTML_USE_XIM

2002-01-14  Radek Doulik  <rodo@ximian.com>

	* keybindingsrc.*: bind style-itemalpha command

	* gtkhtml.c (command): implement style-itemalpha command

2002-01-11  Radek Doulik  <rodo@ximian.com>

	* htmltextslave.c (get_offset_for_pointer): optimized to use word
	width cache

2002-01-10  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit.c (html_engine_new_text): could return link
	object again

	* htmlengine-edit-fontstyle.c (html_engine_text_style_object): new
	helper function
	(html_engine_get_document_url): use html_engine_text_style_object
	to change link editing behaviour
	(html_engine_get_document_font_style): ditto
	(html_engine_get_document_color): ditto

	* htmlengine-save.c (html_encode_entities): renamed from
	encode_entities, exported, allow encoded_len_return to be NULL

2002-01-08  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-cut-and-paste.c (html_engine_edit_set_link):
	renamed from html_engine_set_link

	* htmlengine-edit-clueflowstyle.c (get_props_and_set): set changes
	to recalculate word widths and layout properly

	* gtkhtml-properties.c: don't save spell properties, load spell
	properties

2002-01-04  Radek Doulik  <rodo@ximian.com>

	* gtkhtml-private.h: add notify_spell_id

	* gtkhtml.c (client_notify_spell_widget): new function
	(init_properties_widget): watch gnome spell configuration, use
	client_notify_spell_widget

2001-12-21  Larry Ewing  <lewing@ximian.com>

	* Makefile.am (libgtkhtml_la_LDFLAGS): add GTKHTML_RELEASE to the
	flags and install headers into proper place.

2001-12-20  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (gtk_html_images_ref): new method
	(gtk_html_images_unref): ditto
	(gtk_html_image_ref): ditto
	(gtk_html_image_unref): ditto
	(gtk_html_image_preload): ditto

	* htmlengine.c (html_engine_begin): don't use factory cleanup, we
	don't need it anymore and we want preloaded images to be kept

2001-12-18  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (class_init): added call to gdk_rgb_init

	* htmlengine-edit-clueflowstyle.c (set_clueflow_style_in_region):
	avoid skipping end and continuing to the end of document

2001-12-17  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (gtk_html_api_set_language): use engine language prior
	to class one

	* htmlengine.c (html_engine_set_language): new method, set
	language for spell checking

	* htmlengine.h: added language item

2001-12-14  Larry Ewing  <lewing@ximian.com>

	* htmliframe.c (html_iframe_init): dup the url.
	(destroy): free the url.

2001-12-13  Larry Ewing  <lewing@ximian.com>

	* gtkhtml-im.h (gtk_html_im_position_update): add prototype for
	html_engine_draw_cursor_in_area.

	* htmlengine-edit-cursor.c (html_engine_draw_cursor_in_area):
	update the preedit posistion.

	* gtkhtml-im.c (gtk_html_im_position_update): update the posistion
	of the XIM preedit block (This XIM patch is based on the patch by
	ynakai@redhat.com and fixes
	http://bugzilla.ximian.com/show_bug.cgi?id=9526)

2001-12-12  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (command): implemented kill-word and
	backward-kill-word commands

2001-12-11  Radek Doulik  <rodo@ximian.com>

	* htmlengine-print.c (html_engine_print_with_header_footer):
	minimal scale 0.5, so we stop on scale, which is still readable

	* htmlselect.c (html_select_set_text): make it safe when
	select->strings == NULL

2001-12-06  Radek Doulik  <rodo@ximian.com>

	* htmltable.c (split): removed old obsolete forgotten code

2001-12-05  Radek Doulik  <rodo@ximian.com>

	* htmlprinter.c (insure_paper): use _("US-Letter") as fallback,
	add printer parameter to be able to get paper from master
	(html_printer_new): add master parameter, to be remembered, needed
	for paper
	half margins as they are too wide in gnome-paper

	* gtkhtml.c (gtk_html_print_set_master): new helper function
 
	* gtkhtml-properties.c: set default print size back to 10

	* htmlprinter.c (insure_paper): use print master to get its paper

	* gtkhtml-private.h: added print_master

	* htmlprinter.c (html_printer_get_page_height): use top and bottom
	margins

	* gtkhtml-properties.c: change default size for printing fonts to
	9

2001-12-09  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (gtk_html_insert_html_generic): freeze/thaw

	* htmlimage.c (save): save links
	(html_image_get_actual_width): exported, updated to allow painter
	== NULL
	(html_image_get_actual_height): likewise
	(set_link): use color

2001-12-03  Radek Doulik  <rodo@ximian.com>

	* htmlimage.c (draw): use new colors

	* htmltextslave.c (draw_highlighted): use new colors

	* htmlpainter.c: remove html_painter_get_highlight_color, it's now
	obsolete

	* htmlcolorset.c: added entries for highlight colors in non-focus
	state

	* htmlframe.c (html_frame_init): as below, BTW, iframe and frame
	has so much shared code, that I believe they should be inherit
	from generic frame parent which should hold shared code

	* htmliframe.c (html_iframe_init): set focus by parent

2001-11-29  Radek Doulik  <rodo@ximian.com>

	* htmlengine.c (set_focus): new helper function
	(html_engine_set_focus): foreach frame/iframe set painter focus,
	uses set_focus helper

2001-11-27  Radek Doulik  <rodo@ximian.com>

	* htmltext.c (html_text_magic_link): use
	html_cursor_jump_to_position_no_spell instead of
	html_cursor_jump_to_position to avoid unwanted spell checker calls
	which are performance expensive

	* gtkhtml.c: updated for spell checking changes

	* htmlengine.c (html_engine_get_spell_word): renamed from
	html_engine_get_word and updated
	(html_engine_spell_word_is_valid): likewise
	(html_engine_replace_spell_word_with): likewise

	* htmlengine-edit.c (html_engine_spell_check_range): updated

	* htmlclueflow.c (begin_of_word): update for spell word selection
	(end_of_word): ditto

	* htmlselection.c (html_selection_spell_word): new helper
	function used for word selection for spell checking

	* htmlengine-edit.c (html_engine_select_spell_word_editable): new
	function, selects word for spell checking, it differs from word
	selection by 2xclick

2001-11-26  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (scroll): use MAX (0, upper) to avoid negative values
	(scroll_by_amount): refactored - remove redundant local variables

2001-11-21  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (selection_clear_event): unselect only when widget is
	non editable, otherwise keep selection valid

	* htmlimage.c (draw): use html_painter_set_focus

	* htmltextslave.c (draw_highlighted): use html_painter_set_focus

	* gtkhtml.c (focus_in_event): set painter focus, redraw selection
	(focus_out_event): ditto

	* htmlpainter.c (html_painter_set_focus): remember focus in
	painter
	(html_painter_get_highlight_color): get highlight color depending
	on focus

	* htmlengine.c (html_engine_redraw_selection): new helper function

	* htmlclueflow.c (calc_size): place check for changed size before
	html_object_calc_size
	(merge): set change size to head of self and tail of with
	(split): set change size aroud and child object 

2001-11-20  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-cut-and-paste.c (insert_empty_paragraph): check
	if original paragraph is empty link and in such case replace link
	with empty text

	* htmllinktext.c (html_link_text_to_text): changed return value,
	now this method return newly created object with the same text as
	link and same text attributes as font style/face and with default
	text color

	* htmlengine-edit.c (html_engine_new_text): don't ever create
	links here

	* htmlengine-search.c (display_search_results): use move_to_found
	only for non editable widget

	* htmlclueflow.c (search_set_info): use strlen instead of
	Text::text_len because of utf8
	(search_set_info): use g_utf8_pointer_to_offset
	(search_text): use strlen
	(search_set_info): added text parameter

2001-11-19  Radek Doulik  <rodo@ximian.com>

	* htmlengine-search.c (display_search_results): hide/show cursor

	* htmlselection.c (html_engine_select_interval): wrap in hide/show
	cursor
	(html_engine_unselect_all): ditto
	(html_engine_disable_selection): ditto

	* htmlengine-search.c (html_engine_search_next): if engine is
	editable, use html_engine_search rather than
	html_engine_search_next to respect cursor position 

	* htmlengine.c (replace): don't replace with empty text's, just
	delete selection in such case

2001-11-15  Radek Doulik  <rodo@ximian.com>

	* htmlcluev.c (do_layout): test if it's new flow by old_y and not
	old_y_off

2001-11-15  Larry Ewing  <lewing@ximian.com>

	* gtkhtml-properties.c (get_font_name): 
	(get_default_fonts): move these out of the gconf #ifdef.  Patch
	from Michael Granger <ged@FaerieMUD.org>. Fixes Ximian 15251
	
2001-11-14  Radek Doulik  <rodo@ximian.com>

	* htmlengine.c (parse_halign): allow halign be "middle", which is
	common mistake

2001-11-14  Larry Ewing  <lewing@ximian.com>

	* htmlcolorset.c (html_colorset_set_style): use the fg[SELECTED]
	instead of text[SELECTED] since that is what the silly gtk+
	widgets do.

2001-11-12  Radek Doulik  <rodo@ximian.com>

	* htmlcluev.c (do_layout): compare curr y_off's (y - ascent) and
	not old and new curr->y

2001-11-08  Radek Doulik  <rodo@ximian.com>

	* gtkhtml-properties.c (gtk_html_class_properties_new): get
	default encoding from default widget style font
	(gtk_html_class_properties_load): ditto
	(get_default_fonts): new helper function
	(get_font_name): stolen from e-font.c

	* htmlengine-edit-text.c (find_first): use g_unichar_isalnum
	(html_engine_capitalize_word): test if next char is alnum
	before doing forward_word
	(upper_lower): don't g_assert here as it's not needed, just test
	if we have text object to modify

2001-11-06  Radek Doulik  <rodo@ximian.com>

	* htmlgdkpainter.c (alloc_e_font_try): try to use gdk_font_load
	for fixed font, if gdk_fontset_load doesn't load fixed font for us

2001-11-05  Radek Doulik  <rodo@ximian.com>
 
	* htmlengine-edit-cut-and-paste.c
	(html_engine_cut_and_paste_begin): check for e->mark != NULL
 
2001-11-05  Larry Ewing  <lewing@ximian.com>

	* htmlselection.h (html_selection_current_time): s/()/(void)/

2001-11-02  Radek Doulik  <rodo@ximian.com>

	* htmltext.c (get_cursor): if we are between two text objects, use
	the second one fixes #14153

2001-11-03  Radek Doulik  <rodo@ximian.com>

	* htmlengine-print.c (html_engine_print_with_header_footer): set
	font manager defaults before we do test for fixed font

2001-11-01  Radek Doulik  <rodo@ximian.com>

	* htmlengine.c (html_engine_replace_word_with): disable selection,
	don't store selection across replace

	* htmlembedded.c (destroy): if changed_id > 0 then disconnect it

	* htmlembedded.h: added changed_id, where we store handler id from
	connected html_embedded_object_changed

	* htmlembedded.c (html_embedded_object_changed): moved from
	htmlengine.c and renamed

2001-10-31  Ettore Perazzoli  <ettore@ximian.com>

	* htmliframe.c (html_iframe_init): Set ->scroll before calling
	`html_iframe_set_scrolling()'.  Fixes #14098.

2001-10-30  Larry Ewing  <lewing@ximian.com>

	* htmlselection.c (html_selection_current_time): add helper
	function.

	* htmlselection.h (html_selection_current_time): add prototype.

	* gtkhtml.c (gtk_html_set_base): add call to set the document
	base.
	(gtk_html_get_base): get the document base.
	(gtk_html_cut): html_selection_current_time.
	(gtk_html_copy): html_selection_current_time.
	(gtk_html_paste): html_selection_current_time.
	
	* gtkhtml.h: add *_base prototypes.

	* gtkhtml-private.h: add base_url member.

	* htmliframe.c (html_iframe_init): use set_scrolling.
	(html_iframe_set_scrolling): add.
	(calc_size): use set_scrolling.

	* htmliframe.h (html_iframe_set_scrolling): add helper function.

	* htmlengine.c (block_end_div): set e->divAlign too.  Fixes 
	Ximian #9167.
	
2001-10-30  Radek Doulik  <rodo@ximian.com>

	* htmltable.c (html_table_set_max_width): set max_width to
	min_width if min_width > max_width

	* htmlengine-edit-cut-and-paste.c (insert_empty_paragraph): move
	undo level end to wrap event
	(html_engine_insert_text): added event emitting, it need to be
	fixed later to have new event type for it, now it uses command
	insert-paragraph
	(html_engine_insert_text): wrap it in undo level

	* gtkhtml.c (gtk_html_editor_event_command): added 'before' flag

	* gtkhtml-enums.h: split GTK_HTML_EDITOR_EVENT_COMMAND in
	GTK_HTML_EDITOR_EVENT_COMMAND_BEFORE and
	GTK_HTML_EDITOR_EVENT_COMMAND_AFTER

	* htmlimage.c (get_actual_width): fix scale for pixel size

2001-10-30  Larry Ewing  <lewing@ximian.com>

	* htmlcluev.c (do_layout): shut up compiler.

	* htmltokenizer.c: get rid of cut & pasted functions they are in
	gal now.

2001-10-29  Larry Ewing  <lewing@ximian.com>

	* htmltable.c (merge): shut up the compiler.

	* htmlengine.c (parse_c): tweak reseting center.
	
2001-10-29  Ettore Perazzoli  <ettore@ximian.com>
 
 	* htmlengine.c (html_engine_init): Init `->pAlign' and
 	`->divAlign' to `HTML_ALIGN_NONE'.
 	(new_flow): Use `->pAlign' instead of `->divAlign'.
 	(block_end_clueflow_style): Likewise.
 	(block_end_div): Likewise.
 	(parse_table): Likewise.
 	(parse_a): Likewise.
 	(parse_c): Likewise.
 	(parse_d): Likewise.
 	(parse_h): Likewise.
 	(parse_p): Likewise.
 	(parse_p): Set the pAlign to be the same as the divAlign by
 	default when starting a new paragraph.  When closing a paragraph,
 	set pAlign to be the same as divAlign.
 	(parse_d): Set both pAlign and divAlign for `<div>'.

2001-10-30  Radek Doulik  <rodo@ximian.com>

	* htmltext.c (set_color): remove call to relayout

	* htmlengine-edit-fontstyle.c (object_set_font_style): use
	html_object_prev_not_slave
	(set_color): ditto
	(set_empty_flow_color): new function + undo
	(set_empty_flow_style): ditto

2001-10-29  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (html_engine_destroy): timers live in the selection
	updater too, clear it before we destroy the objects.

	* htmlgdkpainter.c (alloc_e_font_try): use gdk_fontset_load (patch
	from  Kjartan Maraas <kmaraas@gnome.org>).  see Ximian #11883.

2001-10-29  Radek Doulik  <rodo@ximian.com>

	* htmlprinter.c: use gnome_font_get_width_utf8_sized

	* htmlobject.c (html_object_cursor_backward): handle aligned clues

	* htmlengine.c (html_engine_calc_min_width): use pixel_size

	* htmlprinter.c (get_font_size): new helper function
	(alloc_font): use get_font_size, which uses scale attribute

	* htmlengine-print.c (html_engine_print_with_header_footer): set
	scale

	* htmlprinter.c: use scale attribute

	* htmlprinter.h: added scale attribute

	* htmlpainter.c (html_painter_get_font): check if font is non-NULL
	before dereferencing

	* htmlprinter.c (alloc_font): if we can't allocate selected face
	and even Courier or Helvetica, fallback to first font from
	gnome_font_family_list

	* htmlfontmanager.c (html_font_manager_get_font): replace g_error
	with g_warning and test if font is non-NULL when setting to font
	manager

	* htmlprinter.c (begin): added call to gnome_print_beginpage

	* htmlengine-print.c (do_we_have_default_font): new helper
	function
	(html_engine_print_with_header_footer): don't print if we are
	unable to allocate default font

	* htmlcluev.c (check_point): check align_right_list too
	(check_point): translate aligned clues coordinates

2001-10-29  Ettore Perazzoli  <ettore@ximian.com>

	* htmlselection.c (html_engine_select_interval): Peek the time
	from `gtk_get_current_event()'.

	* gtkhtml.c (get_current_time): New function to get the current
	time from `gtk_get_current_event()' [if the latter fails, it just
	resorts to `GDK_CURRENT_TIME'].
	(gtk_html_paste): Use it instead of just `GDK_CURRENT_TIME' as the
	timestamp.
	(gtk_html_copy): Likewise.
	(gtk_html_cut): Likewise.

2001-10-29  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (command): check if word is non-NULL, don't leak it

2001-10-28  Larry Ewing  <lewing@ximian.com>

	* gtkhtml.c (command): stop insertion links on new paragraphs.

	* htmlengine-edit-cut-and-paste.c (html_engine_cut_line): wrap cut
	line in an undo level.
	(html_engine_set_insertion_link): set the insertion color if there
	is a url.
	(insert_empty_paragraph): the command resets the link for us now.
	
	* htmlimage.c (stop_anim): remove the stall timeout here as well.
	(html_image_pointer_remove_stall): helper function.
	(html_image_pointer_unref): use remove_stall.
	(check_point): go before or after by splitting in the middle.
	This is at least more usable that the old method.

	* htmlengine.c (html_engine_destroy): stop all animations and
	destroy stall timers before we enter the destroy processing.
	
	* gtkhtml.c: add accessor to the allow_frameset disable code.

	* gtkhtml.h: add prototypes.

2001-10-27  Larry Ewing  <lewing@ximian.com>

	* gtkhtml.c (scroll_by_amount): fix this so that we never scroll
	farther down the page than we want to (adj->val -
	adj->page_size). Fixes Ximian #2504.

	* htmltokenizer.c (in_entity): always collapse the entity even in
	tags and element names.

	* htmlengine.c (html_engine_destroy): make the engine safe for
	reentrant calls that could result from destroying embedded objects
	that might iterate the main loop. Fixes ximian #13699.

2001-10-26  Radek Doulik  <rodo@ximian.com>

	* htmltable.c (op_copy): handle cspan, rspan
	added few g_return_if_fail's

	* htmlclueflow.c (calc_size): if width_left < 0 and ! firstRun,
	then break line here
	(draw_background): don't call html_object_draw for parent as this
	means we draw itself too (so when flow is drawed from drawing
	queue, it's rendered twice which means uglyness for gdkxft) I've
	tried to reproduce bug #6, for which this was intended as fix, but
	can't reproduce it, so I hope #6 is fixed properly now.

	* htmlobject.c (html_object_is_clue): added HTML_TYPE_CLUEALIGNED,
	which Larry probably forgot commit

2001-10-25  Larry Ewing  <lewing@ximian.com>

        * htmlembedded.c (destroy): clean up the signals and unset the
        object data so that even if the widget lives on if doesn't kill
        us.
        (html_embedded_allocate): rename for the fun of it.
        (html_embedded_new_widget): pass em as object data so that the
        signal will be removed when we destroy.

	* htmltokenizer.c (flush_entity): don't add the TAG_ESCAPE to the
	output when fluhing the entity.
	(in_entity): don't collapse entities in tags or attributes.

	* htmlimage.c (image_update_url): don't do anything if there is no
	map.
	(get_url): return the image->url if final->url is NULL.

2001-10-25  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-cut-and-paste.c (insert_object): use
	html_cursor_jump_to_position_no_spell
	(insert_object_do): ditto
	(insert_object): ditto

	* htmlcursor.c (html_cursor_jump_to_position_no_spell): new
	function, preserves engine's need_spell_check flag while jumps

	* htmlengine-edit-cut-and-paste.c (append_object): remember
	position when empty flow is already prepared

	* htmlengine.c (check_cursor): new function, checks if cursor
	position is valid

	* htmlengine-edit-cut-and-paste.c (insert_object_do): save orig
	cursor after split
	(insert_object_do): preserve position before for orig
	(isolate_tables): rewritten once more
	(insert_undo_action): update to isolate_tables changes
	(insert_setup_undo): ditto
	(insert_object): ditto

	* htmlobject.c (move_object_cursor): allow cursor moves in flow
	where containers are mixed with leaf objects

2001-10-24  Larry Ewing  <lewing@ximian.com>

	* htmlobject.c (html_object_is_clue): add HTML_TYPE_CLUEALIGNED to
	the type list.

	* htmlimage.c (html_image_animation_new): initialize some
	variables that were missed.

	* htmlengine.c (html_engine_destroy): remove the thaw idle if we
	are destroyed.

2001-10-24  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-cut-and-paste.c (insert_empty_paragraph): added
	add_undo parameter which specifies, if undo action should be added
	(delete_object): ditto
	(isolate_tables): rewritten
	(insert_object): updated to new isolate_tables

	* htmltable.c (op_copy): fill empty cells with cells with empty
	texts, fix copying start condition

2001-10-23  Radek Doulik  <rodo@ximian.com>

	* htmltable.c (split): redo splits on table boundaries

	* htmltokenizer.c (g_utf8_get_char_validated): make it static to
	avoid compiler warning

	* htmltable.c (merge): take care of prev_c1 when moving cells
	handle case when merging two cells better - fix cursor position

	* htmlclue.c (html_clue_append_after): be more carefull
	(html_clue_append): ditto

	* htmlengine-edit-cut-and-paste.c (insert_object_do): check for
	clue

	* htmlobject.c (html_object_is_clue): new function

	* htmlclueflow.c (merge): merge always

	* htmltable.c (split): add dup to parent clue
	(merge): c1 = c2 to be sure c1_prev is valid

2001-10-22  Larry Ewing  <lewing@ximian.com>

	* htmlclue.c (op_helper): don't do anything to last until we've
	checked to make sure the clue isn't empty and last is not NULL.

2001-10-22  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit.c (html_engine_select_word_editable): use
	html_selection_word

	* htmlselection.c (html_selection_word): new method
	(word_interval): use html_selection_word

	* htmlengine-edit-cut-and-paste.c (html_engine_delete_container):
	reorder selection related method calls
	(html_engine_delete_n): ditto + added freeze/thaw

	* htmlpainter.c (html_painter_draw_spell_error): return width of
	spell error underline (which is width of underlined text)

	* htmltextslave.c (draw_spell_errors): fixed misplaced
	misspell-underlines, optimized

2001-10-21  Larry Ewing  <lewing@ximian.com>

	* htmldrawqueue.c (html_draw_queue_clear): take care of
	pending_frees here this way we don't leak if when the queue is
	cleared.
	(html_draw_queue_flush): don't free free_pending obects here, just
	don't draw them.

	* htmlobject.c (destroy): make sure cleanup everything even if
	redraw is pending, otherwise the drwaqueue code will leak this.

2001-10-20  Larry Ewing  <lewing@ximian.com>

	* htmliframe.c (copy): add a partial copy implementation to
	make things slightly less prone to breaking.
	(html_iframe_class_init): use copy.

2001-10-19  Dan Winship  <danw@frotz.mysterion.org>

	* gtkhtml-stream.c (gtk_html_stream_vprintf): Fix another
	ppc-breaking stdarg buglet.

2001-10-19  Radek Doulik  <rodo@ximian.com>

	* htmlinterval.c (unselect_object): queue draw only if engine is
	not frozen
	(select_object): ditto

	* htmlimage.c (update_or_redraw): use html_engine_flush_draw_queue
	instead of html_draw_queue_flush and html_engine_queue_draw
	instead of html_draw_queue_add

	* htmlengine.c (html_engine_flush_draw_queue): flush only if not
	frozen
	(html_engine_freeze): flush draw queue before freeze

	* htmlengine-edit-cut-and-paste.c (set_cursor_at_end_of_object):
	preserve need_spell_check flag

	* gtkhtml.c (expose): do simple draw as engine now handles frozen
	state by itself

	* htmlengine.c (html_engine_draw_real): renamed from
	html_engine_draw
	(html_engine_draw): handle frozen draws

	* htmlclueflow.c (op_helper): remove slaves only when cut or in
	copy result

	* htmlclue.c (op_helper): make it work even when containing slaves

	* htmlengine.c (html_engine_add_expose): new method, stores expose
	rectangle in SList to be processed in thaw
	(thaw_idle): call do_pending_expose, clear and reset
	pending_expose list
	(do_pending_expose): do pending exposes

	* gtkhtml.c (expose): if engine is frozen, then add expose to
	pending to be processed in final thaw

	* htmlengine.c (thaw_idle): check for freeze_count if we aren't
	frozen again
	(html_engine_thaw): don't decrease freeze_count if it equals to 1,
	do it in thaw_idle

	* htmlengine-edit-cut-and-paste.c (html_engine_copy_object): don't
	freeze and thaw in copy, copy should not modify our tree, so we
	don't need to update it after

2001-10-18  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (update_embedded): go ahead and draw the
	background.  This cuts down on flashing when switching pages
	quickly.

2001-10-18  Radek Doulik  <rodo@ximian.com>

	* htmltablecell.c (calc_size): fix rendering

2001-10-18  Larry Ewing  <lewing@ximian.com>

	* htmltokenizer.c: fix to guarantee no invalid utf8 sequences can
	make it past any part of the tokenizer into the tokens.  This is
	critical to prevent looping in g_utf8* on certain input.

2001-10-17  Larry Ewing  <lewing@ximian.com>

	* htmltext.c (html_text_set_text): update the text_len when we set
	the text.

	* htmlembedded.c (destroy): sink any widget that hasn't been
	parented yet.

2001-10-17  Radek Doulik  <rodo@ximian.com>

	* htmlobject.c (html_object_add_to_changed): new function, adds
	object to changed list and tries to minimalize repeated drawing

	* htmlengine-edit-cut-and-paste.c (delete_object_do): flush queue
	before delete to avoid deleted object drawing

	* htmlengine.c (html_engine_flush_draw_queue): make it possible
	flush draw queue when engine is frozen

	* htmltext.c (html_text_op_cut_helper): fix rendering

2001-10-16  Larry Ewing  <lewing@ximian.com>

	* htmlselect.c (copy): implement enough of copy that it no longer
	crashes when copied.

2001-10-17  Radek Doulik  <rodo@ximian.com>

	* htmltable.c (calc_size): fix rendering issues

2001-10-16  Radek Doulik  <rodo@ximian.com>

	* htmltext.c (html_text_get_nb_width): fix for case where more
	than 2 non-breakable texts are in line, use get_next_nb_width
	(get_next_nb_width): new helper function

2001-10-16  Larry Ewing  <lewing@ximian.com>

	* htmlclueflow.c: include <stdlib.h> for abs definition.

	* htmlengine.h: add allow_frameset boolean.

	* htmlengine.c (html_engine_init): add allow_frameset paramter.
	(parse_f): only parse the frameset and frames if allow_frameset is
	true.
	(parse_n): only discard the noframes body if allow_frameset is
	true.
	(html_engine_init): initialize allow_frameset.

	* htmltokenizer.c (add_byte): discard '\0' on input, it just
	confuses the rest of the tokenizer and serves no purpose.

2001-10-15  Radek Doulik  <rodo@ximian.com>

	* handle "font size points" attribute everywhere

	* gtkhtml-properties.h: added points attributes

	* gtkhtml.c (selection_received): automagic links when pasting
	text from selection

	* htmlclueflow.c (add_clear_area): new helper function
	(calc_size): use add_clear_area in case we need to erase area
	behind flow, which has just shrinked

	* htmlcluev.c (add_clear_area_behind): set width and height to
	HTMLObjectClearRectangle

	* htmlengine.c (clear_changed_area): use width and height from
	HTMLObjectClearRectangle

	* htmlobject.h: added width and height to HTMLObjectClearRectangle

2001-10-14  Larry Ewing  <lewing@ximian.com>

	* htmlimage.c (render_cur_frame): add hack to turn off alpha
	blending durring an animation.  Since gifs are the only animation
	type gdk-pixbuf supports it breaks nothing an makes for a big
	spead increase.

2001-10-14  Jon Trowbridge  <trow@ximian.com>

	* htmlframe.c (html_frame_init): On second thought, maybe sharing
	the tokenizers isn't such a good idea after all...

	* htmliframe.c (html_iframe_init): Ditto.

2001-10-13  Jon Trowbridge  <trow@ximian.com>

	* htmliframe.c (html_iframe_init): The iframe's HTMLEngine needs
	to share the parent's HTMLTokenizer, not a copy. (Bug #11638)

	* htmlframe.c (html_frame_init): Likewise, the frame's HTMLEngine
	needs to share the parent's HTMLTokenizer, not a copy. (also Bug
	#11638)

2001-10-12  Radek Doulik  <rodo@ximian.com>

	* htmlengine.c (draw_changed_objects): test if we already have
	window

	* htmlobject.c (html_object_engine_intersection): new function,
	extracted
	(html_object_engine_translation): ditto

	* htmldrawqueue.c (draw_obj): refactorize, extracted few functions

	* htmlcluev.c (do_layout): handle case where width is > max_width
	and schedule area clear to changed_objs
	also store changed objs to local list which is prepend to global
	one on end

	* htmlengine.c (draw_changed_objects): handle area clears
	(clear_changed_area): do area clear here
	(html_engine_intersection): new extracted function

	* gtkhtml.c (gtk_html_begin): return NULL to avoid compiler
	warning

	* htmlclue.c (split): reset self::x,y to get right redraw in plain
	text mode

	* htmltext.c (get_tags): don't use </FONT size=...>, but just
	</FONT>
	(get_tags): join <tag> and </tag> additions together

	* htmlclueflow.c (save): in case of PRE paragraph, write final \n
	just after content
	(write_pre_tags): don't write \n for PRE here
	(save): don't put \n after <DIV>, </DIV>
	(save): put alignment tags inside

2001-10-12  Larry Ewing  <lewing@ximian.com>

	* gtkhtml.c (gtk_html_private_calc_scrollbars): don't clip the
	page width it leads to bad things.
	(gtk_html_begin): add a precondition to try to see

2001-10-09  Radek Doulik  <rodo@ximian.com>

	* htmlclueflow.c (get_pre_padding): fixed pre/post padding between
	list and non list paragraphs
	(need_list_begin): fix for list/non-list
	(need_list_end): ditto

	* htmlengine.c (parse_l): close flow on </li>

	* htmlclueflow.c: fixed pre/post padding (was wrong between pre
	and non-pre paragraphs with different indentation levels)
	fixed list indentation (was wrong for indented lists and for inner
	lists with longer indentation)
	fixed pre/post padding on end of list
	prettyfied save output
	(write_pre_tags): fix list, nonlist paragraph on the same level

	* htmlengine-save.c (get_body): add new line after <BODY>

2001-10-09  Larry Ewing  <lewing@ximian.com>

	* htmltextslave.c (get_offset_for_bounded_width): remove redundant
	calls to html_text_get_text since it is actually expensive.

2001-10-08  Larry Ewing  <lewing@ximian.com>

	* htmlselect.c (html_select_add_option): don't add static strings
	to a list that we free all the items in.  Also some formatting
	changes in random places.  Fixes Ximian #8629

2001-10-08  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (gtk_html_api_set_language): new helper private
	function, used to set language thru editor API
	(gtk_html_set_editor_api): set language
	(client_notify_widget): set language
	(client_notify_widget): recheck spelling

	* gtkhtml.h (struct _GtkHTMLEditorAPI): added set_language method

	* htmlengine.c (html_engine_get_word): utf8-ize this function

2001-10-06  Larry Ewing  <lewing@ximian.com>

	* htmlimage.c (html_image_set_url): call register with reload set
	to false.

2001-10-05  Larry Ewing  <lewing@ximian.com>

	* gtkhtml-stream.c (gtk_html_stream_vprintf): fix the limiting
	code.

2001-10-05  Radek Doulik  <rodo@ximian.com>

	* htmlimage.c (html_image_factory_end_pixbuf): call
	gdk_pixbuf_loader_close and get pixbuf from loader if we don't
	have it yet
	(html_image_edit_set_url): renamed from html_image_set_url, editor
	will use this one
	(html_image_set_url): reincarnate old one
	(free_image_ptr_data): new helper function
	(html_image_pointer_unref): use free_image_ptr_data
	(html_image_factory_register): ditto, fixed reload
	(html_image_set_url): call html_image_factory_register with reaload TRUE

2001-10-03  Larry Ewing  <lewing@ximian.com>

	* gtkhtml-stream.c (gtk_html_stream_vprintf): limit the potential
	alloca size so that bad things are less likely to happen.

2001-10-01  Larry Ewing  <lewing@ximian.com>

	* htmlsearch.c (html_search_new): silence warnings for unused
	variables.

	* gtkhtml-stream.c: add stdlib.h include.

	* htmlsearch.c (html_search_new): handle the nongnu regex case
	properly.  From David Kaelbling <drk@sgi.com>

	* htmlentity.c: add gtkhtml-compat.h include for alloca
	definition.  From David Kaelbling <drk@sgi.com>

	* htmlpainter.c: add gtkhtml-compat.h include for alloca
	definition.  From David Kaelbling <drk@sgi.com>

	* gtkhtml-stream.c (gtk_html_stream_vprintf): 
	(gtk_html_stream_printf): add helper functions
	for writing to streams to cut down the duplication of code that is
	floating around.

	* gtkhtml-stream.h: add prototypes for stream_printf and
	stream_vfprintf

	* htmlengine.c (parse_f): go ahead and pass the NULL on through.

	* htmltokenizer.c (add_byte): make the unknown character a ? so
	that we can distinguish it from a the underscore that camel will
	provide.

2001-09-26  Larry Ewing  <lewing@ximian.com>

	* htmlform.c (html_form_add_radio): handle a NULL name for the
	radio group without.  I'm not sure what the proper thing to do
	here is, but crashing is not a good thing.

	* htmlengine-edit-clueflowstyle.h: make the prototype match the
	function (spotted by Dan Nguyen <dnn@austin.ibm.com>).

2001-09-25  Lauris Kaplinski  <lauris@ximian.com>

	* htmlprinter.c (draw_panel): Close path before fill
	(draw_background): Ditto
	(begin): Close path before clip
	(prepare_rectangle): Close path

2001-09-21  Larry Ewing  <lewing@ximian.com>

	* htmltext.c (is_convert_nbsp_needed): silence a warning.
	(is_convert_nbsp_needed): fix this properly.

	* htmlpainter.c: add #include <stdlib.h> to cover the alloca
	prototype.

	* htmlgdkpainter.c (gtkhtml_private_split_name): ifdef out since
	it is currently unused.

	* Makefile.am (testgtkhtml_LDADD): remove -static it was breaking
	the build under libtool-1.4 and FreeBSD.
	(gtest_LDADD): same.

2001-09-19    <NotZed@Ximian.com>

	* htmltokenizer.c (add_byte): Check that utf8_length doesn't
	outgrow our buffer.  The g_utf_get_char_extended function seems
	broken in a way i can't fathom right now.

2001-09-18  Larry Ewing  <lewing@ximian.com>

	* htmlimage.c (html_image_factory_end_pixbuf): let the pointer
	close the loader when it is freed, not before then so that
	html_image_set_url works properly.

2001-09-17  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit.c (html_engine_prev_cell): don't call
	gtk_html_edit_make_cursor_visible
	(html_engine_next_cell): ditto

	* gtkhtml.c (destroy): move gconf related code before html->priv
	is freed

	* htmlclueflow.c (get_start_tag): added few \n
	(get_end_tag): ditto, use need_list_end instead of need_list_begin

2001-09-16  Radek Doulik  <rodo@ximian.com>

	* htmlcluev.c (find_free_area): fixed test for checking if margins
	changed

2001-09-14  Radek Doulik  <rodo@ximian.com>

	* htmlclueflow.c (calc_size): take care of case when lmargin >=
	rmargin, could happen if there is wide aligned object, which takes
	whole max_width, so we must find another free area, otherwise we
	end in infinite loop, where width_left <= 0
	(calc_size): recalc margins only if area was sufficient, in other
	case we have already calculated new and right margins and there
	they were recalculated to wrong values, which could trap us in an
	infinite loop

	* htmltextslave.c(slave_split_if_too_long): new function, use
	html_object_calc_abs_position to calc absolute slave position and
	bound width by MAX_WIDGET_WIDTH - x
	(calc_size): if slave width > max_width, use slave_split_if_too_long

	* htmlengine.c (html_engine_calc_size): don't use min_width as
	lower bound of max_width

	* htmltable.c (html_table_set_max_width): calc max_width as MAX
	(max_width, min_width)

2001-09-13  Larry Ewing  <lewing@ximian.com>

	* htmlengine-save.c (html_engine_save_encode): actually free the
	encoding buffer.  Wow that was a huge leak, fixes ximian #9691.

2001-09-12  Larry Ewing  <lewing@ximian.com>

	* htmlgdkpainter.c (alloc_e_font_try): free the temp strings even
	if we exit with and error.

2001-09-12  Radek Doulik  <rodo@ximian.com>

	* htmlgdkpainter.c (alloc_e_font_do): renamed from alloc_e_font
	(alloc_e_font): if we cannot alloc font with requsted style, try
	to allocate simplified styles of the same face before we fallback
	to fixed
	(alloc_e_font_try): use gdk_font_load and then
	e_font_from_gdk_font instead of e_font_from_gdk_name to avoid
	fixed font creation
	(alloc_e_font_try): comment out fixed font test which was
	probably wrong
	(alloc_e_font_try): use e_font_from_gdk_name to be sure that
	fontset is used when needed

	* gtkhtml.c (client_notify_widget): update tkey compares for
	/font_variable instead of /font_variable_family and likewise for
	/font_fixed

	* htmlengine.c (html_engine_make_cursor_visible): allow cursor to
	be 1 pixel outside view - it doesn't matter now, as we don't allow
	edit margin widths in editor, once we do, we must take care about
	case when rightBorder == 0

	* htmlengine-edit-cursor.c (refresh_under_cursor): left and top
	border widths were interchanged

2001-09-10  Larry Ewing  <lewing@ximian.com>

	* htmlframe.c (html_frame_init): handle NULL and empty urls by
	loading a blank page in the frame.

2001-09-10  Radek Doulik  <rodo@ximian.com>

	* htmlengine.c (html_engine_calc_size): use pixel size

	* keybindingsrc.*: update TAB/Shift TAB bindings

	* gtkhtml.c (load_keybindings): bind C-S-+ and C-+ to ZOOM_IN
	(load_keybindings): don't bind TAB/Shift TAB
	(command): simplify command binded to TAB/Shift TAB

2001-09-08  Dan Winship  <danw@ximian.com>

	* gtkhtml.c (destroy): unref the engine rather than explicitly
	destroying it.

2001-09-07  Radek Doulik  <rodo@ximian.com>

	* applied boc's patch
	* gtkhtml.c (destroy): remove set_font idle
	(destroy): remove gconf notification callback
	(init_properties_widget): remember client notify ID
	(init): zero gconf and XIM fields (it isn't needed because gnew0,
	but we does this for other fields too anyway)
	(init_properties): initialize gconf by itself if needed and print
	warning about it

	* Makefile.am (gtest_LDADD): added GCONF_LIBS

	* htmltextslave.c (get_offset_for_bounded_width): for ' ' search
	in sep instead of text->text
	(calc_size): test for split only for slave->posLen > 1
	(calc_size): split only if pos > 0

2001-09-06  Radek Doulik  <rodo@ximian.com>

	* htmlimage.c (update_or_redraw): new helper function, takes care
	about updating when new data arrives thru stream. It schedules
	update only if image size changed, otherwise it just redraws
	(html_image_factory_end_pixbuf): use update_or_redraw
	(html_image_factory_area_prepared): ditto

2001-09-03  Radek Doulik  <rodo@ximian.com>

	* htmlengine.c (parse_table): don't discard broken tables

2001-09-01  Larry Ewing  <lewing@ximian.com>

	* htmlimage.c (copy): make a reference.
	(html_image_factory_unregister): fix this properly.

2001-08-31  Larry Ewing  <lewing@ximian.com>

	* htmlimage.c (html_image_factory_unregister): change the test now
	that we unref before we remove.

2001-08-31  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-cursor.c: define stipple colors on the
	beggining, it will make it easier for tigert to tune stipple
	lines colors

2001-08-30  Radek Doulik  <rodo@ximian.com>

	* htmltextslave.c (draw_highlighted): updated to use faster line
	offset calculation using html_painter_calc_text_width

	* htmlpainter.c (calc_text_bytes_delta): new helper function, it
	does 1st pass of translating \t and &nbsp; - calculates right size
	of translated string
	(translate_text_special_chars): 2nd pass which finally translates
	\t and &nbsp;
	(put_last): helper inline function
	(html_painter_draw_text): use new translating function
	(html_painter_calc_text_width): ditto
	(html_painter_calc_text_width): changed line_offset to pointer, we
	update line_offset now to line offset on the end of string

	* htmltext.c (split_word_width): removed as it's broken, don't
	bother with it for now

	* htmlpainter.c (html_painter_draw_text): handle &nbsp; before
	this we have left nbsp drawing on X, but some fonts drawed char
	160 a '='
	(draw_current): helper inlined function to draw current undrawed
	text before we draw/skip special characters (&nbsp; and \t)

2001-08-29  Radek Doulik  <rodo@ximian.com>

	* htmltextslave.c (calc_size): split if width > MAX_WIDGET_WIDTH
	(get_offset_for_bounded_width): new helper function
	(calc_width): update for MAX_WIDGET_WIDTH changes

	* htmlenums.h (MAX_WIDGET_WIDTH): define it as 32000

	* htmlengine.c (html_engine_calc_size): make max_width <=
	MAX_WIDGET_WIDTH

	* gtkhtml.c (gtk_html_private_calc_scrollbars): don't let width be
	greater than MAX_WIDGET_WIDTH

2001-08-28  Radek Doulik  <rodo@ximian.com>

	* gtkhtml-properties.c (gtk_html_class_properties_new): use rather
	g_new0
	(gtk_html_class_properties_load): assign 65535 instead of 0xffff
	as default (looks like gnome_config doesn't understand HEXadecimal
	numbers)

2001-08-27  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (gtk_html_private_calc_scrollbars): don't let
	adjustment values go out of bounds
	(gtk_html_update_scrollbars_on_resize): new function, updates
	scroll bars after widget is resized, tries to keep view position
	({x,y}_offset on the same place
	(gtk_html_private_calc_scrollbars): keep scrollbars in bounds,
	it's probably unneeded now, but to be sure
	(size_allocate): use gtk_html_update_scrollbars_on_resize, take
	care of adjustment changes
	(button_press_event): reversed font-zooming direction

	* htmlimage.c (html_image_set_url): re-register image pointer even
	if url is the same as before as image could actually change
	between
	(html_image_set_url): schedule update and set change
	(html_image_set_border): set change
	(html_image_set_size): ditto
	(html_image_set_spacing): ditto
	(html_image_factory_unregister): unref before test for refcount,
	fix g_assert condition, unref when removing from factory hash
	table

2001-08-24  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (update_embedded): fix the x and y offsets of the
	area we begin the painter on.

2001-08-24  Radek Doulik  <rodo@ximian.com>

	* htmlengine-search.c (html_engine_search): update to respect
	search info changes

	* htmlengine-edit-cut-and-paste.c (insert_object): call
	insert_object_do only if len > 0

	* htmlsearch.c (html_search_new): when editable, start at current
	cursor position

2001-08-24  Larry Ewing  <lewing@ximian.com>

	* htmlengine-edit-selection-updater.c: remove the
	html_object_ref/unref calls on the engine.  They are are wrong.
	html_engine_edit_selection_updater_destroy will never get
	called because the ref in html_engine_edit_selection_updater_new
	will keep html_engine_destroy from ever being run.  Thanks go to
	Jacob for tracking this down. Fixes ximian #7168

2001-08-24  Radek Doulik  <rodo@ximian.com>

	* htmlprinter.c (alloc_font): extract family name from face and
	use that for font lookup

	* htmlfontmanager.c (html_font_manager_get_attr): renamed from
	get_attr, exported

2001-08-23  Radek Doulik  <rodo@ximian.com>

	* htmltext.c (check_last_white): new inlined helper function
	(check_prev_white): ditto
	(is_convert_nbsp_needed): updated, check for
	&nbsp;...&nbsp;<space>
	(write_prev_white_space):  new inlined helper function
	(write_last_white_space): ditto
	(convert_nbsp): updated, convert to &nbsp;...&nbsp;<space>
	(merge_word_width): commented out unused condition

2001-08-22  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-cursor.c (html_engine_setup_blinking_cursor):
	start with shown cursor
	(html_engine_setup_blinking_cursor): call blink_timeout_cb
	directly 1st time
	(html_engine_draw_cursor_in_area): draw object cursors only when 

	* htmlengine-edit-clueflowstyle.c (get_props_and_set): when we are
	changing from !item at indent level 0, set insentation to 1 and
	likewise for item --> !item && indentation == 1

	* htmlclueflow.c (html_clueflow_set_style): don't change
	indentation here

2001-08-22  Larry Ewing  <lewing@ximian.com>

	* htmlclueflow.c (check_point): fix some stupidness of mine.

	* htmlclueflow.c (check_point): make sure that head and tail are
	not NULL before we dereference them.  Fixes ximian #5434.

2001-08-21  Larry Ewing  <lewing@ximian.com>

	* htmlclueflow.c (write_pre_tags): add some parens.

	* gtkhtml.c (gtk_html_set_paragraph_alignment): emit alignment
	changed signals for we we change the alignment.

2001-08-21  Radek Doulik  <rodo@ximian.com>

	* htmlclueflow.c (write_pre_tags): check for curr_tag != NULL as
	pointed out by danw

2001-08-20  Radek Doulik  <rodo@ximian.com>

	* htmlclueflow.c (html_clueflow_set_style): fix condition to avoid
	wrong indentation for H1

2001-08-17  Radek Doulik  <rodo@ximian.com>

	* keybindingsrc.{ms,emacs,xeamcs}: changed C-TAB rather to pure
	indent-more and S-C-TAB to indent-less

	* gtkhtml.c (insert_tab_or_indent_more_or_next_cell): new helper
	function for new GTK_HTML_COMMAND_INDENT_INC_OR_NEXT_CELL command

	* keybindingsrc.{ms,emacs,xeamcs}: added C-TAB for
	indent-more-or-next-cell

	* htmlengine-edit-cursor.c: added table and image cursor, fixed
	few problems

	* htmlcursor.h: added new type HTMLCursorRectangle

2001-08-16  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-cursor.c (move_rect): extracted helper function
	(clip_rect): ditto
	(draw_cursor_rectangle): new helper function
	(html_engine_draw_cell_cursor): new method for cell cursor
	drawing, uses draw_cursor_rectangle
	(html_engine_draw_cursor_in_area): call
	html_engine_draw_cell_cursor

	* htmlclueflow.c (update_item_number): don't update for non-items
	(op_cut): fixed few cases of item sequences and for crash in case
	that flow was whole deleted and destroyed

2001-08-15  Radek Doulik  <rodo@ximian.com>

	* htmlclueflow.c (get_pre_padding): don't handle ordered items
	differently
	(get_prev_relative_item): new helper function
	(get_next_relative_item): ditto
	(update_item_number): use new functions, allow lists to be
	interrupted by list with higher level
	(CLUEFLOW_ITEM_MARKER): make it 6 chars wide as number markers

	* gtkhtml.c (command): don't decrease indent on list item, rather
	just delete

	* htmlclueflow.c (save_plain): add padding even to empty lines,
	so we get item headings
	(plain_get_marker): new helper function
	(plain_padding): use plain_get_marker

	* htmlengine-edit-clueflowstyle.c: updated for list changes

	* htmlengine.c: rewritten/updated [un]ordered lists

	* htmlclueflow.c: rewritten/updated [un]ordered lists, implemented
	[un]ordered lists saving

	* htmlenums.h: redefined HTMLListType
	HTML_CLUEFLOW_STYLE_LIST_ITEM instead of plenty item types

	* gtkhtml.c (clueflow_style_to_paragraph_style): added item_type
	parametr
	(paragraph_style_to_clueflow_style): likewise

	* gtkhtml-enums.h: added
	GTK_HTML_COMMAND_PARAGRAPH_STYLE_ITEMALPHA command

2001-08-14  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (update_embedded): add begin/end painter calls
	around the update calls for things like HTMLImageInput.  

2001-08-13  Radek Doulik  <rodo@ximian.com>

	* htmlselection.c (test_point): new helper function
	(html_engine_point_in_selection): new method, tests if point is in
	the selection

	* htmlclueflow.c (merge): ops, remove HTML_CLUEV cast

	* gtkhtml.c (gtk_html_update_styles): exported

	* htmlengine-edit-table.c: be more careful about HTMLObject types

	* htmlimage.c (html_image_set_url): set object change flags on url
	change

	* htmlclueflow.c (merge): copy all fields

2001-08-09  Radek Doulik  <rodo@ximian.com>

	* htmlcursor.c (backward_in_flow): fixed. before, we could end
	between two text objects in the middle of the line

2001-08-10  Larry Ewing  <lewing@ximian.com>

	* gtkhtml.c (realize): if no one has put us in a scrolled window
	or set our adjustments go ahead and create the adjustments
	ourself.  This will prevent the widget from sefaulting in this
	case.

2001-08-09  Larry Ewing  <lewing@ximian.com>

	* htmlclueflow.c (save_plain): never let the requested length be
	less than zero.

2001-08-09  Joe Shaw  <joe@ximian.com>

	* gtkhtml.c (button_press_event): Don't grab the focus unless
	button 1 is pressed or, in editable mode, button 2 or 3 are
	pressed. This has the effect, in evolution, of allowing the folder
	tree or the message list to keep its focus if you use the mouse
	wheel in the message viewing pane.

2001-08-09  Radek Doulik  <rodo@ximian.com>

	* gtkhtml-enums.h: added grab-focus command

2001-08-08  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-selection-updater.c (updater_idle_callback):
	restore selection_mode flag

	* htmlselection.c (html_engine_disable_selection): disable
	selection mode

2001-08-07  Radek Doulik  <rodo@ximian.com>

	* testgtkhtml.c (redirectFilter): do not use g_free on memory
	allocated by HTAnchor_address

	* gtkhtml.c (button_press_event): disable selection mode
	(command): added GTK_HTML_COMMAND_COPY_AND_DISABLE_SELECTION
	command

	* gtkhtml-properties.c (gtk_html_class_properties_new): make ms
	bindings default

	* htmlcluev.c (check_point): fix for padding != 0

2001-08-06  Larry Ewing  <lewing@ximian.com>

	* htmlclue.c (op_helper): don't segfault in the assertion if the
	clue is empty.

2001-08-03  Radek Doulik  <rodo@ximian.com>

	* htmlengine.h: added block_selection flag

	* htmlselection.c (html_engine_activate_selection): test for
	block_selection
	(html_engine_block_selection): new helper function
	(html_engine_unblock_selection): ditto

	* htmlengine-edit-cut-and-paste.c (delete_object): send delete
	event
	(insert_empty_paragraph): replace empty text in new empty flow by
	text with current style

	* gtkhtml.c (gtk_html_editor_event): new helper function

	* gtkhtml-enums.h: added GTK_HTML_EDITOR_EVENT_DELETE

2001-08-02  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-table.c (table_set_bg_color): use gdk_color_copy
	and gdk_color_free instead of g_new and g_free

	* htmltablecell.c (save): save BACKGROUND as well

	* htmlobject.c (html_object_get_cursor): make cursor of non-text
	objects be at least 10 points high

2001-07-31  Larry Ewing  <lewing@ximian.com>

	* htmltable.c: wrap debug ouput with #ifdef GTKHTML_DEBUG_TABLE

	* htmlengine-edit-cut-and-paste.c: wrap debug ouput with #ifdef GTKHTML_DEBUG_TABLE

	* htmltextslave.c (draw_highlighted): remove debugging output.

2001-07-31  Radek Doulik  <rodo@ximian.com>

	* htmlfontmanager.c (html_font_set_init): use memset rather than
	bzero

	* htmlengine-edit-cursor.c (html_engine_hide_cursor): don't draw
	cursor here

	* htmltext.c (get_cursor_base): set base to Text coordinates if
	there are no slaves
	(get_cursor): if there are no slaves, use Text ascent/descent
	(html_text_op_cut_helper): remove text slaves
	(remove_text_slaves): new extracted function
	(fit_line): use remove_text_slaves

2001-07-30  Larry Ewing  <lewing@ximian.com>

	The following is a patch from Damian Ivereigh <damian@cisco.com>
	it has only the slight modification of moving the new members into
	the priv structure rather than the public one.
	
	* htmlengine-edit-cut-and-paste.c (html_engine_copy_object): add
	new function.
	(html_engine_copy): use html_engine_copy_object.

	* htmlengine-edit-cut-and-paste.h: add html_engine_copy_object.

	* gtkhtml-private.h: add holders for the primary selection.

	* gtkhtml.h: change the request_paste prototype.

	* gtkhtml.c (button_press_event): update the primary selection.
	and set in selection when if we've selected a word or line.
	(button_release_event): copy to the primary selection.
	(selection_get): get the selection based on which one atom is
	passed.
	(selection_received): distinguish between the clipboard and
	primary.  Pass the selection type when we recurse.
	(gtk_html_request_paste): add atom type parameter and pass it
	along when we convert.
	(init): initialize the primary selection holders and add the
	clipboard target.
	(gtk_html_cut): cut to the clipboard.
	(gtk_html_copy): copy to the clipboard.
	(gtk_html_paste): paste from the clipboard.

2001-07-30  Radek Doulik  <rodo@ximian.com>

	* htmlclueflow.c (pref_right_margin): reuse old hack to keep plain
	text editing work, before I fix aligned objects calculation

2001-07-26  Chema Celorio  <chema@celorio.com>

	* htmlimage.c (html_image_factory_area_updated): remove a
	g_warning

2001-07-27  Radek Doulik  <rodo@ximian.com>

	* htmlclueflow.c (write_pre_tags): test if flow doesn't contain
	table, in this case we don't want to save <BR> or \n

	* htmltablecell.c (save): commnted out my hack for &nbsp; saving
	to empty cells

	* htmlengine.c (parse_table): insert empty paragraph in empty
	cells

2001-07-26  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (gtk_html_command): update styles if needed

	* gtkhtml-enums.h: added commands for delete table/row/col/cell
	contents

	* gtkhtml.c (command): use gtk_html_undo/redo rather than
	html_engine_ ones

	* htmltablecell.c (merge): fixed cells merging

	* gtkhtml.c (command): set update_styles for more commands
	(update_styles): fixed indentation change signal emiting
	(key_press_event): don't check cursor position for update, it's
	obsolete

2001-07-25  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-table.c (html_engine_table_set_spacing): added
	relative parameter
	(html_engine_table_set_padding): ditto
	(table_set_padding): check for t != NULL
	(table_set_spacing): ditto

	* keybindingsrc.ms: added bindings for table spacing/padding, I
	must change spell checking bindings to avoid conflicts :-(

	* gtkhtml-enums.h: added new command for table spacing/padding
	change

2001-07-25  Jon Trowbridge  <trow@ximian.com>

	* htmlsearch.c (html_search_set_forward): Check that
	search != NULL. (Bug #4869)

2001-07-24  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-table.c (html_engine_get_table): don't fail,
	just return NULL

	* htmlengine-edit-tablecell.c (html_engine_get_table_cell): don't
	fail, just return NULL

	* htmlengine-edit-cut-and-paste.c (append_object): remove unwanted
	empty flows, fix cursor position

	* htmlengine-edit.c (html_engine_next_cell): fixed for multi flow
	cells
	(html_engine_prev_cell): likewise

	* htmlengine-edit-tablecell.c
	(html_engine_delete_table_cell_contents): new method

	* htmlengine-edit-table.c (html_engine_delete_table): new method

2001-07-23  Jon Trowbridge  <trow@ximian.com>

	* htmlengine-search.c (html_engine_search_set_forward): Added.
	Allows you to change the direction of an on-going search.

	* gtkhtml-search.c (gtk_html_engine_search_set_forward): Added.
	Allows you to change the direction of an on-going search.

2001-07-23  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-clueflowstyle.c: remove undo field as it's not
	needed
	(undo_or_redo): use dir parameter
	(style_operation_new): remove undo parameter

	* htmlengine-edit-table.c (html_engine_table_goto_0_0): fixed loop
	condition
	(html_engine_table_goto_0_0): renamed, exported
	(html_engine_table_goto_col): likewise
	(html_engine_table_goto_row): likewise
	(html_engine_table_goto_pos): likewise

2001-07-20  Radek Doulik  <rodo@ximian.com>

	* htmlcursor.c: reverted ettore's revert of begin/end line
	enhancement for table cells, because otherwise it breaks prev/next
	cell methods. I hope to consult that with ettore to find out
	solution for his "cursor is going outside document range" problem

	* htmlengine-edit-table.c (goto_col): new helper function
	(goto_row): likewise
	(goto_begin): likewise
	(html_engine_table_set_rows): new method
	(html_engine_table_set_cols): new method

	* htmlengine-edit.c (html_engine_next_cell): new function,
	extracted
	(html_engine_prev_cell): new function, extracted

2001-07-19  Larry Ewing  <lewing@ximian.com>

	* gtkhtml-stream.c (gtk_html_stream_new): add a types function
	that returns the supported content types on the stream.  Now it is
	possible for the app to figure out wether or not it should wrap
	image data in html for display.
	(stream_log_types): add a log implementation of the types function.
	(gtk_html_stream_log_new): take an already existing stream instead
	of all the component parts, this makes it slightly easier to log
	random streams.
	(gtk_html_stream_get_types): get the supported content types of a
	given stream.

	* gtkhtml-stream.h: add gtk_html_stream_get_types and fixup other
	prototypes.

	* gtkhtml-types.h: add GtkHTMLStreamTypesFunc typedef.

	* htmlengine.c (html_engine_stream_types): add engine
	stream_types.
	(html_engine_stream_write): renamed from html_engine_write.
	(html_engine_strean_end): renamed from html_engine_end.
	(html_engine_begin): use the reworked html_stream_log_new function.

	* htmlimage.c (html_image_factory_types): add a simple stream type
	function.
	(html_image_pointer_load): add the types function.

2001-07-18  Radek Doulik  <rodo@ximian.com>

	* htmlengine.c (html_engine_get_max_width): change return value to
	gint, take care to return values > 0

2001-07-17  Larry Ewing  <lewing@ximian.com>

	* htmlobject.c (html_object_get_uris): #if 0 this unused function.
	
	* htmlimage.c (html_image_factory_get_engine): #if 0 it out.

2001-07-17  Radek Doulik  <rodo@ximian.com>

	* htmltokenizer.c (html_tokenizer_real_end): return blocked tokens
	to tokenizer

	* gtkhtml.c (delete_one): take care of cursor offset when
	deleteing container

	* htmlengine-edit-cut-and-paste.c (delete_object_do): removed
	expected_len hack

	* htmltable.c (cut_partial): don't shrink when start_col ==
	end_col

	* htmlengine.c (html_engine_calc_size): set max_width to MAX(view
	width, min_width)

	* htmlclueflow.c (calc_size): do not allow width exceed max_width

2001-07-17  Larry Ewing  <lewing@ximian.com>

	* gtkhtml-embedded.c: add some missing documentation.

2001-07-13  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (parse_table): initialize cellwidth_percent and
	cellheight_percent each time through the loop.

2001-07-12  Larry Ewing  <lewing@ximian.com>

	* gtkhtml-stream.h: add types include.

2001-07-08  Larry Ewing  <lewing@ximian.com>

	Chema <chema@ximian.com> pointed out that we were inheriting a lot
	of includes from <libgnomeprint/gnome-print.h> which is getting
	cleaned up in the gnome-print trunk.  This is basically his patch
	minus a couple things I didn't want to do yet.
	
	* htmltokenizer.c: add gtkobject include.

	* htmltextinput.c: add gtksignal include.
	* htmlgdkpainter.c: same.

	* htmltable.c: include stdio.h.
	* htmltextslave.c: same. 
	* htmlengine.c: same.
	* gtkhtmldebug.c: same.
	* htmlengine-edit-cut-and-paste.c: same.

	* htmltablecell.c (merge): use g_print.
	* htmlengine-edit-table.c (html_engine_insert_table_row): same.

	* htmlimage.c (get_src): add missing prototype.  use g_print.

	* htmlform.h: add gtkradiobutton.h include.

	* htmlengine-edit-text.c (upper_lower): remove debugging printf.

	* gtkhtml-stream.c: add missing includes.

2001-07-05  Larry Ewing  <lewing@ximian.com>

	* gtkhtml.c (focus): add Jacobs temporary fix to let focus work
	better.

2001-07-02  Larry Ewing  <lewing@ximian.com>

	* htmlimage.c (html_image_class_init): hook up get_src.
	(get_src): add get_src implementation.

	* htmlobject.h: add html_object_get_src prototype, and get_src
	class method.

	* htmlobject.c (get_src): add default get_src implementation.
	(html_object_get_src): add public method for getting source url.

2001-07-01  Larry Ewing  <lewing@ximian.com>

	* htmltext.c (set_link): respect new semantics.

	* htmllinktext.h (html_link_text_to_text): remove unused
	prototype.

	* htmllinktext.c (set_link): make this respect the new set_link
	semantics.
	(remove_link): removed.
	(html_link_text_set_url): remove this completely unused function.
	
	* htmlobject.h: remove remove_link from the class structure,
	html_object_set_link (o, color, NULL, NULL) has the same effect
	now and we might as well clean up the class structure a little.

	* htmlobject.c (html_object_remove_link): make remove_link proxy
	to set_link.

	* htmlimage.c (set_link): clean this up a little.
	(html_image_init): fix dup target not url.
	(remove_link): removed.
	(html_image_class_init): remove remove_link.
	(html_image_factory_area_updated): add area_updated handler.
	(html_image_factory_register): connect handler.

	* htmlpainter.c (html_painter_set_font_face): remove redundant if.

	* htmlframe.c (calc_size): use html_frame_set_scrolling.

2001-06-29  Ettore Perazzoli  <ettore@ximian.com>

	I am reverting Radek's changes of 2001-06-21 as they make cursor
	movement at the beginning or the end of the document behave
	erratically.

	* htmlcursor.c (forward_in_flow): `#if 0'ed out.
	(backward_in_flow): Likewise.
	(html_cursor_end_of_line): Use `forward()' instead of
	`forward_in_flow()'.
	(html_cursor_end_of_line): Use `backward()' instead of
	`backward_in_flow()'.

2001-06-26  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (command): renamed SET_MARK to SELECTION_MODE, use
	selection mode flag
	(cursor_move): use selection mode flag
	(load_keybindings): added more hardwired bindings

	* htmlengine.h: added selection_mode flag

	* htmlengine.c (html_engine_get_view_width): don't allow width < 0
	(html_engine_get_view_height): likewise

2001-06-25  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (delete_one): new helper function, deletes container
	or cursor position +/-1

	* htmlengine-edit-cut-and-paste.c (html_engine_delete_container):
	new function, deletes whole container

	* htmlfontmanager.c (get_real_font_size): redone, now it's more
	similiar to mozilla font scaling

	* gtkhtml.c (gtk_html_set_magnification): don't allow sizes < 4

2001-06-23  Larry Ewing  <lewing@ximian.com>

	* htmltokenizer.c (add_byte): new function to sanitize invalid
	utf-8 strings.
	(in_plain): use add_byte.

2001-06-21  Radek Doulik  <rodo@ximian.com>

	* htmlcursor.c (forward_in_flow): new helper function
	(backward_in_flow): ditto
	(html_cursor_end_of_line): use forward_in_flow
	(html_cursor_beginning_of_line): use backward_in_flow

	* htmltable.c (calc_column_width_step): removed hopefully last
	forgoten substract by table->padding

2001-06-20  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (parse_halign): helper function to parse halign
	values.
	(add_pending_paragraph_break): move this logic that is duplicated
	in several places into a function.
	(parse_table): use parse_halign, and add_pending_paragraph.
	(parse_a): small cleanups, add id logic.
	(parse_f): remove redundant NULL checks.
	(parse_s): ditto.
	(parse_h): use parse_halign.
	(parse_p): ditto.
	(parse_d): ditto.
	(parse_l): use add_pending_paragraph.
	(append_element): ditto.
	(parse_o): rework if statement.
	(parse_u): ditto.

2001-06-20  Radek Doulik  <rodo@ximian.com>

	* htmlcluev.c (find_free_area): uncomment loop break try_y ==
	next_y - not sure why it was commented out, I am going to
	investigate it more

	* gtkhtml.c (set_magnification): new helper function
	(gtk_html_set_magnification): make it work for pages with
	frames/iframes

2001-06-19  Radek Doulik  <rodo@ximian.com>

	* htmltablecell.c (calc_min_width): use parent method

	* htmltable.c (calc_column_width_step): don't add padding
	(html_table_set_cells_max_width): don't substract padding

	* htmlcluev.c (get_right_margin): substract 2 * padding
	(do_layout): fix for padding
	(calc_min_width): new method, takes care for padding
	(calc_preferred_width): ditto
	(set_max_width): fix for padding

	* htmlobject.c (html_object_get_left_margin): added painter parameter
	(html_object_get_right_margin): ditto

	* htmlgdkpainter.c (alloc_e_font_try): added medium, bold, roman,
	italic parameters
	(try_font_possible_names): new function, try more weights/slants
	(alloc_e_font): use try_font_possible_names
	(alloc_e_font_try): don't allow sizes < 0

2001-06-18  Radek Doulik  <rodo@ximian.com>

	* htmlfontmanager.c (html_font_manager_clear_font_cache): new
	method
	(html_font_manager_set_magnification): ditto

	* gtkhtml.c (gtk_html_set_magnification): new method, sets
	magnification, which is used for font sizes.
	(gtk_html_zoom_in): new method
	(gtk_html_zoom_out): ditto
	(gtk_html_zoom_reset): ditto
	(load_keybindings): bind C-=/C--/C-8 and keypad C-+/C--/C-* for
	zooming
	(button_press_event): bind C-scroll wheel to zooming,
	unfortunatelly Gtk is a little broken and doesn't pass these
	events to widgets with visible scrollbars :-(
	(gtk_html_command): renamed from gtk_html_editor_command

	* gtkhtml-enums.h: new commands for zooming

	* htmlframeset.c (set_max_width): implemented

	* gtkhtml.c (gtk_html_set_iframe_parent): added frame parameter,
	remember frame in html

	* htmlengine.c (html_engine_get_max_width): take care of FRAMES
	and IFRAMES

	* gtkhtmldebug.c (gtk_html_debug_dump_object): added FRAME and
	FRAMESET

	* gtkhtml.h: added frame pointer

2001-06-14  Radek Doulik  <rodo@ximian.com>

	* htmlgdkpainter.c (alloc_e_font_it_known): handle NULL face
	properly
	(alloc_e_font_it_known): new helper function, extracted
	(alloc_e_font_it): 1st try to load exact size font, if not
	available then try to look for nearest size

	* htmlengine-edit-table.c (table_set_border_width): don't allow
	border < 0

2001-06-13  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-table.c (table_set_bg_color): free bgColor
	before set it to NULL

2001-06-12  Radek Doulik  <rodo@ximian.com>

	* htmltable.c (html_table_end_table): check for table->cells
	[r][c]

2001-06-11  Radek Doulik  <rodo@ximian.com>

	* htmltablecell.c (save): save &nbsp; to empty cells

	* htmltable.c (check_point): check for valid column
	(html_table_end_table): remove empty cells

	* gtkhtml.c (replace_nbsp): new helper function
	(selection_get): replace &nbsp; with ' ' for
	STRING/TEXT/COMPOUND_TEXT

	* htmlengine-edit-table.c (html_engine_insert_table): new function

2001-06-08  Radek Doulik  <rodo@ximian.com>

	* htmltokenizer.c (in_comment): don't allow comment end like this
	-a->

2001-06-07  Radek Doulik  <rodo@ximian.com>

	* Makefile.am (INCLUDES): added IMLIB cflags

	* htmlengine-edit-cut-and-paste.c (delete_object): check table
	only when cursor and mark are in non-empty flows
	(insert_object_do): be more careful about paragraph inserting
	around tables
	(insert_empty_paragraph): new extracted method, use undo direction
	(html_engine_insert_empty_paragraph): use insert_empty_paragraph
	(append_object): increment len by 2 when splitting

	* htmlclueflow.c (op_helper): don't handle tables specialy

	* htmlenumutils.c (html_valign_name): return "middle" MIDDLE value
	instead of "center"

	* htmlengine-edit-cut-and-paste.c (append_object): freeze/thaw
	engine and set changes
	(html_engine_append_object): removed freeze/thaw here
	(insert_object): moved tables fix here (from insert_object_do as
	we don't want two UNDO steps to be created)

	* htmlinterval.c (html_interval_flat): make this method public
	(html_interval_select): use flat interval

	* htmltext.c (word_get_position): kill warning

2001-06-05  Larry Ewing  <lewing@ximian.com>

	* htmlframe.c (html_frame_init): attach submit to frame_submit.
	(frame_submit): proxy signal, needs a little more love.

	* htmltextinput.c (html_text_input_key_pressed): fix a stupid cut
	& paste bug so that the enter handler actually works.

	* htmlradio.c (html_radio_init): call html_form_add_radio and
	change protype.
	(html_radio_new): change prototype.

	* htmlradio.h (html_radio_new): change prototype.

	* htmlengine.c (parse_input): fix to html_radio_new to match the
	new protoype.

	* htmlform.h: add prototype for html_form_add_radio.

	* htmlform.c (html_form_destroy): free the group hash.
	(html_form_add_radio): new function to handle radio groups
	correctly.
	(destroy_radio): helper to destroy the has entries.

2001-06-05  Radek Doulik  <rodo@ximian.com>

	* htmltablecell.c (calc_min_width): fixed for NOWRAP and
	non-fixed-width case

2001-06-04  Larry Ewing  <lewing@ximian.com>

	* htmltextinput.c (html_text_input_key_pressed): Make enter focus
	on the next widget or submit the form if there are no more
	widgets.  This is based on a patch by someone who's name I can't
	find, I'll update this entry when I do.
	(html_text_input_init): attach html_text_input_key_pressed to the
	widget.

	* htmlengine.c (html_engine_destroy): destroy the stacks we had
	missed.
	(parse_f): destroy the frame if we don't add it.
	(parse_iframe): add disabled code to use frame here.
	(html_engine_stop_parser): clear the frame stack.

2001-06-02  Larry Ewing  <lewing@ximian.com>

	* htmlframe.c (destroy): free the url.
	(html_frame_init): set the initial margins on the frame to 0 this
	seems to be what mozilla does.

	* htmlframeset.c (calc_size): free the temp arrays.

2001-06-01  Larry Ewing  <lewing@ximian.com>

	* htmltablecell.c (calc_min_width): fix the logic so that
	min_width doesn't return larger than needed be we still break the
	loop.

	* htmlframe.c (calc_min_width): Fix the logic for frames that have
	a specified width;

	* htmlframe.c (frame_url_requested): increment cur in the loop.
	(set_max_width): if the size is given the min width is

	* htmltablecell.c (calc_min_width): break the resize loop that was
	occuring when no_wrap and HTML_OBJECT_FLAGS_FIXED_WIDTH were both
	set (fixes http://bugzilla.helixcode.com/show_bug.cgi?id=3164).
	
2001-05-31  Larry Ewing  <lewing@ximian.com>

	* htmlframe.c (check_point): take the scrolling into account when
	doing check_point.

	* htmlframeset.c (html_frameset_init): ugh, fix bug introduced in
	the reworking.

	* htmlshape.c (html_shape_point): remove silly macros and fix
	distance macro so that circles actually work.

	* htmlimage.c (image_update_url): fix this properly this time.

	* htmlshape.c (html_shape_point): add tests for poly and default.
	(html_shape_new): move from separate shape structures to a single
	structure with a pointer array holding HTMLLengths.  I still need
	to add support for actually using the percentage lengths.

	* htmlshape.h: add prototypes for HTMLLength functions.

	* htmlframeset.c (html_frameset_init): move the HTMLLength
	functions into htmlshape since we can use them there, and make
	them public.

	* htmlengine.c (parse_a): let the shape routine figure out if the
	shape is valid if we have either a type or coords.

	* htmlimage.c (image_update_url): translate x and y by o->x and o->y.

2001-05-31  Larry Ewing  <lewing@ximian.com>

	* htmlimage.c (html_image_set_map): rename and add ismap logic. 
	(destroy): free final_url.
	(copy): copy new members.
	(image_update_url): add ismap logic.
	(html_image_init): initialize new members.

	* htmlimage.h: Add ismap and final_url members.

	* htmlengine.c (parse_i): add ismap support.

2001-05-30  Radek Doulik  <rodo@ximian.com>

	* htmltablecell.c (save): save align/valign

	* htmlobject.c (set_painter): as below
	(html_object_set_painter): as below, simplyfied

	* htmliframe.c (set_painter): as below

	* htmlframe.c (set_painter): removed max_width parameter

	* htmlengine.c (html_engine_set_painter): don't call
	html_object_clear_word_width as it's no more needed
	(html_engine_set_painter): don't call calc_min_width as this is
	also no more needed
	(html_engine_set_painter): don't compute max_width as it's now
	handled properly in calc_size using get_page_width/height
	(html_engine_calc_size): use get_page_width/height, simplified
	(get_max_width): new helper function

	* htmlclueflow.c (pref_right_margin): removed obsolete method
	(calc_size): use html_object_get_right_margin instead of
	pref_right_margin
	(calc_size): take care of PRE when calling fit_line

	* gtkhtml.c (size_allocate): do calc size always

	* htmlprinter.c (class_init): as below

	* htmlplainpainter.c (class_init): as below

	* htmlgdkpainter.c (class_init): implemented and plugged in new
	virtual methods

	* htmlpainter.h: added new virtual methods get_page_width/height

	* htmltablecell.c (save): updated to use percent_width
	(html_table_cell_init): initialize percent_width, percent_height

	* htmlengine-edit-tablecell.c (html_engine_table_cell_set_width):
	new function

	* htmltablecell.c (save): use heading
	(save): use no_wrap

	* htmlengine-edit-tablecell.c
	(html_engine_table_cell_set_no_wrap): new function
	(html_engine_table_cell_set_heading): ditto

	* htmlclueflow.c (get_default_font_style): take care of heading
	cells
	(html_clueflow_get_halignment): ditto

	* htmltablecell.h: added heading flag

	* htmlengine.c (parse_table): use Cell::no_wrap instead of setting
	NOWRAP style, which has been removed (now we can have nowrap cells
	with all possible clueflow styles, which was before impossible)
	(parse_table): remember heading in cell

	* htmltablecell.h: added no_wrap flag

	* htmltablecell.c (calc_min_width): use no_wrap

2001-05-30  Larry Ewing  <lewing@ximian.com>

	* htmlimage.c (image_update_url): temp hack to piggyback url
	selection onto point calculation.  
	(check_point): call image_update_url.
	(html_image_set_usemap): add.
	(html_image_init): initialize usemap.
	(destroy): free usemap.
	(copy): dup usemap.

	* htmlimage.h: add html_image_set_usemap prototype, and usemap
	member.

	* htmlmap.h: format change ;)

	* htmlengine.c (parse_i): add the map to the image
	(parse_m): fix length.

	* htmlframeset.c (calc_min_width): add hack to force size
	calculation when the widget gets a new allocation.
	(forall): fix this.
	(is_container): add.
	remove debug g_warnings.

2001-05-29  Larry Ewing  <lewing@ximian.com>

	* htmltokenizer.c (end_tag): remove frameset warnings.

	* htmlengine.h: add new members for frame and map support.

	* htmlengine.c (close_anchor): remove extra if.
	(parse_frameset): new function to handle framsets.
	(parse_iframe): cleanup attribute parsing, add stubs.
	(parse_a): add initial area handling, misc cleanups.
	(parse_f): add frame and frameset parsing.
	(parse_m): add initial map handling.
	(parse_n): add stub fror noframe handling.
	(html_engine_init): initialize framestack and map.

	* htmlclueflow.c (save_plain): fix the wraping function that was
	broken in the move to g_unicode.

	* htmlenums.h: add new types.

	* htmltype.c (html_types_init): init new types.
	(html_type_name): add new types.

	* htmltypes.h: add new types.

	* Makefile.am: add new files.

	* gtkhtml.c (on_object): remove redundant checks.
	(set_pointer_url): move logic here.

	* htmlframeset.h:
	* htmlframeset.c:
	* htmlframe.c:
	* htmlframe.h:
	* htmlmap.c:
	* htmlmap.h:
	* htmlshape.c:
	* htmlshape.h: Commit pending files without hooking them into the
	build so that I can use cvs to track revisions.

2001-05-29  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-clueflowstyle.c
	(html_engine_get_current_clueflow_alignment): use
	html_clueflow_get_halignment

	* htmlengine.c (parse_table): use halign of table cells
	(parse_c): </center> resets divAlign to NONE
	(html_engine_parse): initialize divAlign to NONE
	(parse_table): for non-heading table cells init halign to NONE

	* htmlclueflow.c (html_clueflow_get_halignment): if halign ==
	NONE, then try to use parent cell halign

2001-05-29  Larry Ewing  <lewing@ximian.com>

	* gtkhtml.c (set_pointer_url): add helper function.

	* htmltablecell.c (save): save rowspan and colspan when writing
	the table back out.

2001-05-28  Larry Ewing  <lewing@ximian.com>

	* htmlclueflow.c (html_clueflow_get_line_offset): initialize o it
	was never getting set.

2001-05-25  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-cut-and-paste.c (check_table_0): new helper
	function
	(check_table_1): ditto
	(delete_object): shrink selection before delete (for some table
	related cases)

2001-05-24  Radek Doulik  <rodo@ximian.com>

	* replaced HTML_VALIGN_CENTER with HTML_VALIGN_MIDDLE everywhere

	* htmlengine.c (parse_i): replace align=center with align=middle
	according to standard

2001-05-23  Larry Ewing  <lewing@ximian.com>

	* htmlprinter.c (draw_text): terminate the temporary string at the
	last character, not the last character + 1.

	* htmltokenizer.c (end_tag): do not discard the line feeds
	following a opening tag inside a pre tag, but discard them
	otherwise.  This should avoid the unintentional spaces introduced
	by the previous change.

2001-05-22  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (parse_d): close the flow unconditionaly for dd but
	only change the indent level if we are in a list.

	* htmltokenizer.c (end_tag): only discard the first LF in an
	opening tag if it is a pre or textarea element (fixes
	http://bugzilla.helixcode.com/show_bug.cgi?id=2093)
	
2001-05-22  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-tablecell.c (html_engine_table_cell_set_valign):
	new method
	(html_engine_table_cell_set_halign): ditto

	* htmltablecell.c (html_table_cell_init): changed initial
	alignment

	* htmlengine-edit-tablecell.c
	(html_engine_table_cell_set_bg_color): new method
	(html_engine_table_cell_set_bg_pixmap): ditto
	(html_engine_get_table_cell): ditto

2001-05-21  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-table.c (html_engine_table_set_align): updated
	to use ClueAligned
	(html_engine_table_set_width): new function

2001-05-18  Radek Doulik  <rodo@ximian.com>

	* htmlengine.c (parse_table): added support for align=left/right
	for tables

	* htmlengine-edit-table.c (html_engine_table_set_align): new
	function

2001-05-18  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (parse_d): fix dt rendering so that it always
	splits the flow, even outside of dl, this is "feature" of
	netscape/mozilla is used in several prominant places like bonsai
	(fixes http://bugzilla.helixcode.com/show_bug.cgi?id=2043).

2001-05-17  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (parse_f): fix color parsing so that it pushes the
	current color rather than black if no color is specified (fixes
	http://bugzilla.ximian.com/show_bug.cgi?id=2911).

2001-05-17  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-table.c (html_engine_table_set_bg_color): alloc
	space for new color if needed

	* htmltablecell.h: removed padding

	* htmlengine-edit-table.c (new_cell): don't set cell background
	from table (it's resolved dynamically now)
	(html_engine_table_set_bg_color): allow NULL c which means disable
	bg color
	(html_engine_get_table): new helper function
	(html_engine_table_set_padding): new method
	(html_engine_table_set_border_width): added t parameter

	* htmlimage.c (html_image_pointer_load): ref image pointer
	(html_image_factory_register): don't ref image pointer before
	loading (it's done in load now) but ref all image pointers (for
	register)
	(html_image_factory_unregister): unref image pointer in unregister

	* htmltablecell.c (draw_background_helper): use table bg pixmap if
	needed

	* htmlengine.c (parse_table): don't use table bg pixmap as starting
	row bg pixmap

	* htmlengine-edit-table.c (html_engine_table_set_bg_color): new
	method
	(html_engine_table_set_bg_pixmap): new method

	* htmlengine.c (parse_table): don't use table bg color as starting
	row color

	* htmltablecell.c (draw_background_helper): use table bg color if
	needed

2001-05-15  Radek Doulik  <rodo@ximian.com>

	* htmltablecell.h (HTML_IS_TABLE_CELL): renamed from
	IS_HTML_TABLE_CELL

	* tabs should work now nicely for plain text mode and for PRE

2001-05-10  Jon Trowbridge  <trow@ximian.com>

	* htmliframe.c (html_iframe_init): When rendering a frame, make
	sure that you use the same kind of tokenizer as is being used
	by the parent widget.

	* htmltokenizer.c (html_tokenizer_class_init): Change "begin" and
	"end" from virtual functions to signals with the HTMLTokenizer's
	traditional begin and end behavior as the default handlers.  Add
	the "fully_tokenized" signal.
	(html_tokenizer_begin): Replace the virtual function machinery
	with a signal emission.
	(html_tokenizer_end): Replace the virtual function machinery with
	a signal emission.
	 (html_tokenizer_clone): Added.  Allocates a tokenizer of the same
	type.

2001-05-10  Larry Ewing  <lewing@ximian.com>

	* gtkhtml.c (mouse_change_pos): make the magic distance threshold
	depend on the space width.
	(focus): start of new focus handler.

	* htmltext.c: update the magic url matching regex to handle
	unsername:passwd@ and % escapes and keep trailing slash.

2001-05-09  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (parse_color): rework the code to handle broken
	color specifications the same way netscape and mozilla do.  We
	were still missing one case.

2001-05-09  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (command): added insert-tab and
	insert-tab-or-indent-more commands

	* htmltokenizer.c (in_comment): allow all characters to be between
	-- and > on comment end (it's not as standard says, but we
	probably want to act the same as netscape and mozilla)

2001-05-08  Radek Doulik  <rodo@ximian.com>

	* htmltextslave.c (draw_spell_errors): updated

	* htmlgdkpainter.c (draw_spell_error): updated

	* htmlpainter.c (html_painter_draw_text): don't draw when
	drawed_len > len
	(html_painter_draw_spell_error): removed off parameter, now we
	call draw_spell_error with exact x position and text which should
	be error-highlighted

	* htmlgdkpainter.c (draw_spell_error): use line_offset

	* gtkhtml-properties.c: added select prev/next word commands

	* gtkhtml.c (move_selection): select prev/next word

	* htmlpainter.c (html_painter_draw_text): slightly refactored

2001-05-07  Radek Doulik  <rodo@ximian.com>

	* htmltextslave.c (draw_normal): use line_offset
	(draw_highlighted): ditto
	(get_offset_for_pointer): ditto

	* htmltext.c (offset_to_line_offset): new helper function
	(get_line_length): new method implementation
	(html_text_get_line_offset): new method
	(html_text_get_line_offset_at_offset): new method
	(calc_word_width): added line_offset parameter
	(html_text_request_word_width): use line_offset
	(get_cursor_base): use line_offset

	* htmlpainter.c (html_painter_calc_text_width): added line_offset
	parameter, handle tabs properly
	(html_painter_draw_text): ditto

	* htmlobject.c (get_line_length): new generic method
	implementation
	(html_object_get_line_length): new method, returns length in
	line_offset metric (offset with tabs expanded)

	* htmlclueflow.c (html_clueflow_get_line_offset): new function

2001-05-04  Radek Doulik  <rodo@ximian.com>

	* htmltokenizer.c (html_tokenizer_add_pending): add '\t' for tab,
	not spaces
	removed prePos counter

2001-05-06  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (parse_input): add missing break, thanks go to
	"Giancarlo Capella" <capella@teleion.it> for finding this.
	(parse_body): s/p/e/

2001-05-03  Larry Ewing  <lewing@ximian.com>

	* htmliframe.c (calc_size): use either e_scroll_frame or scrolled
	window.
	(html_iframe_init): ditto.

2001-05-06  Jon Trowbridge  <trow@ximian.com>

	* htmltext.c (text_len): Call g_utf8_validate on the string
	before g_utf8_strlen-ing it.

	* htmltypes.h: Added typedef for HTMLTokenizerClass.

	* htmlengine.c (html_engine_set_tokenizer): Added.  Allows the
	HTMLEngine's tokenizer to be changed.

	* htmltokenizer.c: Converted HTMLTokenizer to be a GtkObject with
	a vtable for the basic operations.  Renamed the existing functions
	as html_tokenizer_real_foo and made them the default vtable
	entries for HTMLTokenizerClass.  Changed the html_tokenizer_foo
	functions to just be wrappers around calls to the appropriate
	vtable entries.  The previous struct HTMLTokenizer, which was
	totally private, is now struct _HTMLTokenizerPrivate.  Lots of
	references to entries in that struct have been changed to reflect
	all of the renaming, but no non-trivial changes were needed to
	make everything work.

2001-05-03  Radek Doulik  <rodo@ximian.com>

	* htmlundo.c (html_undo_do_undo): block events during undo/redo
	(html_undo_do_redo): ditto

	* htmlengine-edit-cut-and-paste.c (delete_object_do): move cursor
	to right position after cut & merge

	* htmlclue.c (op_helper): append only non-null cut/copied objects
	to result

	* htmlclueflow.c (could_merge): new helper function, extracted
	from merge
	(op_helper): new helper function, extracted from op_cut and
	op_copy
	(op_helper): take care of operations which boundary begins/ends on
	table end/begin

	* gtkhtml.c (gtk_html_editor_event_command): take care of
	block_events flag

	* htmlengine.h: added block_events flag

	* gtkhtml.c (gtk_html_undo): added update_styles call
	(gtk_html_redo): ditto

	* htmlenums.h: added HTML_ENGINE_SET_CLUEFLOW_INDENTATION_ALL

	* htmlengine-edit-cut-and-paste.c (append_object):
	added dir parameter
	(append_object): new method, extracted from
	html_engine_append_object
	(insert_object_do): added dir parameter

2001-05-02  Larry Ewing  <lewing@ximian.com>

	* gtkhtml.c (gtk_html_load_from_string): use stream_write instead
	of write.

	* gtkhtml.h: remove unused prototype.

	* gtkhtml-stream.h: remove prototypes for nonexistant functions.

	* htmlengine.c (parse_iframe): parse the frameborder option, and
	cleanup the width/height parsing.

2001-04-30  Radek Doulik  <rodo@ximian.com>

	* gtkhtml-properties.c: Frederic Crozat <fcrozat@mandrakesoft.com>
	- This patch (against gtkhtml 0.9.2) adds a missing include and therefore
	remove a warning when compiling with latest glibc (2.2.2)

2001-04-29  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit.c (html_engine_spell_check_range): if (begin)
	object hasn't parent just return

	* htmlclueflow.c (html_clueflow_spell_check): keep
	g_return_if_fail as spell_checking fail is not fatal, so we want
	only warning and no crash

	* htmlengine-edit.c (html_engine_spell_check_range): check if
	object has parent and if it's clueflow

2001-04-27  Larry Ewing  <lewing@ximian.com>

	* htmlclueflow.c (html_clueflow_spell_check): change assertion
	into g_return_if_fails to keep the flow == NULL case from being
	fatal until it can be looked into more deeply.

2001-04-27  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-cut-and-paste.c (set_cursor_at_end_of_object):
	new extracted function, sets cursor to end of object and adds len
	to the cursor position
	(insert_object_do): ops, moved set_cursor_at_end_of_object to
	right place

	* htmltable.c (cut_partial): don't merge if start == end

	* htmlobject.c (html_object_get_bound_list): test for list->next
	also to avoid leafs

	* htmlengine-edit-cut-and-paste.c (remove_empty_and_merge): don't
	test left == NULL resp. right == NULL as it's already tested above
	(insert_object_do): use html_object_heads_list and
	html_object_tails_list
	(get_tree_bounds_for_merge): remove - obsolete
	(html_object_heads_list and html_object_tails_list extracted from
	this one

	* htmlobject.c (html_object_tails_list): new (extracted) method
	(html_object_heads_list): ditto
	(html_object_merge_down): new method
	(merge_down): new helper function

	* htmltable.c (cut_partial): take care of case when cursor is on
	table boundary
	(cut_partial): when start_col == end_col, merge approriate cells

2001-04-25  Dan Winship  <danw@ximian.com>

	* gtkhtml.c, htmlclueflow.c, htmlcursor.c, htmlcursor.h,
	htmlengine-edit-cut-and-paste.c, htmlengine-edit-movement.c,
	htmlengine-edit.c, htmlengine-edit.h, htmlengine-save.c,
	htmlengine-search.c, htmlengine.c, htmlentity.c, htmlgdkpainter.c,
	htmlinterval.c, htmlplainpainter.c, htmlprinter.c, htmlsearch.c,
	htmltext.c, htmltext.h, htmltextslave.c, htmltokenizer.c,
	htmltokenizer.h:
	Replace libunicode calls with gunicode and e-unicode calls. 

2001-04-25  Radek Doulik  <rodo@ximian.com>

	* htmlengine.c (html_engine_schedule_redraw): new functions,
	schedules redraw to be done in idle time
	(html_engine_block_redraw): block redraw until unblock is called
	(html_engine_unblock_redraw): unblock redraws, redraw if needed

	* gtkhtml.c (command): new commands - block/unblock redraw

	* htmlselection.c (html_engine_activate_selection): activate only
	if widget is already realized

	* htmlobject.c (destroy): free object data
	(html_object_set_data): change type of value to gchar *
	(html_object_get_parent_level): new method, returns depth in tree
	(number of parents)

	* htmlimage.c (html_image_pointer_load): new extracted method

	* htmlengine.c (parse_d): set flow data to current flow

	* htmlengine-edit.c (html_engine_set_data_by_type): change type of
	value to gchar * (it's simpler and we could destroy data simplier)

	* htmlcursor.c (html_cursor_beginning_of_paragraph): updated to
	work with tables
	(html_cursor_end_of_paragraph): likewise

	* htmlclueflow.c (merge): copy data from cf2 if cf1 is empty

	* gtkhtmldebug.c (dump_data): new helper function, dumps object
	data
	(dump_object_simple): dump object data

	* gtkhtml.c (gtk_html_insert_html): use
	html_image_factory_move_images

	* htmlimage.c (html_image_factory_move_images): new method, moves
	all image poiters from one factory to another

	* gtkhtml.c (gtk_html_insert_html): new method, inserts html
	generated from html source, hacked - creates new widget and steals
	it's content and destroy it, insert content to original one

2001-04-20  Radek Doulik  <rodo@ximian.com>

	* htmlobject.c (destroy): free object data
	(free_data): helper function

	* gtkhtml.c (gtk_html_editor_command): added boolean return value

	* htmlengine.c (flow_new): new wrapper around flow constructor
	which sets object data

	* gtkhtml.c (command): new command implementations

	* gtkhtml-enums.h: added cursor-bod/eod commands

2001-04-22  Ariel Rios  <ariel@linuxppc.org>

	* test.c (button_cb): Remove stupid warning on callback.

2001-04-21  Ariel Rios  <ariel@linuxppc.org>

	* Makefile.am (noinst_PROGRAMS): Add gtest

	* test.c : This file provides a nice simple
	test application for GtkHTML altho it is a 
	little hacky at some points. However it should
	be enough to get started with using the widget

2001-04-17  Larry Ewing  <lewing@ximian.com>

	* htmliframe.c (draw): clean up the draw routine a little.
	(html_iframe_init): remove redundant condition.

2001-04-17  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-fontstyle.c (html_engine_set_font_style): like
	with color setting

	* gtkhtml-enums.h: moved new commands to the end

	* htmlengine-edit-fontstyle.c (html_engine_set_color): set
	insertion color also for selection case

	* htmlselection.c (html_engine_is_selection_active): call
	html_engine_edit_selection_updater_do_idle

	* htmlengine.h: added cursor_position_stack to keep cursor
	positions for save/restore commands

	* gtkhtml-properties.c: added command names

	* gtkhtml-enums.h: new commands - save/restore cursor position

	* gtkhtml.c (gtk_html_select_paragraph_extended): new function

	* htmlengine-edit.c
	(html_engine_select_paragraph_extended): new function

	* keybindingsrc.ms: added C-a for select-all and C-p for select
	paragraph

	* keybindingsrc.xemacs: like for emacs ones

	* keybindingsrc.emacs: added C-a, C-e

	* gtkhtml.c (BCOM): remove C-a and C-e from hardcoded bindings

	* htmlengine-edit-movement.c (html_engine_beginning_of_paragraph):
	new function
	(html_engine_end_of_paragraph): ditto

	* htmlengine-edit.c (html_engine_select_paragraph_editable): new
	function
	(html_engine_select_all_editable): ditto

	* gtkhtml.c (gtk_html_select_paragraph): new function
	(gtk_html_select_all): ditto

	* gtkhtml-properties.c: added new commands

	* gtkhtml-enums.h: added selection commands

2001-04-16  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (parse_table): silence warning.

	* htmlclueflow.c (calc_preferred_width): initialize next to NULL.

	* htmlplainpainter.c (draw_text): remove unused variable.
	(calc_text_width): remove unused function.
	
        The following changes to enable embedded printing are all from a
	slightly renamed and reworked patch from Bill Gribble
	<grib@gnumatic.com>.  Thanks.
	
	* htmlembedded.h (html_embedded_get_widget): add prototype.

	* htmlembedded.c (draw): call html_painter_draw_embedded.
	(html_embedded_get_widget): added helper function.

	* htmlpainter.h: add the draw_embedded member function.

	* htmlpainter.c (class_init): initialize draw_embedded.
	(html_painter_draw_embedded): wrapper function for the class
	function.

	* htmlprinter.c (draw_embedded): fire the draw_print save the
	context and fire the draw_print signal where appropriate.
	(class_init): use draw_embedded.

	* htmlgdkpainter.c (draw_embedded): fire the draw_gdk signal if
	the embedded widget is a GtkHTMLEmbedded widget.
	(class_init): use draw_embedded.
	
	* gtkhtml-embedded.h: add draw_print and draw_gdk signals.

	* gtkhtml-embedded.c: add draw_gdk and draw_print signals.
	(gtk_html_embedded_class_init): init the signal handlers.

	* htmliframe.c (html_iframe_init): initialize iframe->gdk_painter
	to NULL.  
	(set_painter): do proper refcounting of the iframe->gdk_painter.
	(iframe_set_gdk_painter): helper function to handle setting the
	painter.
	(destroy): use the helper funtion to make sure we remove the last
	reference to the the painter.

2001-04-14  Larry Ewing  <lewing@ximian.com>

	* htmlfontmanager.c (html_font_manager_finalize): free the face.

	* htmlpainter.c (finalize): destroy the colorset.

	* htmlengine-print.c (html_engine_print_with_header_footer): ref
	the old painter while we print.

	* htmlengine.c (html_engine_set_painter): fixup refcounting of
	painters.
	(html_engine_destroy): use unref instead of destroy.

2001-04-13  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (parse_f): make sure we don't hold two references
	to the color.

2001-04-12  Dan Winship  <danw@ximian.com>

	* htmlengine.c (parse_iframe): Don't leak.

2001-04-12  Radek Doulik  <rodo@ximian.com>

	* htmlgdkpainter.c (html_gdk_painter_unrealize): check if painter
	is already realized

2001-04-11  Radek Doulik  <rodo@ximian.com>

	* htmlplainpainter.c (alloc_fixed_font): if face == NULL pass NULL
	- NULL means that fixed font is requested

	* gtkhtml.c (command): ops, removed unwanted calls to
	update_styles

	* htmlengine-edit-fontstyle.c (html_engine_set_font_style):
	changed order back to AND, OR
	(get_color_from_selection): use point for movement thru selection
	(get_color_from_selection): don't get color from end of objects
	(get_font_style_from_selection): likewise

	* gtkhtml.c (button_press_event): fixed Bug 2166:
	With Evolution, start composing a new message; type out a few lines. Click
	to insert the cursor somewhere, and then click backwards in the text to
	select a range. Now click outside of the selection. The GtkHTML component
	should go away, leaving a grey box.

2001-04-07  Dan Winship  <danw@ximian.com>

	* htmlprinter.c (DARK, LIGHT):
	* htmlgdkpainter.c (DARK, LIGHT):
	* htmlengine-edit-rule.c (SET, SETO):
	* gtkhtml-properties.c (GET, SET, GET, GETS, COPYS): Remove
	inappropriate uses of ## in macro definitions.

	* htmltextslave.h: 
	* htmltable.h: Remove (unused) non-extern declarations of
	html_table_class and html_text_slave_class.

	* htmlclue.c: Make parent_class static

2001-04-03  Radek Doulik  <rodo@ximian.com>

	* htmlengine.c (check_prev): check faces

	* htmlfontmanager.c (strip_white_space): new helper function
	(alloc_new_font): allow white spaces in face list
	(get_name_from_face): use 13th and 14th attribute instead of 12th
	and 13th

2001-04-02  Larry Ewing  <lewing@ximian.com>

	* htmlclueflow.c (write_pre_tags): only write a \n for PRE flows,
	rather than a <br>\n.

2001-03-30  Larry Ewing  <lewing@ximian.com>

	* htmlobject.c (copy): copy pref_width.

	* gtkhtml.c (selection_received): use unicode_strlen on the
	selection data lenght.  Why are we not using byte ranges for
	insert_text and paste_text?

	* htmlengine-edit-cut-and-paste.c (html_engine_insert_text): use
	unicode_strlen.

	* htmlobject.c (html_object_init): init min_width and pref_width.

	* htmlplainpainter.c (alloc_fixed_font): use the parent class to
	do the work, just override the settings.  remove a bunch of
	duplicated support functions

	* htmlengine.c (parse_table): close_anchor at the begining of a
	new cell since <a> elements cannot span cells.  Remove it from the
	closing tag because that presumes there is a valid closing tag.
	We need more regression tests.
	
	* htmlengine.c (parse_table): close_anchor at the end of a row to
	make sure stray anchors don't wrap.

	* htmlclueflow.c (calc_padding): temporary hack to swtich to
	remove padding in the text/plain case.  This will get moved into
	the painter soon.
	(save_plain): use calc_padding based on the painter from the
	current engine and don't automatically assume it.

2001-03-29  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (gtk_html_build_with_gconf): helper function, returns
	TRUE if gtkhtml was built with gconf support. it's provided for
	scripting languages

	* htmlengine-edit-table.c (delete_table_row): updated
	(delete_row_undo_action): use DeleteCellsUndo data

	* htmltext.c (get_tags): added quotes

	* htmlengine-save.c (color_to_string): use %02x instead of %2x to
	avoid colors like <BODY BGCOLOR="#98cc 0">

	* htmlengine-edit-table.c (insert_table_row): fixed cursor
	position, added row_cells parameter
	(delete_row_setup_undo): rewritten to use cells data

2001-03-29  Larry Ewing  <lewing@ximian.com>

	* gtkhtml.c (on_object): free the pointer_url before we set it to
	NULL.

2001-03-28  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-table.c (insert_table_column): added column
	parameter, when non-NULL, use it as newly created cell-places
	content
	(delete_column_setup_undo): use new undo data and remember deleted
	cells for later undo (insertion)

2001-03-27  Larry Ewing  <lewing@ximian.com>

	* htmliframe.c (destroy): disconnect the signals from the html
	widget that refer to the iframe since the iframe_created.
	(html_iframe_class_init): use the new destroy handler.

2001-03-26  Larry Ewing  <lewing@ximian.com>

	* keybindingsrc.emacs: disable autofill.

2001-03-27  Radek Doulik  <rodo@ximian.com>

	* htmltable.c (append_selection_string): start tabbing on first
	non-empty cell

	* htmlclueflow.c (merge): use style of second flow if first one is
	empty
	(pref_right_margin): removed unused variable

	* htmlengine-search.c (move_to_found): fixed coordinates
	calculation

	* htmlclueflow.c (calc_preferred_width): don't remove trailing
	space width on the end of paragraph

2001-03-26  Larry Ewing  <lewing@ximian.com>

	* Makefile.am: add htmlplainpainter.[ch]

	* htmlclueflow.c (pref_right_margin): determine the prefered
	margin based on the width of the line in plain painters.

2001-03-26  Radek Doulik  <rodo@ximian.com>

	* gtkhtml-search.c (gtk_html_engine_search_incremental): added
	wrappers around html_engine_search_... methods

	* htmltokenizer.c (in_extension): even more safe extension
	handling

	* htmlcolor.c (html_color_unref): really free color

	* htmlengine.c (parse_d): better checking

	* htmltokenizer.c (in_extension): don't check for extension end in
	quted input

2001-03-26  Larry Ewing  <lewing@ximian.com>

	* htmlplainpainter.c: html painter for plain mode.  The idea here
	is that rather than loosing valuable information when converting
	from html to plain and back again we change the painter to draw
	the html how it will render in text plain mode.  This is not close
	to perfect yet, but with a little work it should get better.

	* htmlplainpainter.h: header for plain mode.

2001-03-22  Larry Ewing  <lewing@ximian.com>

	* gtkhtml.c: remove references to load_in_progress.
	gtk_html_write and gtk_html_end are now just proxies to
	gtk_html_stream_write and gtk_html_stream_end.

	* gtkhtml.h: remove references to load_in_progress.

2001-03-22  Radek Doulik  <rodo@ximian.com>

	* htmlinterval.c: removed some warnings

	* htmlengine.c (text_new): new helper function, takes care of
	setting class_data to HTMLText objects

	* htmltokenizer.c: added searchGtkHTMLCount and extension in
	HTMLTokenizer
	(in_comment): look for extension in comment (like <!--+GtkHTML:
	-->
	(in_extension): new function, handles gtkhtml extension
	(html_tokenizer_tokenize_one_char): extracted from
	html_tokenizer_write

	* htmlengine.c: added class_data hash table to Engine to store
	object data to be set by class
	(html_engine_set_class_data): new function, sets data to
	class_data table
	(html_engine_clear_class_data): clears previously set class_data
	(html_engine_set_object_data): set data to object according to
	class_data
	(get_class_table_sure): helper function
	(get_class_table): helper function
	(parse_d): parse <DATA ...> tag, this tag is stored in comments
	(maybe we should parse it only when in comment?)
	(html_engine_class_data_clear): clear whole class_data table
	(class_data_table_free_func): helper function
	(class_data_free_func): helper function

	* gtkhtml.c: new signal IFRAME_CREATED
	(gtk_html_set_iframe_parent): emit new signal

2001-03-21  Kjartan Maraas  <kmaraas@gnome.org>

	* htmlanchor.c: #include <string.h>
	* htmlpainter.c: Same here.
	* htmltable.c: Init two vars to zero to avoid "could be used
	uninitialized" warnings.
	
2001-03-20  Radek Doulik  <rodo@ximian.com>

	* gtkhtml-enums.h: new command
	GTK_HTML_COMMAND_TEXT_SET_DEFAULT_COLOR

2001-03-20  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (html_engine_begin): add LOG_INPUT ifdef here.
	(parse_s): compare against the full length of the string.
	(parse_h):  use the full length again.

	* gtkhtml.c: Add documentation for several more functions.
	(gtk_html_begin_content): remove LOG_INPUT #define, do this in
	html_engine_begin, with gtk_html_stream_log_being now.
	(gtk_html_write): removed logging code.
	(gtk_html_end): removed logging code.
	(gtk_html_export): rename the content and data
	arguments for clarity.
	
2001-03-19  Larry Ewing  <lewing@ximian.com>

	* gtkhtml-stream.c (gtk_html_stream_log_new): helper function to
	allow logging on any stream created with gtk_html_stream_log_new
	rather than gtkhtml_stream_new.
	(stream_log_write): proxy the write to the internal stream.
	(stream_log_close): proxy the close to the internal stream and
	clean up.

	* gtkhtml-stream.h: add prototype for gtk_html_stream_log_new.

2001-03-15  Radek Doulik  <rodo@ximian.com>

	* htmltable.c (accepts_cursor): accept cursor

	* htmlobject.c (move_object_downtree): stop on containers, which
	accepts cursor (like tables)

2001-03-18  Larry Ewing  <lewing@ximian.com>

	* keybindingsrc.emacs: add bindings for space-and-fill and
	break-and-fill for testing.

	* htmlengine.c: fix more warnings I left.

	* gtkhtml.c (command): add handlers for the space-and-fill and
	break-and-fill.

	* gtkhtml-properties.c: add enum entries for space-and-fill, and
	break-and-fill.

	* htmlengine-edit.h (clueflow_style_to_paragraph_style): add
	prototypes

	* htmlengine-edit.c (html_engine_fill_pre_line): utility function
	to word wrap pre lines.
	(html_engine_space_and_fill_line): insert space then fill line.
	(html_engine_break_and_fill_line): fill line then insert paragraph.

2001-03-15  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (update_embedded): add prototype and fix warnings.

2001-03-14  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (html_engine_update_event): do a container forall
	on the layout to move offscreen objects off of the screen.
	(update_embedded): a hack of a function to make sure objects get
	moved out of the way properly.
	(parse_object): remove the call to set "embeddedelement" this is
	taken care of elsewhere now.

	* htmlembedded.c (html_embedded_set_widget): set "embeddedelement"
	data on the widget.

2001-03-14  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-table.c (new_cell): set cell bgcolor, bgpixmap
	and padding
	(insert_table_column): fixed cursor position and cursor movement
	afret insertion

	* htmltext.c (calc_min_width): make minimal width be always >= 1
	(calc_preferred_width): ditto

	* htmltextslave.c (calc_size): make width be always >= 1

	* htmlengine-edit-table.c (html_engine_insert_table_1_1): create
	width=100% table

2001-03-13  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (html_object_changed): call html_object_calc_size
	on the embedded element rather than html_embedded_size_recalc.

	* htmlembedded.c (calc_size): take the descent from the embedded
	element into account.  Remove the requirement that the widget be
	realized.
	(html_embedded_size_recalc): removed, use html_object_calc_size
	instead.
	
	* htmlembedded.h (html_embedded_size_recalc): remove prototype.

2001-03-13  Radek Doulik  <rodo@ximian.com>

	* gtkhtml.c (command): return for already handled commands

	* htmltext.c: fixed matching, removed * from final char match,
	which made it useless, added ?!;: to forbidden terminal characters

	* htmlengine-edit-cut-and-paste.c (html_engine_insert_text): stop
	inserting links after ' ' (space)

	* htmlundo.c (html_undo_level_end): copy save_undo to level anyway
	(redo_level_end): ditto

	* htmlengine-edit-cut-and-paste.c
	(html_engine_insert_empty_paragraph): stop inserting links
	after paragraph insertion

	* gtkhtml.c (command): set update_styles
	(move_selection): ditto
	(cursor_move): ditto
	(key_press_event): use update_styles

	* gtkhtml-private.h: added update_styles flag

2001-03-12  Radek Doulik  <rodo@ximian.com>

	* gtkhtml-search.c (destroy): don't set gtkhtml's data here, as
	gtkhtml is already destroyed

2001-03-11  Larry Ewing  <lewing@ximian.com>

	* htmlinterval.h: fix harmless typo in copyright header.

2001-03-10  Larry Ewing  <lewing@ximian.com>

	* gtkhtml-search.c (destroy): dereference data before we destroy
	it, this should fix the crashes ettore has been seeing.

2001-03-08  Larry Ewing  <lewing@ximian.com>

	* htmlbutton.c (html_button_class_init): add encode method.
	(encode): new method to encode the button value. (patch from "Bill
	Gribble" <grib@gnumatic.com>)

	* htmlbutton.h: add success indicator. (patch from "Bill Gribble"
	<grib@gnumatic.com>)

	* htmlengine.c (parse_object_params): handle the multiple leading
	spaces you can get from tabs and &nbsp; correctly.
	(is_leading_space): helper funtion to find leading whitespace.

	* htmlclueflow.c: use IS_UTF8_NBSP.
	
	* htmlentity.h (IS_UTF8_NBSP): helper macro to match &nbsp;

2001-03-08  Radek Doulik  <rodo@ximian.com>

	* gtkhtml-search.c (data_destroy): don't destroy widget, as this
	is called from widget destroy handler

2001-03-07  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (parse_t): only emit the title changed signal if we
	have a valid title and were already in a title tag.

2001-03-07  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-table.c (delete_column_setup_undo): new undo
	setup for column delete
	(delete_column_undo_action_before): 1st undo action (insert after)
	(delete_column_undo_action_after): 2nd undo action (insert before)

	* htmlundo-action.c (html_undo_action_destroy): check for
	action->data before unref'ing them

	* htmltable.h (HTML_IS_TABLE): use HTML_CHECK_TYPE

	* htmltypes.h (HTML_CHECK_TYPE): new macro

	* htmlengine-edit-table.c (html_engine_insert_table_1_1): move 1
	step back to inserted table
	(insert_table_column): move to the 1st cell of inserted column
	(delete_table_column): fix cursor position after column removed
	(insert_table_column): extracted from
	html_engine_insert_table_column
	(delete_table_column): extracted from
	html_engine_delete_table_column
	(insert_column_setup_undo): new function
	(insert_column_undo_action): new undo action

	* htmltable.h (IS_HTML_TABLE): renamed to HTML_IS_TABLE

2001-03-06  JP Rosevear  <jpr@ximian.com>

	* Makefile.am: make htmltablepriv.h a source

2001-03-06  Radek Doulik  <rodo@ximian.com>

	* keybindingsrc.{ms,emacs}: new bindings

	* gtkhtml.c (command): use new command

	* htmlengine-edit-table.c (html_engine_delete_table_column): new
	command implementation

	* gtkhtml.c (command): use new table methods

	* htmlengine-edit-table.c (html_engine_insert_table_column): new
	table command

	* htmltablepriv.h: new file for private HTMLTable methods

	* htmlengine-edit-cut-and-paste.c (html_engine_append_object): new
	method, splits at cursor upto level 'level' and appends object
	right there

	* htmlengine-edit-table.c (html_engine_insert_table_1_1): new
	command implementation

	* htmlengine-edit-cut-and-paste.c (look_for_non_appendable): check
	for parent type insted of object itself

	* htmlobject.c (html_object_merge): work around nested types
	(CLUEV, TABLECELL)

	* gtkhtml-properties.c: added new commands definitions

	* htmlengine-edit-cut-and-paste.c (split_and_add_empty_texts): in
	case of '' split after

	* htmltable.c (merge): take care of merging 1 row table with other
	one
	(merge): fixed cells setting in output (t1) table

2001-03-02  Radek Doulik  <rodo@ximian.com>

	* htmltable.c (calc_size): test for already properly sized
	columnOpt, if needed call set_max_width

	* htmlclueflow.c (check_point): check for p != NULL

	* htmltext.c (copy): g_strdup face, it caused some crashes in
	destroy method before

2001-02-20  Larry Ewing  <lewing@ximian.com>

	* htmlobject.c (html_object_check_point): allways return NULL when
	width or height == 0.

	* htmlclueflow.c (check_point): fix logic to work with zero
	height objects.  This should fix the looping bug the red-carpet
	guys were seeing.

2001-02-15  Dan Winship  <danw@ximian.com>

	* htmltext.c (split_word_width): fix up a g_renew use to fix a
	crash when typing.

2001-02-12  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-cut-and-paste.c (check_magic_link): try magic
	links only for HTMLText and not link

	* htmltext.c (html_text_magic_link): save and restore cursor
	position
	(html_text_magic_link): wrapped in one undo step
	(paste_link): ops, removed level step here
	(paste_link): take care for case when cursor in on end of previous
	object

2001-02-09  Radek Doulik  <rodo@ximian.com>

	* htmldrawqueue.c (html_draw_queue_flush): do clear/draw_obj only
	if GtkHTML has window

	* htmliframe.c (draw): use parent_class draw method for non
	printer painters

	* htmlembedded.c: reworked size calculation/allocation, removed
	ugly hacks ;-)

	* gtkhtml-embedded.c (gtk_html_embedded_new): don't set
	resize_mode to QUEUE

	* gtkhtml.c (gtk_html_set_default_content_type): take care of
	content_type == NULL

2001-02-08  Frederic Crozat <fcrozat@mandrakesoft.com>

	* gtkhtml.c (client_notify_widget): rename font_var_family and
	font_fix_family to font_var and font_fix

2001-02-08  Radek Doulik  <rodo@ximian.com>

	* htmltable.c (divide_left_by_preferred_width): expand only
	columns with pref > fixed

	* htmltext.c (merge_word_width): fixed

2001-02-07  Larry Ewing  <lewing@ximian.com>

	* htmlimage.c (draw): use HTML_IS_PRINTER to detect printer object
	cleanly. (from Dave Benson <daveb@ffem.org>)

	* htmltokenizer.c (html_tokenizer_end): clear dest.
	(html_tokenizer_reset): free the token buffer list, and clear dest
	and size. (from Dave Benson <daveb@ffem.org>)

2001-02-01  Larry Ewing  <lewing@ximian.com>

	* gtkhtml.c (mouse_change_pos): allow a little bit of motion
	before we decide it isn't a click on a url.  This should probably be
	reworked to function more like netscape over urls.

2001-02-01  Radek Doulik  <rodo@ximian.com>

	* htmlcursor.c (html_cursor_end_of_line): take care of objects
	with different height on one line
	(html_cursor_beginning_of_line): ditto
	(html_cursor_up): ditto
	(html_cursor_down): ditto

2001-02-01  Larry Ewing  <lewing@ximian.com>

	* htmlembedded.c (calc_size): fix the bug I introduced last week
	that caused htmliframes too loop in their size negotiation.

2001-01-31  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-cut-and-paste.c (html_engine_insert_text): delay
	spell check only for newly typed words

2001-01-30  Radek Doulik  <rodo@ximian.com>

	* htmlengine.c (html_engine_set_painter): take care of borber

	* htmliframe.c (draw): take care of html border, fixes iframes
	printing

	* htmlcluev.c (check_point): take care of Objects with zero width

	* htmlclueflow.c (check_point): take care of Objects with zero
	width

	* htmltextslave.c (check_point): take care of ''

	* htmlimage.c (get_actual_width): use actual engine
	(get_actual_height): likewise

	* htmliframe.c (set_max_width): implemented set max width
	(calc_min_width): rewritten, use html_engine_calc_min_width, this
	fixes Evolution welcome message problem

	* htmlengine.c (html_engine_get_view_width): take care of iframes
	(html_engine_get_view_height): likewise
	(html_engine_calc_min_width): new method

2001-01-29  Radek Doulik  <rodo@ximian.com>

	* htmlimage.c (calc_min_width): fix min width for images with
	percented height

2001-01-29  Larry Ewing  <lewing@ximian.com>

	* htmlengine.c (html_engine_begin): call html_engine_id_table_clear.
	(html_engine_id_table_clear): move the table reset functions to a
	helper funtion.

2001-01-29  Radek Doulik  <rodo@ximian.com>

	* gtkhtml-search.c (hide): new helper function
	(data_destroy): ditto
	(focus_out_event): new signal handler
	(destroy): ditto
	(gtk_html_isearch): don't destroy input line, hide instead, store
	data in input line widget data

	* gtkhtml-private.h: added search_input_line

2001-01-29  Larry Ewing  <lewing@ximian.com>

	* htmltable.c (html_table_init): remove reference to refcount.
	Remove unused link/unlink funtions.

	* htmltablecell.h: remove unused refcount member.  Remore
	link/unlink prototypes.

	* htmltable.c (set_cell): remove useless call to
	html_table_cell_link.

2001-01-29  Radek Doulik  <rodo@ximian.com>

	* htmltable.c (destroy): reversed order of walk thru table as we
	don't want access freed memory

	* htmlengine.c (html_engine_add_object_with_id): strdup key only
	if it's a new one, else pass old_key (take a look in glib sources
	if you don't beleive it's right :)

2001-01-26  Radek Doulik  <rodo@ximian.com>

	* htmlclueflow.c (html_clueflow_spell_check): draw spelled range
	only if engine isn't frozen

	* htmlengine.c (parse_table): don't ignore nowrap

2001-01-25  Radek Doulik  <rodo@ximian.com>

	* htmlengine-edit-cut-and-paste.c (html_engine_insert_text): don't
	do spell check yourself and rather pass check param to
	insert_object

2001-01-25  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml.c (gtk_html_new): added doc comment to test doc stuff
	(gtk_html_new_from_string): added new constructor

	* gtkhtml-stream.h (gtk_html_stream_unref): moved
	gtk_html_stream_ref, gtk_html_stream_unref from gtkhtml.h

	* htmltablecell.c (calc_size): new method, take care of fixed
	height
	(clue_move_children): new helper function
	(html_table_cell_set_fixed_height): new function

	* htmlengine.c (parse_table): support <td height=[number]>

	* htmltablecell.c (html_table_cell_init): added fixed_height

2001-01-25  Larry Ewing  <lewing@ximian.com>

	* htmlimage.c (html_image_pointer_timeout): only queue a redraw if
	there is an image object to queue it on (not a background).

2001-01-24  Larry Ewing  <lewing@ximian.com>

	* htmlimage.c (html_image_pointer_timeout): draw the borders now
	that we think we've waited long enough.  The idea here is that we
	are too agressive about drawing the box where the image should be
	and it results in ugly artifacts.  Now we wait a STALL_INTERVAL
	amount of time before we start drawing the box.
	(html_image_pointer_new): initialize the timer.
	(html_image_pointer_unref): clear the timer if it is still around.
	(draw): short circuit if stall is not set.

	* htmlimage.h: add stall flag and stall timeout to track stream
	progress.

	* htmlembedded.c (calc_size): use the requisition because the
	allocation fluctuates too much.

	* gtkhtml-embedded.c (gtk_html_embedded_new): listen to the size
	parameters passed along in the html.

2001-01-24  Radek Doulik  <rodo@helixcode.com>

	* htmlengine-edit.c (html_engine_spell_check_range): check for
	properties:live spell checking

	* htmltext.c (split_word_width): do renew only when words !=
	s->words (not needed, but old way I got segv with efence, weird)

	* htmlengine.c: added need_spell_check flag

	* htmlengine-edit-cut-and-paste.c: do spell checking only on word
	ends and use need_spell_check engine flag

	* htmlcursor.c: check for need_spell_check before cursor move

	* htmlclueflow.c (html_clueflow_spell_check): queue draw checked
	interval
	(queue_draw): helper function

	* testgtkhtml.c (print_footer): add param to quiet warning

2001-01-23  Larry Ewing  <lewing@helixcode.com>

	* htmlcolorset.c: unref all the colors when we destroy the
	colorset (from iain@ximian.com).

	* htmlengine.c: unref the insertion_color. (iain)

	* htmltext.c: free text->face in destroy. (iain)

	* htmltable.c: initialize higher_span.

2001-01-23  Radek Doulik  <rodo@helixcode.com>

	* htmlengine-print.c: use user_data in printing

	* gtkhtml.c (gtk_html_print_with_header_footer): added user_data
	parameter for language bindings

	* htmlengine.c (thaw_idle): use gtk_html_edit_make_cursor_visible

	* gtkhtml.c (gtk_html_edit_make_cursor_visible): new function
	(key_press_event): don't do queue_draw here
	(move_selection): use gtk_html_edit_make_cursor_visible
	(cursor_move): ditto

	* htmlengine.c (html_engine_make_cursor_visible): let cursor
	always rather end in right-bottom

2001-01-19  Radek Doulik  <rodo@helixcode.com>

	* htmlengine-edit.c (html_engine_indent_pre_paragraph): changed
	undo name

	* htmlclueflow.c (html_clueflow_set_style): clear word width when
	changing from/to PRE

	* htmlengine.c (html_engine_set_painter): use
	html_object_clear_word_width

	* htmlobject.c (html_object_clear_word_width): new function

	* htmlengine-edit.c (html_engine_indent_pre_paragraph): new
	function, indents pre paragraph to 72 chars
	(go_to_begin_of_pre_para): helper function
	(try_break_this_line): ditto

	* htmlengine.c (html_engine_thaw): add show cursor if idle already
	added
	(html_engine_freeze): hide always cursor

	* htmlengine-edit-cut-and-paste.c (html_engine_delete_n): don't do
	cut here, just delete

	* htmlcursor.c (html_cursor_beginning_of_paragraph): new function
	(html_cursor_end_of_paragraph): new function

	* htmlengine.c (clear_word_width): new helper function
	(html_engine_set_painter): clear word width cache

	* htmltext.c (html_text_clear_word_width): make this function
	public

2001-01-18  Radek Doulik  <rodo@helixcode.com>

	* htmltext.c (object_split): take care of split in &nbsp; sequence

	* htmlobject.c (html_object_merge): added engine parameter

	* htmlengine-edit-cut-and-paste.c (html_engine_insert_text): call
	convert nbsp

	* htmltext.c (merge_word_width): new function
	(object_merge): use merge_word_width

	* gtkhtml.c (command): added
	GTK_HTML_COMMAND_DELETE_BACK_OR_INDENT_DEC command
	(load_keybindings): bind backspace to new command

	* htmlengine-edit.c (html_engine_cursor_on_bop): new function
	(html_engine_get_indent): new function

	* htmlrule.c (save): save all attributes

	* htmltext.c (html_text_op_cut_helper): convert nbsp
	(html_text_convert_nbsp): new helper function, takes care of nbsp
	converting
	(convert_nbsp): refactored, does only actual rewrite
	(is_convert_nbsp_needed): extracted 1st pass where we find out if
	convert is neccessary
	(split_word_width): new functions, takes care of word_width cache
	for splitted text
	(clear_word_width): helper function, clears word width cache

2001-01-16  Radek Doulik  <rodo@helixcode.com>

	* htmlclue.c (forall): use pnext to remember p->next as p could be
	removed in func call

	* gtkhtml.c (gtk_html_set_color): new function

	* htmltext.c (html_text_op_cut_helper): remove spell errors from
	cuted part

	* htmlengine-edit-cut-and-paste.c (prepare_delete_bounds): if
	level > 1 prepend NULL before left and right

	* htmlclueflow.c (get_post_padding): add post padding for header
	preceding another header too

	* htmlengine.c (insert_text): create new text if para is pending

2001-01-12  Radek Doulik  <rodo@helixcode.com>

	* htmlclueflow.c (search): fixed crash for empty document

2001-01-11  Radek Doulik  <rodo@helixcode.com>

	* htmlclue.c (merge): merge all clues

	* htmltext.c (html_text_op_cut_helper): move spell_errors
	(html_text_op_cut_helper): remove spell errors when cutting whole
	text
	(object_split): update spell errors
	(remove_spell_errors): make it exact
	(object_split): do convert_nbsp
	(object_merge): do convert_nbsp

	* htmlgdkpainter.c (alloc_e_font_it): do n1 -> n2 -> n3 instead of
	n1 -> n3

	* gtkhtml.c (selection_received): paste only in editable
	(gtk_html_request_paste): ditto

	* htmlgdkpainter.c (alloc_e_font_it): substitute size by * when
	looking for closest font

	* gtkhtml.c (scroll): repeat two lines when scrolling by page
	(scroll): use rather 2.5 * size
	(cursor_move): try to repeat last 2 lines while scrolling by page
	(2.5 * size)

	* htmlengine-edit-clueflowstyle.c
	(html_engine_set_clueflow_style): free/thaw engine

	* htmlclueflow.c (check_point): fixed case when flow indent level
	> 0

	* htmlfontmanager.c: use full font name

	* gtkhtml-properties.c: read/store full font name

2001-01-10  Radek Doulik  <rodo@helixcode.com>

	* htmlobject.c (html_object_get_tail_leaf): new function, moved
	from cut&paste
	(html_object_get_head_leaf): ditto
	(html_object_get_selection_string): new function, returns
	selection string for object
	(select_object): helper function for
	html_object_get_selection_string
	(unselect_object): ditto

	* gtkhtml.c (gtk_html_cut): set selection owner
	(gtk_html_copy): likewise
	(command): use gtk_html_copy, gtk_html_cut
	(button_release_event): use gtk_html_copy

	* htmlengine-edit-cut-and-paste.c (html_engine_paste_text): add
	undo level "Paste text"
	(html_engine_paste_object): added undo level "Paste"

	* gtkhtml.c (gtk_html_request_paste): do PASTE if no selection
	available
	(button_release_event): copy selection to clipboard
	(gtk_html_paste): use gtk_html_request_paste instead of
	html_engine_paste
	(selection_received): if it's selection from us, use
	html_engine_paste rather than text version of data
	(command): call gtk_html_paste rather than html_engine_paste as we
	want take care of XSelection while pasting
	(command): don't cut before inserting rule
	(command): don't cut before inserting empty para, do delete instead

2001-01-09  Dave Camp <dave@helixcode.com>

	* Makefile.am (libgtkhtml_HEADERS): Added htmlengine-cut-and-paste.h

2001-01-09  Radek Doulik  <rodo@helixcode.com>

	* htmlengine.c (parse_p): don't push DIV block
	(parse_p): don't pop it
	(add_line_break): add para with empty text only when !HTML_CLUE
	(clue)->head

	* htmltext.c (html_text_append): new helper method

	* htmlengine.c (parse_h): don't place hrule in own flow
	(add_line_break): when flow == NULL, add para with empty text
	(insert_text): replaced crappy code with html_text_append method
	call

2001-01-08  Radek Doulik  <rodo@helixcode.com>

	* htmlengine-edit-cut-and-paste.c (html_point_get_left): remove
	allow_null parameter
	(html_point_get_right): likewise

	* htmlobject.c (html_object_op_cut): add left, right parameters

	* gtkhtml.c (idle_handler): take care of thaw_idle handler

	* htmltext.c (calc_min_width): use strlen rather than
	unicode_index_to_offset

	* htmltextslave.c (get_offset_for_pointer): renamed from
	html_text_slave_get_offset_for_pointer, make it private

	* htmlobject.c (html_object_next_not_type): new helper function
	(html_object_prev_not_type): ditto

	* htmlclueflow.c (check_point): rewritten, take care of objects
	with different (ascent + descent)'s

	* htmltextslave.c (check_point): implement this method

	* htmltext.c (check_point): return just NULL, left work to
	clueflow which is container

2001-01-05  Radek Doulik  <rodo@helixcode.com>

	* htmlengine.c (html_engine_freeze): hide cursor
	(thaw_idle): show cursor
	(html_engine_thaw_idle_reset): show cursor

	* htmlclueflow.c (get_text): use html_object_next_not_slave
	(get_text_bytes): ditto

	* htmlengine.c (thaw_idle): don't reset blinking

	* htmlengine-edit-cursor.c (html_engine_draw_cursor_in_area):
	don't draw cursor if engine is freezed

	* htmlengine.c (html_engine_thaw): do thaw in idle time

	* htmltext.c (html_text_op_cut_helper): use new object helper
	functions

	* htmlobject.c (html_object_move_cursor_before_remove): new helper
	function
	(html_object_move_cursor_before_remove): ditto
	(op_cut): use these helper functions

	* htmlengine-edit-cut-and-paste.c (delete_object_do): use disable
	selection instead of deactivate to deselect deleted objects
	(html_point_get_left): added allow_null parameter
	(html_point_get_right): likewise
	(prepare_delete_bounds): allow NULL for bounds, but not for from,
	to
	(remove_empty_and_merge): make sure cursor have no zero offset if
	there is prev object
	(html_point_get_right): don't allow NULL for ''
	(html_point_get_left): likewise
	(move_cursor_before_delete): extracted from delete_object_do,
	fixed
	(place_cursor_before_mark): extracted from delete_object_do
	(delete_object_do): refactored, use move_cursor_before_delete and
	place_cursor_before_mark

	* htmlengine.c (html_engine_thaw): use html_draw_queue_clear

	* htmldrawqueue.c (html_draw_queue_clear): new function
	(html_draw_queue_flush): use html_draw_queue_clear

	* htmlengine-edit-cut-and-paste.c (delete_object): don't set
	cursor to home, op_cut take care of cursor now

	* htmlobject.c (html_object_op_copy): pass engine instead of empty
	text
	(html_object_op_cut): likewise
	(op_cut): take care of cursor

2001-01-04  Radek Doulik  <rodo@helixcode.com>

	* htmlengine-edit-cut-and-paste.c (check_magic_link): new helper
	function
	(html_engine_insert_empty_paragraph): use check_magic_link
	(html_engine_insert_text): likewise

	* htmltext.c (html_text_magic_link): moved magic links code here
	(paste_link): use paste_object + undo levels

	* htmlengine-edit-table.c (html_engine_insert_table): likewise

	* htmlengine-edit-rule.c (html_engine_insert_rule): don't destroy
	rule after pasting

	* htmlengine-edit-images.c (html_engine_insert_image): don't
	destroy image after pasting

2001-01-03  Radek Doulik  <rodo@helixcode.com>

	* htmlengine-edit-cut-and-paste.c (remove_empty_and_merge): remove
	child before destroy

	* htmllinktextmaster.c (html_link_text_master_class_init): set
	merge method

	* htmlobject.c (html_object_destroy): ops, take back remove_child
	to merge
	(html_object_merge): remove child

2000-12-29  Radek Doulik  <rodo@helixcode.com>

	* htmltable.c (divide_into_percented): fixed, there was error in
	part calculation in case left < to_fill

2000-12-21  Radek Doulik  <rodo@helixcode.com>

	* htmltable.c (html_table_end_row): fixed crash for empty row
	<tr></tr>

2000-12-20  Radek Doulik  <rodo@helixcode.com>

	* htmlimage.c (get_actual_width): use top_html_engine
	(get_actual_height): likewise

2000-12-19  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml.c (selection_received): use unicode_strlen

2000-12-18  Larry Ewing  <lewing@helixcode.com>

	* htmlclueflow.c (html_clueflow_spell_check): free the text
	returned from get_text to fix a leak.
	Free the interval when we create a new one, stops leak.

	* htmltext.c (html_text_spell_errors_clear_interval): clean up
	memory leak.

2000-12-15  Radek Doulik  <rodo@helixcode.com>

	* htmltable.c (calc_percentage_step): extracted from
	calc_col_percentage, take care of cspan
	(calc_col_percentage): use calc_percentage_step
	(divide_into_percented): be exact here

	* htmlengine-edit-cut.c (html_engine_cut): update selection before
	cut

	* htmltablecell.c (calc_min_width): don't use fixed_width as
	min_width
	(calc_preferred_width): for fixed width cells use it as preferred

	* htmltable.c (calc_preferred_width): calc also fixed width cells
	preferred width to columnPref array
	(divide_upto_preferred_width): extracted from
	divide_into_variable_all
	(divide_into_variable_all): first divide in fixed width cells,
	then to auto-width ones
	(divide_left_by_preferred_width): extracted from
	divide_into_variable_all

	* htmltablecell.c (html_table_cell_get_fixed_width): new helper
	function

	* htmltable.h: added array columnFixed with fixed widths of
	columns

	* htmltable.c (calc_column_width_template): added parameter pref,
	it should be array with preferred width used by portioning width
	of spaned columns

2000-12-14  Larry Ewing  <lewing@helixcode.com>

	* gtkhtml.c (gtk_html_begin_content): arggggh... use the content
	type we are passed not the default.  This breaks the logic in the
	editor component.

	* htmlimage.c (save_plain): make sure we initialize the return
	value

2000-12-14  Radek Doulik  <rodo@helixcode.com>

	* htmlengine.c (parse_i): don't set eat_space here
	(parse_a): rather do it here

2000-12-14  Larry Ewing  <lewing@helixcode.com>

	* gtkhtml.c (destroy): free content_type.
	(init): initialize content_type.
	(gtk_html_begin_content): add entry point for specifying content type
	at stream initialization.
	(gtk_html_set_default_content_type): new funtion to set the
	default content type assumption of new streams.

	* htmlengine.h: add content_type to html_engine_begin prototype.

	* htmlengine.c (html_engine_begin): add content_type parameter.

	* gtkhtml-private.h: add content_type to private structure.

	* htmliframe.c (html_iframe_init): make iframe inheirit default
	content_type.

	* gtkhtml.h: add gtk_html_set_default_content_type and
	gtk_html_begin_content.
	
	* htmltokenizer.c (html_tokenizer_write): remove call to
	html_tokenizer_begin as it shouldn't be needed any more.
	(charset_is_utf8): temporary helper function.
	(html_tokenizer_begin): add content_type argument to allow support
	for multiple charsets.
	(in_plain): do not convert to utf-8 if we are expecting utf-8

2000-12-14  Kjartan Maraas  <kmaraas@gnome.org>

	* *.c: Added #include <config.h> to all .c files and fixed some
	_() marked strings to be N_() since they are static.
	
2000-12-13  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml.c (shift_to_iframe_parent): remove -1
	(enter_notify_event): use shift_to_iframe_parent
	(mouse_change_pos): set in_selection only if selection non-empy
	(compare coordinates)

2000-12-12  Radek Doulik  <rodo@helixcode.com>

	* htmlengine-edit-fontstyle.c (html_engine_set_color): if color ==
	NULL use default Text color

	* htmltablecell.c (calc_preferred_width): implemented
	calc_preferred_width

	* htmlengine-edit-movement.c (html_engine_forward_word): fixed one
	char word case
	(html_engine_backward_word): make it dual to
	html_engine_forward_word

2000-12-12  Iain Holmes  <iain@helixcode.com>

	* gtkhtml.c (on_object): Emit the ON_URL signal when there is no object.

2000-12-12  Radek Doulik  <rodo@helixcode.com>

	* htmltable.c (draw): use pixel size for cell content panel
	(calc_column_width_template): take care for cspan
	(calc_column_width_step): likewise, calc exactly
	(divide_into_percented): calc exactly

2000-12-12  Larry Ewing  <lewing@helixcode.com>

	* htmlclueflow.c (draw): fix list item marker position tweak and
	rounding slightly.

2000-12-11  Radek Doulik  <rodo@helixcode.com>

	* htmlprinter.c (draw_pixmap): let gnome-print do alpha stuff

	* htmlengine-print.c (html_engine_print_set_min_split_index): new
	helper setting function
	(print_all_pages): use min_split_index

	* htmlengine.h: added min_split_index for printing 

	* Makefile.am (testgtkhtml_SOURCES): move htmlurl.h here

	* htmlprinter.c (draw_panel): do shadings

	* htmltypes.h: removed HTMLURL

2000-12-10  Radek Doulik  <rodo@helixcode.com>

	* htmltable.c (forall): call func also on self

	* htmlcluev.c (find_free_area): break cycle if try_y == next_y to
	avoid infinite cycles

	* htmltable.c (calc_min_width): use pixel_size for specified_width
	(calc_preferred_width): likewise
	(html_table_set_max_width): likewise

2000-12-08  Larry Ewing  <lewing@helixcode.com>

	* htmlengine.c (parse_object_params): make sure we parse the
	string once we have already removed TAG_ESCAPE so that param
	parsing works properly.

2000-12-08  Radek Doulik  <rodo@helixcode.com>

	* htmltable.c (get_bg_color): new method
	(draw): use parent color for border panel
	(draw): use cell color for its border panel
	fix border_extra everywhere
	(LL): use unsigned long long while scaling to avoid overflows
	while printing

	* htmlobject.c (html_object_set_bg_color): new function

	* htmltable.c (divide_into_variable_all): calc exactly :)

	* htmlpainter.c (html_painter_draw_panel): added parameter bg
	(color)

2000-12-07  Larry Ewing  <lewing@helixcode.com>

	* gtkhtml.c (selection_get): whoops encode COMPOUND_TEXT as well
	see comments.

2000-12-07  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml-search.c: reworked, use new API

	* removed gtkhtml-input.[ch], implemented it thru editor API

2000-12-07  Larry Ewing  <lewing@helixcode.com>

	* htmlengine-save.c (html_engine_save_buffer_new): add cast to
	cleanup warning.
	(html_engine_save): cleanup warning.
	(html_engine_save_plain): cleanup warning.

	* htmlengine-save.h: make prototypes match.
	
	* gtkhtml-private.h: add last_selection_type parameter to the the
	private stucture to track what selections whe have requested.

	* gtkhtml.h: change gtk_html_request_paste prototype to
	include type parameter.

	* gtkhtml.c: added UTF8_STRING (and UTF-8) targets to support the
	various X selection atoms people are using.
	(selection_get): support the new targets.
	(init): add new targets.

2000-12-07  Radek Doulik  <rodo@helixcode.com>

	* htmltable.c: border extra tweakings

	* htmlgdkpainter.c (draw_panel): changed border drawing
	(find_font): if found bigger and smaller font than requsted,
	choose according to size known from font style

	* htmltable.c: fix HTML_CHANGE_PREF_WIDTH brokeness
	count padding to cell width

	* htmlgdkpainter.c: removed obsolete code

2000-12-06  Larry Ewing  <lewing@helixcode.com>

	* htmlengine.c (parse_object_params): use
	html_tokenizer_peek_token check for pending <param> tags
	nondestructively.
	(parse_object): clean up the calls to parse_body, and discard_body
	now that we have no longer already popped the token off the stack.

	* htmltokenizer.h: add prototype for html_tokenizer_peek_token.

	* htmltokenizer.c (html_tokenizer_peek_token): add a new function
	to peek at the next token nondestructively.

	* htmlengine.c (parse_object): make sure we actually match the end
	tag properly.

2000-12-06  Radek Doulik  <rodo@helixcode.com>

	* htmlobject.c (html_object_calc_preferred_width): cache
	pref_width

	* htmlobject.h: added pref_width

	* htmlembedded.c (allocate): set HTML_CHANGE_ALL

	* htmltext.c (split): set HTML_CHANGE_ALL

	* htmlimage.c (html_image_factory_area_prepared): set HTML_CHANGE_ALL

	* htmlinterval.c (select_object): use top engine for select_in and
	"right one" for select_range call

2000-12-06  Larry Ewing  <lewing@helixcode.com>

	* htmlengine.c (parse_object): change ret_val to object_found to
	make the meaning clear. Let me make this clear if you return TRUE
	in your object_requested signal we will use the embedded element,
	if you return false we will parse and use the contents between
	<object> and </object>.  Also free type and classid.

	* gtkhtml.c (html_engine_object_requested_cb): change ret_val to
	object_found to make the meaning clear.

2000-12-06  Radek Doulik  <rodo@helixcode.com>

	* htmltable.c (calc_column_width_step): take care of cspan
	(calc_column_width_template): do steps for all possible cspans

	* htmlengine.c (parse_i): set eat_space to FALSE after <img>

	* htmltable.c (divide_into_percented): don't substract max_size
	[c] from MIN, but from total_width part
	(calc_lowest_fill): new helper function
	(divide_into_variable_all): use calc_lowest_fill, updated first
	step of dividing between cols with pref width < actual
	(calc_column_width_step): extracted from
	calc_column_width_template

	* htmlengine.c (parse_body): set eat_space to FALSE
	(insert_text): drop consequent spaces
	(parse_s): set eat_space to FALSE after </select>
	(parse_t): likewise after </textarea>

	* htmlengine.h: added Engine::eat_space flag

	* htmlgdkpainter.c (alloc_e_font): drop our heuristic and let
	EFont do the job
	(alloc_e_font): drop fixed font if face != NULL
	(alloc_e_font): use our heuristic for size
	(alloc_e_font_it): new helper function
	(alloc_e_font): try to alloc "obligue" when no italics found

	* htmltable.c (divide_into_variable_all): more tuning

	* htmlengine.c (parse_p): don't reset divAlign
	(parse_d): likewise
	(html_engine_parse): set divAlign to HTML_HALIGN_LEFT

	* htmltable.c: I have completely rewritten size calculating,
	scaling part is done in html_table_set_max_width, calc_size is
	partialy rewritten and partialy refactored. I hope it finally work
	correctly. It's at least correct in cases I know, which were
	miscalculated before. One TODO: implement exact dividing of left
	width using an DDA like algorhytm
	(divide_into_variable_all): don't add to columns, which already
	met their preferred width

2000-12-05  Radek Doulik  <rodo@helixcode.com>

	* htmlobject.c (fit_line): fixed condition o->width < width_left
	to o->width <= width_left

	* htmlenums.h: add HTML_CHANGE_PREF_WIDTH

2000-12-05  Larry Ewing  <lewing@helixcode.com>

	* htmlengine.c (parse_object): applied patch from Bill Gribble
	<grib@gnumatic.com> to fix param parsing for object tags.
	(parse_object_params): same.

	* gtkhtml-embedded.c (gtk_html_embedded_new): (from patch) add
	data argument.  Also fixed some prototype indentation.

	* gtkhtml-embedded.h: (from patch) add data variable.

2000-12-04  Radek Doulik  <rodo@helixcode.com>

	* htmltable.c (cell_end_col): new helper function
	(calc_column_min_widths): take care of FIXED width cells and for
	colspan

	* htmltable.h: removed ColInfo, RowInfo, colInfo

	* htmltable.c: removed obsolete calc_col_info,
	html_table_add_col_info

	* htmltable.h: removed obsolete colSpan

	* htmltable.c (calc_column_min_widths): simplify condition

	* htmltable.h: removed obsolete colType

	* htmltable.c (calc_preferred_width): use COLUMN_PREF_POS
	(calc_min_width): use COLUMN_POS

	* htmltable.h: removed obsolete _minWidth, _prefWidth

	* htmlengine-edit-paste.c (prepare_clueflows): fix case when
	engine->cursor->object->next == NULL

	* htmlinterval.c (select_object): use selected_in
	(html_interval_select): set selected_in to FALSE before selecting

	* htmlengine.h: added flag selected_in

	* htmltextmaster.c (calc_size): set ascent, descent

2000-12-01  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml.c (button_press_event): changed some logic, scroll wheel
	no more unselects, ...

2000-11-30  Radek Doulik  <rodo@helixcode.com>

	* htmlentity.c: killed warning

	* htmlengine.c (html_engine_update_event): reorder actions, set
	adjustments

2000-11-28  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml.c (init_properties): updated to latest gconf

	* gtkhtml-properties.c: as below
	(GET): use gconf_client_get_without_default and gconf_value_free
	instead of gconf_client_get_full and gconf_value_destroy

	* gtkhtml.c: aplied patch form Chipzz@ULYSSIS.Org
	fixes gconf typos

2000-11-27  Radek Doulik  <rodo@helixcode.com>

	* gtkhtmldebug.c (gtk_html_debug_dump_object): dump ascent and
	descent

	* htmliframe.c (check_point): take care for border area

2000-11-24  Radek Doulik  <rodo@helixcode.com>

	* htmltable.c (bin_search_index): new function
	(to_index): new helper function
	(get_bounds): rewritten, uses to_index and bin_search_index
	(check_page_split): updated

	* htmlclueflow.c (check_point): check for p coordinates instead of
	self ones
	(check_point): refactoring: remove tmp var obj1
	(check_point): refactoring: remove tmp var x1, y1
	(check_point): use html_object_next_not_slave

2000-11-22  Radek Doulik  <rodo@helixcode.com>

	* htmlimage.c (select_range): new method

	* htmltablecell.c (save): add \" around color
	(save): save width attribute

	* htmltable.c (save): save percent if percent > 0 instead of
	specified width

	* htmltablecell.c (save): fixed test

	* htmltable.c (save): added BACKGROUND, CELLSPACING, CELLPADDING,
	WIDTH and BORDER attributes

	* htmlimage.c (html_image_resolve_image_url): also strdup image
	url if not resolved
	(save): g_free url always

	* htmlimage.h (HTML_IMAGE_POINTER): define HTML_IMAGE_POINTER

	* htmltable.c (html_table_init): set bgPixmap to NULL

	* htmltable.h: added bgPixmap to HTMLTable

	* htmltablecell.c (save): make tags uppercase

	* htmltable.c (save): make tags uppercase

	* htmltext.c (get_tags): make tags uppercase

	* htmltablecell.c (save): save bgcolor attribute in TD tag

	* htmltable.c (save): save bgcolor attribute in TABLE tag

	* htmlengine.c (parse_table): set table->bgColor

	* htmltable.c (destroy): free bgColor
	(html_table_init): set bgColor to NULL

	* htmltable.h: added bgColor to HTMLTable structure

	* htmlengine-search.c (display_search_results): use new selection
	API

	* htmlcursor.c (forward): use html_object_next_leaf_not_type
	instead of html_object_next_leaf
	(backward): likewise

	* htmlobject.c (html_object_next_not_slave): don't require
	p->parent
	(html_object_prev_not_slave): likewise
	(html_object_next_leaf_not_type): fixed, use rv when going forward
	(html_object_prev_leaf_not_type): likewise

	* htmlundo.c (do_action): removed warning

	* htmlengine.c (html_engine_normalize_cursor): use
	html_engine_edit_selection_updater_update_now

	* htmlcursor.c (normalize): use html_object_get_length
	(normalize): use html_object_prev_not_slave

	* htmlinterval.c (html_interval_new_from_cursor): take care of
	cursors order

	* htmlengine-edit-selection-updater.c: removed old_point from
	HTMLEngineEditSelectionUpdater, it's not needed anymore
	(updater_idle_callback): use new selection API

	* htmlselection.c (html_engine_set_active_selection): moved from
	htmlengine.c
	(html_engine_activate_selection): renomed from html_engine_set_active_selection
	(html_engine_select_interval): use html_engine_activate_selection

	* htmlinterval.c (unselect_object): moved from htmlselection.c
	(html_interval_unselect): new function

	* htmlselection.c (html_engine_select_interval): new function
	(selection_helper): use html_engine_select_interval
	(html_engine_select_region): use html_engine_select_interval

	* htmlinterval.c (select_object): moved from htmlselection.c

	* htmlselection.c (html_engine_select_region): use html_interval_select

	* htmlinterval.c (html_interval_select): rewritten

2000-11-21  Joe Shaw  <joe@helixcode.com>

	* htmlengine.c (parse_i): Advance the token by only 3 spaces instead of
	8 for the "id" tag. This is a holdover from when it was called
	"imageid".

2000-11-21  Radek Doulik  <rodo@helixcode.com>

	* htmlengine.c (clear_selection): new helper function
	(html_engine_destroy): use clear_selection
	(html_engine_begin): use clear_selection

	* gtkhtml.c (mouse_change_pos): added window parameter
	(on_object): likewise
	(scroll_update_mouse): updated
	(motion_notify_event): updated
	(enter_notify_event): updated

	* htmlselection.c (html_engine_unselect_all): use
	html_engine_get_top_html_engine

	* htmlengine.c (html_engine_get_top_html_engine): new helper
	function, returns engine from TOP html widget - the one without
	iframe_parent

	* htmliframe.c (append_selection_string): new method

	* gtkhtml.c (shift_to_iframe_parent): new helper function
	(motion_notify_event): use shift_to_iframe_parent
	(button_press_event): shift_to_iframe_parent
	(button_release_event): shift_to_iframe_parent

	* Makefile.am (libgtkhtml_HEADERS): added gtkhtml-enums.h and
	gtkhtml-types.h to libgtkhtml_HEADERS

	* htmlinterval.c (do_downtree_lines_intersection): follow engine
	on way down

2000-11-20  Radek Doulik  <rodo@helixcode.com>

	* htmliframe.c (is_container): iframe is container
	(draw_background): empty method

	* htmldrawqueue.c (draw_obj): take care of iframes

	* htmliframe.c (html_iframe_init): set clue parent to iframe

2000-11-19  Radek Doulik  <rodo@helixcode.com>

	* htmliframe.c (get_engine): new method

	* htmlinterval.c (html_interval_forall): use html_object_get_engine

	* htmlobject.c (get_engine): new virtual method
	(html_object_get_engine): new function

	* htmliframe.c (head): new method
	(tail): new method

2000-11-16  Radek Doulik  <rodo@helixcode.com>

	* htmlobject.c (next): changed to return child->next
	(prev): likewise

	* htmlclue.c: removed next, prev methods

	* htmlobject.c (html_object_next_not_slave): use html_object_next

	* htmlenums.[ch]: renamed from htmlenum

	* htmltypes.h: new file, I've moved some type definitions here to
	avoid annoying circular dependency problems, more types to store
	here in future :)

2000-11-15  Radek Doulik  <rodo@helixcode.com>

	* htmlengine.c (html_engine_init): set selection to NULL

	* replaced engine->active_selection with
	html_engine_is_selection_active (engine) call everywhere

	* htmlengine.h: removed active_selection from Engine

	* htmlselection.c (html_engine_is_selection_active): new function,
	replaces engine->active_selection

	* htmlengine.h: added selection interval to engine

	* htmlobject.c (html_object_next_leaf_not_type): new function,
	does next leaf as long as leaf type is t
	(html_object_prev_leaf_not_type): likewise

	* htmlinterval.c (html_interval_select): use
	html_object_next_leaf_not_type instead of
	html_object_next_not_slave

	* htmlselection.[ch]: new files, contain selection stuff moved
	from htmlengine.[ch]

	* htmlobject.c (html_object_forall): added engine parameter +
	update all calls

	* htmltable.c (check_row_split): new helper function
	(check_page_split): try to split row so long as all cells are
	happy with it

2000-11-14  Radek Doulik  <rodo@helixcode.com>

	* htmltable.c (check_page_split): new method
	(html_table_class_init): use check_page_split

	* htmlclue.c (check_page_split): don't move y to relative
	coordinates as it's already in them

	* htmltable.c (forall): simplified cell condition

	* htmlprinter.c (html_printer_new): don't save context here

2000-11-13  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml-properties.c: added new commands

	* gtkhtml.c (command): implemented new commands

	* gtkhtml.h: added new command cursor-forward/backward

	* htmlengine.c (parse_s): better <s>, </s> recognizing

	* htmltable.c (calc_col_info): add border size to minimal size

2000-11-12  Larry Ewing  <lewing@helixcode.com>

	* htmlengine.c (parse_s): make sure we close the s tag.

2000-11-11  Larry Ewing  <lewing@helixcode.com>

	* htmlimage.c (copy): make sure we copy the percent parameters as
	well or bad things happen.

2000-11-10  Radek Doulik  <rodo@helixcode.com>

	* htmlengine.c (parse_s): added <S></S><STRIKE></STRIKE> tags
	added ID_STRIKEOUT

	* Makefile.am (libgtkhtml_la_SOURCES): added htmlenum.[ch]

	* htmlimageinput.c (html_imageinput_init): updated to use
	percentage

	* htmlengine-edit-images.c (html_engine_insert_image): updated to
	use percentage

	* htmlengine.c (parse_i): updated to use percentage

	* htmlimage.c (save): added ALIGN attribute
	(save): added ALT attribute
	(html_image_init): use percentage
	(html_image_set_size): changed to use new percentage

	* htmlenum.c (html_valign_name): get vertical align value name
	(html_halign_name): likewise

	* htmlenum.[ch]: new files, for html enum utils

	* htmlimage.c (get_actual_width): use html_engine_get_view_width
	and percent_width
	(get_actual_height): likewise
	(save): updated to percenatage, also save width instead of height

	* htmlengine.c (html_engine_get_view_width): new helper function
	(html_engine_get_view_height): likewise

	* htmlimage.h: added percent_width/height to HTMLImage

	* htmlengine.c (html_engine_add_object_with_id): change type of
	old_key to gpointer to avoid compiler warning

	* htmltext.c: removed unused code

2000-11-10  Vladimir Vukicevic  <vladimir@helixcode.com>

	* gtkhtml.c, gtkhtml.h (gtk_html_get_object_by_id): Added
	more generic version of imageid hack; got rid of get_image_by_
	imageid.

	* htmlengine.c, htmlengine.h: Added
	html_engine_add_object_with_id and html_engine_get_object_by_id,
	for associating objects with ids. Added id= tag, but only to
	images. Removed imageid tag. Changed parse_i to use
	add_object for images.

2000-11-10  Radek Doulik  <rodo@helixcode.com>

	* htmltextslave.c (get_ys): helper function, calculates y shift
	for sub/super script
	(draw_spell_errors): use get_ys
	(draw_normal): likewise
	(draw_highlighted): likewise

	* gtkhtmlfontstyle.c (gtk_html_font_style_merge): check for
	DEFAULT style and replace it with SIZE_3

2000-11-09  Radek Doulik  <rodo@helixcode.com>

	* gtkhtmlfontstyle.h: added GTK_HTML_FONT_STYLE_SUBSCRIPT and
	GTK_HTML_FONT_STYLE_SUPERSCRIPT

	* htmlengine.c: added ID_SUB, ID_SUP
	(parse_s): added <sub> and <sup> tags

	* htmlentity.c: added all entities from XHTML 1.0

	* htmltokenizer.c (in_entity): removed old code which doesn't make
	sense to me, let me know if you are aware of idea of this code
	(in_entity): check for searchCount > 9 (&thetasym;)

	* htmlentity.c: removed old code

2000-11-08  Larry Ewing  <lewing@helixcode.com>

	* htmltable.c (save_plain): add simple test/plain save method.
	(html_table_class_init): use save_plain.
	(save): use the result of the calls to html_object_save.

	* htmlimage.c (save_plain): only try to output the alt text if it
	is present.

2000-11-08  Radek Doulik  <rodo@helixcode.com>

	* htmlcolorset.c (SET_GCOLOR): set color only if it's unchanged

	* htmltablecell.c (save): likewise

	* htmltable.c (save): added simple save method

2000-11-07  Larry Ewing  <lewing@helixcode.com>

	* htmlrule.c (html_rule_class_init): use save_plain.
	(save_plain): add a simple rule to the text/plain output.

	* htmlclueflow.c (save_plain): use format string.

	* htmlengine-save.c (write_header): use a format string rather
	than passing the body directly.
	(html_engine_save_buffer_receiver): fix argument type.
	
	* htmlclueflow.c (string_append_nonbsp): make sure we count the
	extra bytes we lose when converting nbsp to a space.
	(save_plain): make sure we deal with byte length and character
	length where appropriate.

2000-11-07  Radek Doulik  <rodo@helixcode.com>

	* htmltextslave.c (could_remove_leading_space): new helper
	function
	(fit_line): use could_remove_leading_space
	(could_remove_leading_space): don't remove on begin of para

	* htmlengine.c (insert_text): eat space on beggining of link

	* htmlgdkpainter.c (calc_text_width): *sigh*, *sigh*, *sigh*,
	replaced painter->text_style with style, this solves random
	bad/good layout problem

2000-11-06  Larry Ewing  <lewing@helixcode.com>

	* htmlclueflow.c (save_plain): disable broken condition checks.

2000-11-04  Larry Ewing  <lewing@helixcode.com>

	* htmltext.c (save_plain): remove call to encode_text_to_8bit
	because this actually breaks the mailer which now assumes it is
	getting text/plain in utf-8 not an 8bit character set.  Also stop
	stipping the nbsp here since we can use it in the wrapping code in
	the clueflow. 

	* htmlclueflow.c (save_plain): test for nbsp properly here, and
	convert use append_nonbsp to spaces.
	(string_append_nonbsp): convert utf-8 nbsp sequence to spaces so
	that we put make things less difficult for other mailers.

	* htmlengine.c (parse_i): parse the alt attribute when parsing the
	img element.

	* htmlimage.c (copy): copy alt contents.
	(html_image_set_alt): set the contents of the alt member.
	(html_image_init): initialize alt to NULL;
	
	* htmlimage.h: add html_image_set_alt.

2000-11-04  Radek Doulik  <rodo@helixcode.com>

	* htmlimage.c (html_image_resolve_image_url): rename from
	resolve_image_url, make it public

	* htmlengine-save.c (get_body): use html_image_resolve_image_url

2000-11-03  Radek Doulik  <rodo@helixcode.com>

	* htmlimage.c (resolve_image_url): new function, resolves image
	URL using GTK_HTML_EDITOR_EVENT_IMAGE_URL
	(save): use resolve_image_url

2000-11-02  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml.h (struct _GtkHTMLEditorAPI): add return value for event
	(_GtkHTMLEditorEventType): added IMAGE_URL editor event

2000-11-03  Dan Winship  <danw@helixcode.com>

	* htmlobject.c (destroy): Free self->object_data before freeing
	self.

2000-11-03  Larry Ewing  <lewing@helixcode.com>

	* htmliframe.c (html_iframe_init): remove out of date comment.
	(iframe_size_changed): correct type of the first arg in the
	function prototype.

	* htmlobject.c (copy): init the datalist before we start copying
	the items into it.  This was cause lots of segfaults in the
	editor.

2000-11-02  Radek Doulik  <rodo@helixcode.com>

	* htmltokenizer.c (prepare_enough_space): raise reserve in buffer
	from 5 to 32

2000-11-01  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml.c (load_bindings_from_file): use g_file_test instead of
	g_file_exist

	* htmltable.c (destroy): fixed cell skipping contidion

	* htmlengine.c (parse_table): ignore nowrap if width is set

	* htmltokenizer.c (html_tokenizer_begin): don't alloc buffer
	(html_tokenizer_end): ser t->size to 0
	(prepare_enough_space): grow t->size by 1/4*t->size + 5
	(TOKEN_BUFFER_SIZE): changed initial token buffer size to 1 << 10

2000-10-31  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml.c: likewise

	* gtkhtml-im.c: replaced GTKHTML_USE_XIM with GTK_HTML_USE_XIM

	* gtkhtml.c (gtk_html_editor_command): do editor command
	(gtk_html_editor_event_command): new function, "emits"
	EditorAPI event
	(get_value_nick): helper function
	(load_keybindings): added KP_Enter
	(key_press_event): use event->string if e_utf8_from_gtk_event_key
	doesn't handle that, also use it only if length == 1 and string
	[0] < 0x80 as we don't want illegal UTF-8 sequences

	* htmltext.c (spell_error_destroy): commented out g_free 

	* htmlengine-edit-fontstyle.c: removed old unused code, this
	avoids warnings and this code still remain in older versions in
	CVS

	* htmlengine-edit-delete.c (html_engine_delete): use
	html_clueflow_new_from_flow

	* htmlengine-edit-insert.c (insert_para): use
	html_clueflow_new_from_flow

	* htmlclueflow.c (html_clueflow_new_from_flow): new function,
	creates new clueflow with same attributes (style, level,
	object_data)
	(html_clueflow_split): use html_clueflow_new_from_flow

	* htmlobject.c (html_object_copy_data_from_object): new function,
	copies data references from src object to dest one

	* gtkhtml.c (command): new command implemented

	* gtkhtml.h: added command indent-zero

	* gtkhtml.c (gtk_html_set_indent): renamed from gtk_html_indent
	(gtk_html_modify_indent_by_delta): new function

	* htmlclueflow.c (html_clueflow_modify_indentation_by_delta):
	renamed from old html_clueflow_indent

	* keybindingsrc.emacs: likewise

	* keybindingsrc.ms: changed to use ...-toggle

	* gtkhtml.h: renamed toggle bold/italic/underline/strikeout
	commands, added on/off bold/italic/underline/strikeout commands

2000-10-30  Radek Doulik  <rodo@helixcode.com>

	* htmlengine-edit.c (html_engine_set_data_by_type): new function,
	sets data to objects with given type

	* htmlobject.c (html_object_set_data): new function for setting
	object data
	(html_object_get_data): new function for accessing object data

	* htmlobject.h: added object_data

	* htmltype.c: added hash table type name --> type
	(build_type_names_table): helper function for initial build of
	type_names hash table
	(html_type_from_name): new function, translates type name to type
	using type_names table

2000-10-29  Radek Doulik  <rodo@helixcode.com>

	* htmlengine-edit-insert.c (insert_para): emit editor event with
	INSERT_PARAGRAPH command

	* gtkhtml.c (gtk_html_editor_event_command): new function

	* gtkhtml.h (struct _GtkHTMLEditorAPI): added event to EditorAPI

2000-10-26  Michael Meeks  <michael@helixcode.com>

	* htmlprinter.c (alloc_font): signdness fix.

	* htmlengine-edit-text.c (upper_lower): ditto.

	* htmlengine-edit-text.c (find_first): ditto.

2000-10-26  Radek Doulik  <rodo@helixcode.com>

	* htmlengine.c (parse_body): call insert_text also for spaces

	* htmlfontmanager.c (alloc_new_font): g_strdup key while inserting
	to hash table
	(destroy_font_set_foreach): g_free key while removing from hash
	table

	* gtkhtml-private.h: include config.h

	* gtkhtml-im.c: include config.h

	* htmlrule.c (fit_line): new virtual method implementation
	(draw): updated for new sizing
	(calc_size): likewise
	(html_rule_class_init): set fit_line

2000-10-25  Radek Doulik  <rodo@helixcode.com>

	* htmltokenizer.c: changed pre to gint to imitate stacked
	behaviour of parser
	(end_tag): updated for stacked pre

	* htmlengine.c (parse_b): added </br> with the same meaning as
	<br> to render broken pages

	* gtkhtml-properties.c: added GTK_HTML_COMMAND_INSERT_RULE

	* keybindingsrc.emacs: added popup-menu, property-dialog,
	insert-rule

	* keybindingsrc.ms: added popup-menu, property-dialog

	* gtkhtml.c (command): implemented insert-rule

	* keybindingsrc.ms: added insert-rule

	* htmlclueflow.c (html_clueflow_spell_check): likewise

	* gtkhtml.c (command): use editor_data instead of spell_data

	* htmlclueflow.c (html_clueflow_spell_check): likewise

	* gtkhtml.c (init): likewise
	(command): likewise

	* htmlengine.c (html_engine_spell_check): use editor_api

	* gtkhtml.c (gtk_html_set_editor_api): updated to set EditorAPI

	* gtkhtml.h (struct _GtkHTMLEditorAPI): extend EditSpellAPI to
	general EditorAPI

	* gtkhtml-properties.c: added new commands

	* gtkhtml.h: added new editor commands for popup menu and property
	dialog

2000-10-24  Radek Doulik  <rodo@helixcode.com>

	* htmlengine-save.c (get_body): added background attribute

2000-10-23  Radek Doulik  <rodo@helixcode.com>

	* htmlengine.c (parse_d): set divAlign to left before parsing
	actual alignment
	(parse_p): likewise

	* htmlengine-edit.h: publicate in scope of gtkhtml sources some
	usefull functions for translating between types

	* htmlengine-save.c (html_engine_save_get_paragraph_style): new
	helper function
	(html_engine_save_get_paragraph_align): likewise

	* htmlclueflow.c (save): fixed typo

	* gtkhtml.h: gtk_html_load_from_string const safe

	* htmlengine.c (parse_one_token): commented out warning

	* gtkhtml.c (cursor_move): not abort with bad params, only warn
	(move_selection): likewise
	(scroll): likewise
	(gtk_marshal_NONE__INT_INT_FLOAT): added new marshaler

2000-10-20  Radek Doulik  <rodo@helixcode.com>

	* htmlengine-save.c (html_engine_save_get_sample_body): new
	function, used by component for sample views
	(get_body): helper function extracted from write_header
	(write_header): use get_body

	* htmlengine-edit-insert.c (html_engine_insert): try to make magic
	links also after '>', ')' - this could simplify of mail adresses,
	for example Ape <primate@helixcode.com> should do the right thing
	now ;-)

	* htmlengine-edit.c (html_is_in_word): changed back from isalnum
	to isalpha

2000-10-19  Radek Doulik  <rodo@helixcode.com>

	* htmltable.c (bin_search_eq_or_lower_index): fixed to not access
	a [-1]

	* gtkhtml-input.c (focus_out): add focus_out signal handler for
	entry
	(set_html_focus): new helper function to set focus back to html
	widget
	(gtk_html_input_line_deactivate): don't set focus to html widget,
	leave that on set_html_focus
	(key_press_event): use set_html_focus
	(focus_out): call set_html_focus in idle callback (otherwise focus
	will be broken)

2000-10-18  Radek Doulik  <rodo@helixcode.com>

	* keybindingsrc.ms: like for emacs

	* keybindingsrc.emacs: changed indentation bindings

	* gtkhtml.c (command): reset html->binding_handled to TRUE in
	editable part

	* htmlclueflow.c (save_plain): add \n for empty paragraphs

	* keybindingsrc.emacs: removed C-left, C-right as they are already
	in standard bindings

	* gtkhtml.c (load_keybindings): removed M-f, M-b from default
	binding

2000-10-17  Radek Doulik  <rodo@helixcode.com>

	* htmlengine-edit-fontstyle.c (object_set_font_style): changed
	order or bit operations, first do OR and then AND
	(html_engine_set_font_style): likewise

	* gtkhtml.c (gtk_html_load_from_string): new helper function, does
	begin, write, end to simplify short/easy html doc loading

	* htmltokenizer.c (in_plain): declare as inline

	* htmltable.c (get_bounds): extract method
	(check_point): optimize

	* htmlentity.c (html_entity_parse): kill warning

	* htmliframe.c (iframe_object_requested): set ret_val only once

	* htmlengine.c (parse_object): don't discard body if we get object
	requested and discard it otherwise

2000-10-16  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml-embedded.c (gtk_html_embedded_set_parameter): check for
	already set parameters and don't leak memory

	* htmlengine-save.c (encode_entities): update to non-utf8 texts,
	save all 8bit range instead of encoding it as #-1; it's wrong
	here, but it may work at least with iso-latin-1 I hope,
	new painter should replace it soon
	(write_header): set charset to UTF-8
	(encode_entities): reverted last change

2000-10-15  Radek Doulik  <rodo@helixcode.com>

	* htmltext.c (save_plain): cut down text from utf8 to 8bit before
	plain saving (this fixes anoying A^ for now, should be replaced
	later by text painter)

	* htmlclueflow.c (save_plain): replaced '\240' with ENTITY_NBSP to
	avoid compiler warnings and kill always true compares
	(save_plain): don't use unicode functions here, as text is not in
	utf8 now

2000-10-13  Lauris Kaplinski  <lauris@helixcode.com>

	* htmltokenizer.c: Renamed g_unichar_to_utf8 to html_unichar_to_utf8

2000-10-13  Radek Doulik  <rodo@helixcode.com>

	* htmlengine-edit-rule.c (html_rule_set): new function for setting
	rule parameters

2000-10-12  Larry Ewing  <lewing@helixcode.com>

	* htmlclueflow.c (save_plain): wrap the text contained within the
	clue.
	(plain_padding): helper function to determine line padding
	(string_append_len): helper funtion to encode write lengths of
	text.

	* htmlclue.c (save_plain): add arg.

	* htmltext.c (save_plain): add arg.

	* htmlobject.h: add width args to save_plain functions.

	* htmlobject.c (save_plain): add requested_width arg.
	(html_object_save_plain): add arg.

	* htmlengine-save.h: add prototype for save buffer functions.

	* htmlengine-save.c: added functions to create a save buffer to
	hold text before wrapping.
	
2000-10-12  Radek Doulik  <rodo@helixcode.com>

	* htmlrule.c (copy): copy also length and size

2000-10-11  Radek Doulik  <rodo@helixcode.com>

	* Makefile.am (CFLAGS): removed pspell flags
	(testgtkhtml_LDADD): removed pspell libs

2000-10-11  Larry Ewing  <lewing@helixcode.com>

	* htmlengine-edit-selection-updater.c (extend_selection): handle
	the NULL obj here as well.

2000-10-10  Larry Ewing  <lewing@helixcode.com>

	* htmlengine-edit-selection-updater.c (extend_selection): make
	sure tht we deal gracefully when next/prev leaf is NULL.

	* htmlobject.c (destroy): add code to poison destroyed memory.

2000-10-10  Radek Doulik  <rodo@helixcode.com>

	* new spell checking API GtkHTMLEditSpellAPI, it's here as I don't
	want to make libgtkhtml depend on Bonobo, just editor component
	which will use this API

	* removed pspell checking #ifdef's

	* gtkhtml-private.h: like below

	* gtkhtml.c (set_fonts_idle): test for GTKHTML_HAVE_GCONF instead
	of PSPELL which was mistaken
	(set_fonts): likewise

	* htmltable.c (expand_columns): use g_renew
	(expand_rows): likewise
	(inc_rows): expand rows by .25*allocRows instead of +10

2000-10-09  Larry Ewing  <lewing@helixcode.com>

	* htmltext.c (convert_nbsp): initialize rv and rp to NULL.

	* htmlfontmanager.c (alloc_new_font): initialize font to NULL.

	* gtkhtml.c: update to use priv structure.
	(destroy): free priv structure.
	(init): allocate the priv structure.
	(class_init): always initialize the spell suggestion signal.

	* gtkhtml.h: Move several of the gtkhtml public structure entries 
	to a private structure. Always include the spell_suggestion
	request signal so that our class structure does not change size.
	Also always define all the entries in the Command type enum so
	that values do not change based on the inclusion of spelling
	support.

	* gtkhtml-im.c: use html->priv for the gdk input method
	structures.

	* gtkhtml-private.h: add structure definition for GtkHTMLPrivate
	here.

2000-10-06  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml.c (BSCROLL): use GTK_TYPE_SCROLL_TYPE instead of
	GTK_TYPE_ENUM

	* htmlembedded.c (calc_min_width): calc it only if widget is
	already realized, use allocation
	(calc_size): likewise

	* gtkhtml.c (size_allocate): call calc_size only when clue
	min_width is less than available width

	* htmltable.c (draw): optimized drawing, hopefully call draw
	method only on cells in drawed area, use bin_search_eq_or_lower_index
	(bin_search_eq_or_lower_index): helper function

	* htmltokenizer.c (prepare_enough_space): inc tokenizer buffer in
	bigger steps + use realloc

2000-10-04  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml.c (set_editor_keybindings): new helper function
	(gtk_html_set_editable): use set_editor_keybindings
	(load_bindings_from_file): new extracted function
	(load_keybindings): use load_bindings_from_file

	* gtkhtml.h: add editor_bindings to GtkHTML

	* gtkhtml.c (command): new commands implementation

	* gtkhtml.h: new commands - focus-forward/backward

	* gtkhtml.c (focus): container signal handler
	(class_init): add focus

2000-10-03  Radek Doulik  <rodo@helixcode.com>

	* htmlengine.c (html_engine_update_event): do cursor home only
	when newPage is TRUE

	* htmltext.c (insert_text): set changes also to parent clue

	* gtkhtml.c (gtk_html_set_paragraph_style): call queue_draw to
	make cursor visible

	* htmlclueflow.c (html_clueflow_set_style): schedule update
	(relayout): new method, if min_width > max_width do
	engine_calc_size and draw

2000-10-02  Radek Doulik  <rodo@helixcode.com>

	* kill some warnings

	* htmltable.c (prev_col_do_cspan): alloc cells before doing
	column spanning

	* htmltokenizer.c (in_plain): use g_unichar_to_utf8

	* htmltable.c (scale_columns): use cell->col
	(calc_column_widths): likewise
	(calc_row_heights): use cell->row
	(calc_size): use cell->col
	(draw): use cell->col and cell->row

2000-09-29  Larry Ewing  <lewing@helixcode.com>

	* gtkhtml.h: turn GTK_HTML_USE_XIM off for the time being.

	* gtkhtml-im.c: wrap contents in ifdef since the structures will
	not be defined.
	
2000-09-29  Larry Ewing  <lewing@helixcode.com>

	* gtkhtml.c (style_set): 
	(realize): 
	(unrealize): 
	(size_allocate): 
	(focus_in_event): 
	(focus_out_event): add entry points for XIM handling.  This is the
	first pass integrating the XIM patches from
	garetxe@euskalnet.net

	* gtkhtml.h: define GTK_HTML_USE_XIM until the configure check is
	written
 
	* gtkhtml-im.c: file added

	* gtkhtml-im.h: file added

2000-09-29  Radek Doulik  <rodo@helixcode.com>

	* htmlengine-search.c (add_iframe_off): new helper function
	(move_to_found): updated to work with IFrames

	* gtkhtml-search.c (changed): call html_engine_search_incremental
	only for non "" texts

	* htmltable.c (html_table_end_table): don't cal lprev_col_do_cspan
	anymore

	* htmliframe.c (search): fixes

2000-09-29  Joe Shaw  <joe@helixcode.com>

	* htmltable.c (do_rspan): Remove printf.
	(html_table_add_cell): call do_cspan after setting the cell so that
	column spanning works correctly.

2000-09-29  Radek Doulik  <rodo@helixcode.com>

	* htmltable.c (inc_columns): fix col calculation

2000-09-28  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml-search.c (changed): update for
	html_engine_search_incremental changes

	* htmlengine-search.c (html_engine_search_incremental): updated,
	so it could be used without former call to html_engine_search,
	also added forward argument

	* htmltable.c (scale_columns): fixed condition, where r could be
	as high as table->totalRows, which was invalid
	refactored + fixed col/row span

2000-09-27  Radek Doulik  <rodo@helixcode.com>

	* htmltextslave.c (calc_size): updated to UTF8 (I've missed this
	one before, *sigh*)
	(fit_line): use html_text_get_text
	(fit_line): likewise
	(draw_spell_errors): likewise
	(draw_normal): likewise
	(html_text_slave_get_offset_for_pointer): likewise

	* gtkhtmldebug.c (gtk_html_debug_dump_object): new function
	(gtk_html_debug_dump_object): updated slave printing to UTF8

	* htmliframe.c (calc_min_width): don't call html_engine_calc_size
	as it is not needed

	* htmlengine.c: include htmlengine-search.h

	* htmltablecell.c (html_table_cell_class_init): removed
	set_max_width virtual method as it was the same as parent class
	(ClueV)

	* htmlcluev.c (do_layout): extracted get_lmargin
	(get_lmargin): new helper function

	* htmltable.c (html_table_add_cell): increase table->col by
	previous cell colspan

	* htmlclueflow.c (spell_check_word_mark): use interval length
	instead of text_len
	(html_clueflow_spell_check): likewise

	* htmltable.c (optimize_cell_width): fixed calculation of addSize
	(calc_size): fixed calculation of available_width
	this fixes annoying horizontal scrollbar appearance in evolution

2000-09-26  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml-search.c (key_press): test e->search_info != NULL

	* htmlsearch.c (html_search_set_forward): added assert

	* gtkhtml.c (move_selection): set binding_handled = TRUE
	(command): binding_handled = FALSE
	(key_press_event): don't call parent key_press handler, as it
	calls bindings_activate, which we don't want to be called again

	* htmliframe.c (search): new virtual method implementation,
	forwards search down the iframe

	* htmlengine-search.c (display_search_results): unselect also for
	root engine (right now it's iframe parent's engine if iframe
	parent != NULL)
	(get_root_engine): helper function

	* htmlengine-search.[ch]: new files, search stuff moved here from
	htmlengine.[ch]

	* htmltokenizer.c (html_tokenizer_write): refactored

2000-09-21  Radek Doulik  <rodo@helixcode.com>

	* htmlengine.c (html_engine_init): don't use gtk_object_unref in
	embedded stack - this should fix Joe's problem - I'll look closer
	on this later

	* htmlimage.c: refcounting for image pointers

2000-09-20  Radek Doulik  <rodo@helixcode.com>

	* htmlengine.c: update timeouts replaced by idle callbacks
	(html_engine_begin): move factory cleanup + stop
	animations here

	* htmltextmaster.c (html_text_master_magic_link): fixed for ' '
	case

	* htmltext.c (convert_nbsp): reset state to 0 after first pass

	* htmltextmaster.c (html_text_master_magic_link): test mim
	[i].preg != NULL

	* htmliframe.c (set_painter): remember gdk_painter
	(draw): draw only with non-gdk painters, also move widget to right
	place

	* gtkhtml.c (focus_in_event): fixed iframes handling
	(button_press_event): fixed mouse wheel scrolling with iframes

2000-09-19  Radek Doulik  <rodo@helixcode.com>

	* htmlprinter.c (draw_text): updated to UTF8

	* gtkhtml.c (key_press_event): check for str != NULL

	* htmlgdkpainter.c (draw_text): use unicode_strlen
	instead of strlen

	* htmlengine-edit-insert.c (html_engine_insert): use unicode_strlen
	instead of strlen
	(do_insert): updated to utf8

	* htmlgdkpainter.c (draw_spell_error): fixed off/len calculation

	* htmlclueflow.c (spell_check_word_mark): use unicode_strlen
	instead of strlen

2000-09-18  Radek Doulik  <rodo@helixcode.com>

	* htmlgdkpainter.c: use e-font
	(get_font): look for unicode font first

	* gtkhtml.c (key_press_event): use e_utf8_from_gtk_event_key

2000-09-15  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml.h: rename button_pressed flag to button1_pressed and use
	if for button 1 only

	* htmlembedded.c (destroy): remove widget from html widget

2000-09-14  Dan Winship  <danw@helixcode.com>

	* htmlembedded.c (destroy): Just hide the embedded widget rather
	than destroying it, to prevent it from being destroyed twice.

2000-09-14  Radek Doulik  <rodo@helixcode.com>

	* htmlengine-edit-movement.c (html_engine_forward_word): refactored
	(html_engine_backward_word): likewise

	* gtkhtml.c (load_keybindings): added M-left, M-b bindings for
	backward-word and likewise for forward-word

	* htmltable.c (set_cell): new helper function, sets cell in table
	on col,row
	(add_cell): refactored set_cells function, filling table with
	cells, which have cspan or rspan > 1 is delayed to
	html_table_end_table, also use set_cell
	(cell_fill): new helper function, fills cell in table (if cspan or
	rspan > 1)
	(html_table_end_table): fill table with cells here
	(get_rc): not needed anymore
	(next): remove call to get_rc
	(prev): likewise

	* htmltablecell.h: added position info to TableCell (col, row)

	* htmlengine-save.c (encode_entities): updated for utf8

	* htmlclueflow.c (spell_check_word_mark): index -> offset and not
	reversed

2000-9-13  Larry Ewing  <lewing@helixcode.com>

	* htmliframe.c (iframe_object_requested): hook up the object
	requested signal.

2000-09-13  Radek Doulik  <rodo@helixcode.com>

	* htmlengine.c (html_engine_set_arg): configure pspell to use utf8
	encoding

	* htmltext.c: use unicode_offset_to_index and
	unicode_index_to_offset everywhere
	(convert_nbsp): updated to support utf8

	* htmlgdkpainter.c (utf8_gdk_text_width): last argument changed to
	len and bytes are calculated using unicode_offset_to_index
	(utf8_gdk_draw_text): likewise

2000-09-12  Radek Doulik  <rodo@helixcode.com>

	* htmltextslave.c (draw_spell_errors): use HTMLSpellErrorColor

	* htmlengine.c (html_engine_set_arg): moved spell initialization
	here

	* htmlclueflow.c (html_clueflow_spell_check): do live spell
	checking only if enabled in properties

	* gtkhtml.c: added support for spell checking properties
	(init_properties_widget): new helper function

	* gtkhtml-properties.h: added spell properties

	* htmlcolorset.h (_HTMLColorId): added HTMLSpellErrorColor

	* htmltextslave.c (draw_spell_errors): use HTMLSpellErrorColor

2000-09-08  Radek Doulik  <rodo@helixcode.com>

	* testgtkhtml.c (print_preview_cb): add footer printing (- page number -)
	(print_footer): footer printing

	* htmltextslave.c (fit_line): add cast to make compiler happy

	* htmlprinter.c (do_rectangle): refactored, split to do_rectangle
	and prepare_rectangle
	(prepare_rectangle): new helper function, also do coordinates
	conversions here
	(set_clip_rectangle): implemented this method, also use
	prepare_rectangle

	* htmlobject.c (check_page_split): return 0 instead of y as we
	don't want include this object in upcoming page (it doesn't fit
	there - this is the reason it was called)

	* htmliframe.c (check_page_split): forward to Engine::clue

	* htmlclueflow.c (check_page_split): removed, no more needed

	* htmlclue.c (check_page_split): moved here from ClueV + updated

	* htmlprinter.c (html_printer_scale_to_gnome_print): exported this
	function for engine
	(html_printer_coordinates_to_gnome_print): likewise

	* htmlengine-print.c (html_engine_print_with_header_footer): likewise
	(print_header_footer): helper function for header/footer printing
	(print_page): use print_header_footer

	* gtkhtml.c (gtk_html_print_with_header_footer): new function,
	allows printing headers/footers

	* htmlfontmanager.c (alloc_new_font): pass face_list to
	html_font_set_new instead of *face which is already freed

	* htmlprinter.c: likewise

	* htmlpainter.c: likewise

	* htmlgdkpainter.c: update fort fontmanager changes

	* htmlpainter.h: add unref_font virtual method

	* htmlfontmanager.c: use ref/unref_font everywhere
	(html_font_manager_get_font): ref font if using default instead of
	unavailable face

	* htmlfontmanager.h: add ref_font + unref_font to font manager

2000-09-06  Lauris Kaplinski  <lauris@helixcode.com>

	* htmlgdkpainter.c (utf8_gdk_text_width): translate 0xa0 -> 0x20
	(utf8_gdk_draw_text): Same

2000-09-06  Radek Doulik  <rodo@helixcode.com>

	* htmltextslave.c (fit_line): fixed eating condition once again

	* htmlgdkpainter.h: removed font_style from gdk_painter as it is
	obsolete

	* htmlgdkpainter.c (draw_text): use painter->font_style instead of
	gdk_painter->font_style

	* htmlfontmanager.c (alloc_new_font): create empty set if none of
	faces exists

	* htmltextslave.c (fit_line): dont eat beggining space on
	beginning of paragraph

	* htmlclueflow.c (html_clueflow_spell_check): don't check spell if
	tail is NULL

	* htmltokenizer.c (html_tokenizer_add_pending): don't insert 0xa0
	instead of space - no more needed and it was causing problems as
	0xa0 is not used for &nbsp; anymore

	* htmlgdkpainter.c (draw_spell_error): fix width calculation

2000-09-05  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml.c (scroll): lower page increment by one "standard" line
	height

	* htmlfontmanager.c (html_font_set_get_idx): dec size for index
	(html_font_set_get_idx): handle GTK_HTML_FONT_STYLE_DEFAULT case
	(get_font_size): tuned so that it works fine with 12pt default
	font
	(get_real_font_size): renamed from get_font_size
	(get_font_num): new helper function
	(html_font_set_get_idx): use it
	(get_real_font_size): use it
	(html_font_set_font): test if new font isn't the same one

	* gtkhtmlfontstyle.h (GTK_HTML_FONT_STYLE_MAX_FONT): use ITALIC
	instead of BOLD

2000-09-04  Radek Doulik  <rodo@helixcode.com>

	* htmltable.c (calc_column_widths): use pixel_size
	(calc_row_heights): use pixel_size

	* htmlcluev.c (do_layout): use pixel_size for padding

	* htmlengine-print.c (html_engine_print): use them

	* gtkhtml-properties.[ch]: add separate font family/sizes for
	printing

2000-09-01  Radek Doulik  <rodo@helixcode.com>

	* htmlfontmanager.[ch]: new fontmanager

	* htmlgdkpainter.c (utf8_gdk_text_width): move html_gdk_text_width
	here, as htmlgdkfontmanager.c is obsolete now
	(utf8_gdk_draw_text): likewise

	* htmlpainter.c (html_painter_set_font_style): make this method
	static
	(html_painter_get_font_style): likewise
	(html_painter_set_font_face): likewise

	* gtkhtml.c (set_fonts_idle): use new font manager

2000-08-31  Lauris Kaplinski  <lauris@helixcode.com>

	* htmlgdkfontmanager.h:
	* htmlgdkfontmanager.c (html_gdk_text_width): Calculate UTF-8 text width
	(html_gdk_draw_text): Draw UTF-8 text

	* htmlgdkpainter.c (draw_spell_error): Use fontmanager text width
	(draw_text): Use fontmanager methods
	(calc_text_width): Same

	* htmltokenizer.c (html_tokenizer_write): Convert entityValue to UTF-8
	
2000-08-31  Radek Doulik  <rodo@helixcode.com>

	* htmlgdkfontmanager.c (font_face_exists): free list
	(html_gdk_font_manager_find_face): fixed walk thru families which
	has been broken by Lauris rewrite

	* htmliframe.c (draw): forwards draw to embeded widget
	(set_painter): sets painter to embeded widget's engine
	(forall): forward forall method
	(calc_size): don't use pixel_size here
	(html_iframe_class_init): set new virtual function implementations

	* htmlengine-print.c (html_engine_print): use
	html_engine_set_painter

	* htmlengine.c (html_engine_set_painter): new function, sets
	painter to engine

	* htmlobject.c (set_painter): new virtual method
	(html_object_set_painter): new function, uses forall to call
	set_painter on all objects
	(set_painter_forall): helper function

	* gtkhtml-input.c (gtk_html_input_line_destroy): deactivate only
	if previosly activated, fixed unref of ebox instead of frame

2000-08-30  Radek Doulik  <rodo@helixcode.com>

	* testgtkhtml.c: added Simple tree dump to debug menu

2000-08-29  Radek Doulik  <rodo@helixcode.com>

	* htmlclue.c 

	* htmltable.c (append_selection_string): new method
	(html_table_class_init): added append_selection_string

	* htmlclueflow.c (append_selection_string): call Clue super method
	here

	* htmlclue.c (append_selection_string): added selection string
	getting method to Clue
	(html_clue_class_init): added append_selection_string

	* htmlengine.c (get_selection_forall_func): removed
	(html_engine_get_selection_string): instead of calling foreach, do
	traversing thru tree in Object methods

2000-08-28  Ettore Perazzoli  <ettore@helixcode.com>

	* gtkhtml-properties.c (DEFAULT_FONT_SIZE, DEFAULT_FONT_SIZE_S):
	New #defines.  The default font size is now 12 points, instead of
	the huge 14 point.
	(gtk_html_class_properties_new): Use them.
	(gtk_html_class_properties_load): Use them.

2000-08-28  Radek Doulik  <rodo@helixcode.com>

	* htmlgdkfontmanager.c (html_gdk_font_manager_find_face): do
	return activities only on one place

	* htmlengine-edit.c (html_engine_selection_pop): switched cursor
	and mark here

2000-08-27  Lauris Kaplinski  <lauris@helixcode.com>

	* gtkhtml.c (set_fonts_idle): Use fontmanager method
	(set_fonts): #ifdef GTKHTML_HAVE_GCONF to kill warning

	* htmlengine.c (parse_font_face): Use painter method instead

	* htmlentity.h: Removed html_entity_prepare, as 0x160 is valid
	unicode char

	* htmlentity.c (html_entity_parse): Use hash table

	* htmlfont.h:
	* htmlfont.c: Removed Gdk dependant parts (which were unused)

	* htmlfontface.h: Removed Gdk dependant members and al methods

	* htmlfontface.c: This is empty now, so will be removed

	* htmlgdkfontmanager.h: Added HTMLGdkFontFace structure
	(html_gdk_font_manager_find_face): Replacement
	(html_gdk_font_manager_set_fixed): Set fixed family + size
	(html_gdk_font_manager_set_variable): Set variable family + size

	* htmlgdkfontmanager.c: Moved htmlfontface stuff here to increase
	code managebility

	* htmlgdkpainter.c (calc_ascent): Use (HTMLGdkFontFace *) cast
	(calc_descent): Same
	(calc_text_width): Same
	(draw_text): Dont translate 0xa0 -> 0x20
	(find_font_face): New class method

	* htmlpainter.h (::find_font_face): New class method
	(html_painter_find_font_face): New accessor function
	* htmlpainter.c: Same
	
2000-08-24  JP Rosevear  <jpr@helixcode.com>

	* Makefile.am: Build testgtkhtml with glibwww2

2000-08-24  Ettore Perazzoli  <ettore@helixcode.com>

	* gtkhtml.c (motion_notify_event): Return FALSE if this is not the
	window we are interested in.
	(button_press_event): Don't add a GTK+ grab.  Check the result of
	the grab.  Use the right window.  Don't set `owner_events'.

2000-08-22  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml-properties.c (gtk_html_class_properties_new): defaults
	to 14pt and helvetica

	* gtkhtml.c (init_properties): load properties here for non-gconf
	version

	* gtkhtml-properties.c (gtk_html_class_properties_load): changed
	gnome-config default font size to 14pt and var font to helvetica
	(gtk_html_class_properties_load): removed gnome_config_sync call

	* gtkhtml.c (on_object): renamed from on_url
	(on_object): reset html->pointer_url to NULL and mouse cursor to
	html->arrow_cursor
	(enter_notify_event): new event handler, call mouse_change_pos
	here

	* htmlengine.c (parse_body): don't insert " ", this fixes problem
	with linked images but maybe broke another cases? any complains?
	(parse_d): fix <div> case when on beggining of new flow (head ==
	NULL) set e->flow align to divAlign

	* htmlclueflow.c (calc_size): disabled width setting to rmargin -
	o->x (Larry could you pls check this?)

	* htmltext.c (html_text_init): don't call convert_nbsp here as we
	want &nbsp; not disappear from texts

	* htmlclueflow.c (calc_preferred_width): use
	html_object_next_not_slave instead of obj->next and
	html_object_prev_not_slave likewise

2000-08-21  Mathieu Lacage <mathieu@eazel.com>

	* src/Makefile.am : add LIBADD variable so that ldd reports correct
	output on libgtkhtml.so

2000-08-21  Radek Doulik  <rodo@helixcode.com>

	* htmlclueflow.c (next_obj_and_clear): fixed for interval checking
	(spell_check_word_mark): likewise

	* htmltext.c (html_text_init): initialize face to NULL

	* gtkhtml.c (set_fonts_idle): use html_gdk_font_manager_set_size,
	so fonts scale nicely when changing size of variable width fonts
	in capplet
	(set_fonts_idle): get fixed face for fix and not variable

	* htmlgdkfontmanager.c (html_gdk_font_manager_set_size): new
	function, sets size to all non-default faces

	* htmlgdkfontmanager.[ch]: rewritten

	* htmlfontface.[ch]: new files

	* htmlengine.c (current_font_face): new helper function
	(push_font_face): likewise
	(pop_font_face): likewise
	(parse_font_face): likewise

	* gtkhtml.c (gtk_html_construct): moved set_fonts + gconf
	notification here, because engine is created
	(gtk_html_construct): call set_fonts_idle instead of set_fonts

	* htmlengine.c (html_engine_init): initialize clue to NULL

2000-08-18  Larry Ewing  <lewing@helixcode.com>

	* gtkhtml.c (set_fonts_idle): check to make sure we have an engine
	and a clue before we start operating on it.  I'll look more
	carefully at this tomorrow, but I need to read mail now.

2000-08-17  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml.c (init): add gconf notification

	* htmlgdkfontmanager.c (html_gdk_font_manager_set_family_var): new
	helper function
	(html_gdk_font_manager_set_family_fix): new helper function
	(html_gdk_font_manager_set_size_var): new helper function
	(html_gdk_font_manager_set_size_fix): new helper function
	(release_fonts): new helper function - releases loaded fonts
	(load_font): rewritten
	(get_closest_font): helper function, tries get closest font to
	required, if not found returns fixed font or g_assert's when fixed
	is not available
	(get_font): helper function
	(test_font): helper function, uses XListFonts
	(get_size): helper function, gets font size from font name

	* htmlgdkfontmanager.h: added family_var, family_fix, size_var and
	size_fix attributes

	* gtkhtml.c (client_notify_class): class gconf notification
	(client_notify_widget): widgets notification, font attributes are
	set here
	(set_fonts): helper function for font setting
	(set_fonts_idle): idle cb for font setting

	* gtkhtml-properties.c (gtk_html_class_properties_new): set
	default values for font attributes
	(gtk_html_class_properties_load): updated
	(gtk_html_class_properties_update): updated
	(gtk_html_class_properties_save): updated

	* gtkhtml-properties.h: added new attributes for fonts settings

2000-08-15  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml.c (button_press_event): do paste only in editable widget

	* htmlengine.c (html_engine_get_word): likewise
	(html_engine_word_is_valid): likewise
	(html_engine_replace_word_with): likewise

	* htmlengine-edit.c (html_engine_spell_check_range): likewise

	* htmlclueflow.c (html_clueflow_spell_check): use html_is_in_word
	instead of isalpha

2000-08-14  Radek Doulik  <rodo@helixcode.com>

	* htmlengine.c (selection_helper): new helper function
	(html_engine_select_line): use selection_helper here
	(html_engine_select_word): likewise
	(word_interval): select word interval for selection_helper used in
	select_word
	(line_interval): likewise

	* gtkhtml.c (gtk_html_select_word): respect allow_selection
	(gtk_html_select_line): likewise

	* htmlengine.c (html_engine_select_line): use html_interval_select

	* htmlinterval.c (html_interval_select): new function, selects
	interval into selection

	* htmlengine.c (html_engine_set_active_selection): new fuction,
	sets active_selection flag + gtk selection owner
	(html_engine_get_cursor): new function, returns cursor with actual
	position, works also for non-editable widget

	* gtkhtml.c (gtk_html_select_word): new function, selects word
	(gtk_html_select_line): new function, selects line
	(button_press_event): select word by 2xclick and line by 3xclick

	* htmlengine-edit.c (html_engine_select_word_editable): new
	function, same as below, but for editable widget
	(html_engine_select_line_editable): likewise

	* htmlengine.c (html_engine_select_word): new function, selects
	word after mouse 2xclick
	(html_engine_select_line): likewise for line

	* htmlobject.c (html_object_next_by_type): new helper function
	(html_object_prev_by_type): likewise

	* htmlengine.c (html_engine_select_region): removed queue_draw
	arg (it was always used as TRUE)
	(html_engine_unselect_all): likewise

	* htmlengine-edit-delete.c (html_engine_delete): use
	html_engine_spell_check_range here

	* htmltext.c (split_spell_errors): new helper function
	(split): use split_spell_errors here
	(html_text_spell_errors_add): use g_list_insert_sorted here as we
	could now add new errors in the middle of list instead of
	appending to the end

2000-08-13  Radek Doulik  <rodo@helixcode.com>

	* htmlengine-edit-insert.c (insert_para): use
	html_engine_spell_check_range here
	(insert_chars): refactored, return only on end of function,
	updated to use html_engine_spell_check_range here, do also
	html_engine_move_cursor instead of calling it in do_insert twice

	* htmlengine-edit.c (html_engine_spell_check_range): new function,
	does spell checking on range given by two cursors - cursors must
	be in same paragraph

	* htmlclueflow.c (html_clueflow_spell_check): updated to work on
	interval
	(spell_check_word_mark): likewise
	(next_obj_and_clear): likewise
	(get_text): likewise

	* htmlinterval.[ch]: new files for helper HTMLInterval API +
	implementation

	* htmltext.c (move_spell_errors): new helper function, moves spell
	errors after offset by delta
	(remove_spell_errors): new helper function remove spell errors in
	length len after offset
	(insert_text): use move_spell_errors here
	(remove_text): use move_spell_errors and remove_spell_errors here
	(html_text_spell_errors_clear_interval): new function, clears
	spell errors in interval

2000-08-11  Radek Doulik  <rodo@helixcode.com>

	* htmlengine.c (html_engine_get_word): don't use engine cursor but
	make dup instead

	* htmlclueflow.c (get_text): refactored
	(interval_get_start): new helper function, computes starting
	offset in obj relevant to interval
	(interval_get_len): new helper function, computes object len
	relevant to interval
	(get_text_len): extracted from get_text, simplified
	(get_text): uses get_text_len
	(next_obj): simplified, uses html_object_get_length now

	* htmltextslave.c (html_text_slave_class_init): added get_length
	virtual method
	(get_length): return 0 here

2000-08-11  Larry Ewing  <lewing@helixcode.com>

	* htmltextslave.c (html_text_slave_trail_space_width): removed
	this as it is no longer needed.

	* htmltextslave.h: remove html_text_slave_trail_space_width
	prototype.

	* htmlclueflow.c (calc_size): stop subracting the width of the
	trailing space of the total width of the cluflow.  This is no
	longer needed and was causing artifacts.

2000-08-10  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml.c (load_keybindings): disabled g_warning about missing
	binding file

	* htmlclueflow.c (html_clueflow_spell_check): fixed resolving
	is_text by test if obj != NULL

	* htmltextmaster.c (get_cursor_base): fix slave condition for
	slave identification (replaced < with <=)

2000-08-10  Larry Ewing  <lewing@helixcode.com>

	* htmlengine.c (html_engine_unrealize): add an unrealize function
	to as a slightly reworked version of the patch that Kevin A Gibbs 
	<kgibbs@stanford.edu> sent in to fix unrelization of the widget
	(thanks Kevin).

	* htmlengine.h: add prototype.
	
	* gtkhtml.c (unrealize): call html_engine_unrealize. 

2000-08-05  Radek Doulik  <rodo@helixcode.com>

	* htmltext.c (html_text_get_nb_width): handle "" case
	(html_text_get_nb_width): extracted forwarding of get_nb_width to
	(forward_get_nb_width): new helper function

	* htmltextslave.c (get_next_nb_width): fixed "" case

	* htmltext.c (calc_min_width): fixed "" case

2000-08-04  Radek Doulik  <rodo@helixcode.com>

	* htmlengine.c (insert_text): don't eat leading spaces in <PRE>
	block

	* htmlprinter.c (draw_panel): scale border size to printer
	coordinates
	(begin): #ifdef'ed debugging rectangle

	* htmlengine-print.c (html_engine_print): use
	html_object_change_set_down here to force complete calcsize

	* htmlobject.c (html_object_change_set_down): new function, set
	changes to this object and all it's childern

2000-08-03  Radek Doulik  <rodo@helixcode.com>

	* htmlengine-edit.c (html_engine_cut_and_paste_begin): hide cursor
	here
	(html_engine_cut_and_paste_end): show it here

	* gtkhtml.c (motion_notify_event): fixed editor cursor setting on
	click

	* htmlprinter.c (draw_background): added quick color printing
	bacground, pixmaps + tiling to be implemented later

	* htmlengine-print.c (print_all_pages): fixed page printing loop

	* htmlprinter.c (finalize): don't showpage here as it was already
	done
	(begin): set debug rounding line to dashed .5pt gray line

	* htmlengine-print.c (print_all_pages): force new_split_offset
	also when new_split_offset == split_offset

2000-08-02  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml.c (on_url): added assert here
	(mouse_change_pos): call on_url only if obj != NULL
	(scroll_update_mouse): call mouse_change_pos only if widget
	already realized

	* htmlclueflow.c (get_post_padding): removed previous uncorrect
	fix

	* htmltable.c (fit_line): override this virtual method as we do
	not want calc_size to be called here - it is expensive and
	unneeded

	* htmltextslave.c (fit_line): split only when len < posLen

	* gtkhtml.c (motion_notify_event): split
	(mouse_change_pos): new helper function, uses on_url
	(on_url): new helper function
	(scroll_update_mouse): new helper function
	(vertical_scroll_cb): call scroll_update_mouse, so mouse is
	updated when scrolling
	(horizontal_scroll_cb): likewise

2000-08-01  Radek Doulik  <rodo@helixcode.com>

	* htmlengine-edit-insert.c: same as below

	* htmltype.c: same as below

	* htmlengine.c: removed inclusion of htmllinktext.h

	* htmlobject.h: removed nb_width from htmlobject as it is not
	needed/used anymore

	* htmlclueflow.c (should_break): not needed anymore - removed
	(calc_size): first try of renice of this ugly function, we don't
	need is_pre anymore, some code extracted to helper function
	set_line_x, fixed first_run arg value for fit_line, fixed FIT_NONE
	case

	* gtkhtmldebug.c (dump_object_simple): added dumping of TextSlave
	text
	(gtk_html_debug_dump_object_type): added new function

	* Makefile.am: removed htmllinktext.[ch] from sources/headers

	* htmltype.c (html_types_init): removed LinkText type init

	* htmllinktext.[ch]: removed, they were not used anywhere
	
	* htmlobject.c (fit_line): do fitting here instead of simply
	returning FIT_COMPLETE

	* htmltextslave.c (debug_print): new helper function, move debug
	stuff here
	(fit_line): rewritten, should be exact now :)
	(split_at_newline): removed, no more needed
	(get_next_nb_width): new helper function
	(fit_line): do incremental calc_text_width here, so it's much
	faster now

	* htmltext.c (calc_preferred_width): moved here from TextMaster
	(html_text_get_nb_width): helper function returns non-breakable
	text width on begin/end of this text
	(calc_min_width): moved from TextMaster + rewritten

	* htmlclueflow.c (calc_min_width): rewritten

2000-07-31  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml.c (motion_notify_event): set ibeam cursor only when
	selection allowed

	* htmlengine.c (parse_color): try to pad color string with 0 when
	too short
	(parse_table): do | on parse_color result so when color not
	successfuly parsed and we have table or row color, it remains set
	to this color

2000-07-28  Radek Doulik  <rodo@helixcode.com>

	* htmlclueflow.c (get_post_padding): add post padding to items
	(not final one)

2000-07-28  Ettore Perazzoli  <ettore@helixcode.com>

	* htmltext.c (get_tags): Use lowercase for tags.

	* htmlclueflow.c (get_tag): Use lowercase for tags.
	(write_pre_tags): Likewise.
	(get_tag_for_style): Likewise.
	(halign_to_string): Likewise.
	(save): Likewise.
	(save): Likewise.

2000-07-28  Ettore Perazzoli  <ettore@helixcode.com>

	* gtkhtml.c (button_press_event): Don't select the region if
	`allow_selection' is false.
	(motion_notify_event): Don't select anything if `allow_selection'
	is false.

2000-07-27  Joe Shaw  <joe@helixcode.com>

	* src/htmltokenizer.c (html_tokenizer_write): Initialize the tokenizer
	if it hasn't been already.
	
2000-07-27  Radek Doulik  <rodo@helixcode.com>

	* htmlclueflow.c (spell_check_word): fixed bad condition in
	g_assert

2000-07-26  Larry Ewing  <lewing@helixcode.com>

	* htmlembedded.c (html_embedded_set_widget): call force_placement.
	(force_placement): The hack to force the widget to get size
	allocated lives here now.

	* htmliframe.c (html_iframe_init): remove the hack for allocation
	from here since it is now in htmlembedded.

	* htmlengine.c (html_engine_destroy): only destroy the spell
	checker if it was properly made.

2000-07-26  Radek Doulik  <rodo@helixcode.com>

	* htmlclueflow.c (html_clueflow_spell_check): as below

	* htmlengine.c (html_engine_spell_check): do spell checking only
	if spell_checker was successfuly created

2000-07-24  Peter Williams  <peterw@helixcode.com>

	* gtkhtml.c (setup_scroll_timeout): Use GDK_THREADS_LEAVE/ENTER
	around our direct call the scroll_timeout_cb so that we don't
	deadlock, as we're in a GDK event loop so the threads are locked
	already.

2000-07-21  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml-properties.c (gtk_html_class_properties_load):
	implemented gnome_config properties loading
	(gtk_html_class_properties_save): and saving

	* htmlclueflow.c (next_obj): new helper function, skips to next
	non-slave object and updates offset and is_text flag
	(spell_check_word): simplified, use next_obj
	(html_clueflow_spell_check): fixed case, when after add to
	session/personal dictionary word is checked OK and is on the end
	of flow - before there were not cleared spell errors

2000-07-20  Ramiro Estrugo  <ramiro@eazel.com>

	* gtkhtml-properties.c:
	* gtkhtml.c: (class_init):
	* htmltext.c: (destroy):
	Protect more pspell dependent code with #ifdef GTKHTML_HAVE_PSPELL.

2000-07-20  Radek Doulik  <rodo@helixcode.com>

	* htmltext.c (copy_helper): copy spell_errors here
	(destroy): clear spell_errors here

	* htmlcursor.c (html_cursor_get_prev_char): new function, returns
	char before cursor

	* gtkhtml.c: new signal spell_suggestion_request for spell checker
	suggestions handling

	* keybindingsrc.emacs: added bindings for new commands

	* keybindingsrc.ms: added bindings for new commands

	* gtkhtml-properties.c: added new commands

	* gtkhtml.h: added spell-suggest, spell-personal-add,
	spell-session-add commands

	* htmlengine.c (html_engine_get_word): new function, returns word
	at cursor
	(html_engine_word_is_valid): new function, returns FALSE if word
	at cursor is invalid by spell checker
	(html_engine_replace_word_with): new function, replaces word at
	cursor with new one

2000-07-19  Radek Doulik  <rodo@helixcode.com>

	* htmlcursor.c (html_cursor_get_current_char): use
	html_object_next_not_slave here

2000-07-18  Radek Doulik  <rodo@helixcode.com>

	* htmlengine-edit-paste.c (do_paste): use SPELL_CHECK

	* htmlengine-edit-insert.c (do_insert): use SPELL_CHECK

	* htmlengine-edit-delete.c (html_engine_delete): use SPELL_CHECK

	* htmlclueflow.h (SPELL_CHECK): new macro - spell checks clue flow

2000-07-15  Radek Doulik  <rodo@helixcode.com>

	* WIP: spell checking

2000-07-15  Larry Ewing  <lewing@helixcode.com>

	* htmldrawqueue.c (clear): draw the background properly.

2000-07-14  Radek Doulik  <rodo@helixcode.com>

	* htmliframe.c (html_iframe_init): set iframe parent

	* gtkhtml.c (gtk_html_set_iframe_parent): wrapper to set iframe
	parent
	(focus_in_event): if embedded in iframe, give focus to iframe
	parent
	(focus_out_event): updated, handle focus only when not iframe
	embedded

	* gtkhtml.h: added iframe parent to GtkHTML

	* htmltextmaster.c (calc_min_width): fix <PRE> minimal width
	calculation

2000-07-12  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml-properties.c (gtk_html_class_properties_load): removed
	compiler warning

	* htmlengine-save.c (encode_entities): added &nbsp; encoding

	* htmlengine.c (html_engine_select_region): changed selection
	behaviour, don't unselect when selection active and pointer moves
	outside an object
	+ select one offset length in object if pointer moves (try move
	pointer over image)

	* htmlimageinput.c: url and target could be NULL now, so images
	with NULL url don't act as links

	* htmlgdkpainter.c (draw_pixmap): save one div here

2000-07-11  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml.c (gtk_html_set_font_style): emit
	INSERTION_FONT_STYLE_CHANGED signal
	(command): use gtk_html_set_font_style and
	gtk_html_toggle_font_style here

	* htmlengine-edit-fontstyle.c (html_engine_set_font_style): return
	TRUE if insertion_font_style changed

2000-07-10  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml.c (load_keybindings): set binding_set to klass bindings
	set before setting standard bindings
	(load_keybindings): clear also klass bindings

2000-07-10  Larry Ewing  <lewing@helixcode.com>

	* htmlengine-edit-fontstyle.c: remove
	html_engine_set_font_style_old as it is no longer being used
	anywhere

	* htmlgdkpainter.c (draw_panel): clean up an an incorrect cast of
	a colorset.

2000-07-07  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml.c (init_properties): be more verbose about gconf errors
	(command): call copy only when selection is active
	(command): call paste only when cut_buffer != NULL

	* testgtkhtml.c (main): added gconf_init

2000-07-06  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml.c: removed gtkhtmllib_init
	(init_properties): complain if gconf is not initialized (g_error)
	(init_properties): create gconf_client here

2000-07-05  Radek Doulik  <rodo@helixcode.com>

	* patch from LotR applied

	* htmlengine-edit-selection-updater.c (updater_idle_callback):
	disable selection if mark and cursor have the same position

2000-07-05  Dan Winship  <danw@helixcode.com>

	* htmllinktextmaster.c (save): 
	* htmllinktext.c (save): 
	* htmltext.c (save, save_plain): Fix calls to
	html_engine_save_output_string to be safe when the text contains
	%-signs.

2000-07-05  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml.c (load_keybindings): when keybindings file not found,
	bind default bindings anyway

	* htmlengine-edit-fontstyle.c (html_engine_set_font_style): I have
	problems with font style setting, so I have implemented quick
	replacement, which uses cut&paste

	* htmlengine-edit-delete.c (delete_different_parent): set pnext
	before removing p from parent

	* htmlengine-edit-paste.c (merge_possibly): remove empty text
	objects here, this fixes well known magic links bug
	(do_paste): try to merge for all pasted objects, this simplifies
	cut&paste commands (they do not need try to merge by itself)
	(prepare_clueflows): do split_first_clueflow_at_cursor also when
	append is TRUE

	* htmlengine-edit-insert.c (equal_insertion): fixed case when
	target is NULL

	* htmlengine-edit-paste.c (split_first_clueflow_at_cursor):
	simplified, use only append_after (it will call prepend if needed)
	(prepend_object): likewise

	* htmlengine-edit-insert.c (insert_chars_different_style): don't
	split text when inserting on end of it (where offset == text_len)
	so we don't get empty link/textmasters any more
	(insert_chars_at_not_text): simplified, use only append_after (it
	will call prepend if needed)

	* htmlclue.c (html_clue_append_after): when where == NULL then
	call html_clue_prepend instead

2000-07-04  Radek Doulik  <rodo@helixcode.com>

	* htmlengine-edit-text.c (upper_lower): removed quick selection
	bug fix
	(html_engine_capitalize_word): also make tail of word lowercase
	instead of only uppercase first letter

	* htmlobject.c (select_range): mark object selected only when
	length > 0 or start < object length

2000-07-03  Radek Doulik  <rodo@helixcode.com>

	* htmlengine-edit-text.c (upper_lower): quick fix for bug in
	selection, going to fix selection now

	* gtkhtml.h: new commands enum entries

	* gtkhtml.c (command): call capitalize + up/downcase
	implementation

	* keybindingsrc.ms: the same as in emacs, could someone point me
	to right MS bindings?

	* keybindingsrc.emacs: added new bindings M-c,M-u,M-l

	* htmlengine-edit-text.c: new file
	(html_engine_capitalize_word): capitalize word implementation
	(html_engine_upcase_downcase_word): up/downcase word implementation
	(find_first): helper function, finds 1st alphanum char in forward
	direction
	(upper_lower): helper function, converts text in cut_buffer to
	up/downcase

Sat Jul 01 11:50:30 2000  George Lebl <jirka@5z.com>

	* gtkhtml.[ch]:  Add a gtkhtmllib_is_initialized call to find out if
	  we have been initialized.  Also don't initialize gconf if it has
	  already been initialized.

2000-07-01  Radek Doulik  <rodo@helixcode.com>

	* keybindingsrc.ms: added new bindings for inc/dec font size

	* gtkhtml.c (command): added calls for inc/dec font size

	* htmlengine-edit-fontstyle.c (html_engine_font_size_inc_dec): new
	function implementing command for increase/decrease font size
	(inc_dec_size_cb): iterator function for inc/dec in cut&paste
	(inc_dec_size): helper function - computes increased/decreased
	font size

	* htmlengine-edit.c (html_engine_cut_and_paste): new function to
	simplify implementation of simple editor commands

2000-06-30  Radek Doulik  <rodo@helixcode.com>

	* htmlengine-edit-insert.c: added url, target to ActionData
	(do_redo): use url, target
	(create_action_data): likewise
	(decide_color): new function, helps to decide which color for
	text/links
	(do_insert): use url, target
	(equal_insertion): new helper function, decides whether the text
	object has same attributes as insertion

	* htmlengine-edit-fontstyle.c (html_engine_get_document_target):
	fix, return html_object_get_target and not html_object_get_url

	* gtkhtml.c (button_press_event): shift + mouse press button
	extends/reduces selection

	* keybindingsrc.emacs: added shift movement selection also to
	emacs keybindings + C-Insert copy S-Insert paste and S-Delete cut

	* htmltext.c (get_tags): colors attribute saving

2000-06-29  Larry Ewing  <lewing@helixcode.com>

	* htmliframe.c (iframe_url_requested): remove "this is a note"
	warning for peterw's peace of mind.

2000-06-29  Radek Doulik  <rodo@helixcode.com>

	* htmlengine-edit-images.c (html_engine_insert_image): use
	HTMLColor here

	* htmlcolor.c (html_color_new_from_gdk_color): make const safe

	* htmlengine.c (html_engine_destroy): destroy insertion_url/target

	* htmlengine.h: add insertion_urt/target

	* htmlengine-edit-fontstyle.c (html_engine_set_font_style): set
	insertion style only when no selection active

2000-06-28  Larry Ewing  <lewing@helixcode.com>

	* htmlimage.c (html_image_init): initialize some important
	variables properly.
	Remove the work around for animation sizes, gtkhtml now will
	require gdk-pixbuf 0.9 or later to funtion properly for animated
	gifs.

2000-06-28  Radek Doulik  <rodo@helixcode.com>

	* htmlengine.c (html_engine_unselect_all): reset shift_selection
	flag

	* keybindingsrc.ms: new bindings for new commands

	* htmlengine.h: added shift_selection flag to engine

	* gtkhtml.c (move_selection): new commands implementation

	* gtkhtml.h: added new commands for ms like shift selection

	* htmllinktextmaster.c (html_link_text_master_to_text): fixed
	compiler warning

2000-06-28  Larry Ewing  <lewing@helixcode.com>

	* htmllinktextmaster.c (copy_helper): move the url and target
	copying to here.
	(copy): call copy_helper.
	(extract_text): This was needed to properly support the cut
	buffer, otherwise we ended up with invalid url and target strings.
	(split): call copy_helper.
	(html_link_text_master_class_init): use our extract_text method.

2000-06-28  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml-properties.c: likewise

	* gtkhtml-properties.h: likewise

	* gtkhtml.c: likewise

	* gtkhtml.h: make gconf usage optional

2000-06-28  Larry Ewing  <lewing@helixcode.com>

	* htmlengine-edit-delete.c (safe_remove): once again do not access
	the next member after you have destroyed the object.

2000-06-27  Ettore Perazzoli  <ettore@helixcode.com>

	* htmlclueflow.c (write_pre_tags): Renamed from
	`write_indentation_tags'.  Write an initial `<BR>' if appropriate.
	(write_post_tags): New.
	(write_indentation_tags): Renamed from
	`write_indentation_tags_helper'.  Write an initial newline if
	@last_value is different from @new_value.
	(save): Use it.  Don't output the <BR> here.
	(append_selection_string): Removed bogus `putchar'.
	(write_indent): New.
	(write_indentation_tags): Use it.
	(save): Use it to write indentation spaces before the actual
	contents if the paragraph is not a PRE paragraph.

2000-06-27  Radek Doulik  <rodo@helixcode.com>

	* htmlengine.c (push_color): ref color when pushing on stack

	* htmlimage.c (copy): ref color only if non-NULL

	* htmlengine-save.c (write_header): implemented color attributes saving

        * near every .c[h] file updated to use HTMLColor
	
	* htmlcolorset.c: updated to use HTMLColor

	* htmlcolor.h: new API for colors handling

2000-06-27  Larry Ewing  <lewing@helixcode.com>

	* htmlclue.c (destroy): don't read the next member from an object
	after we have destroyed that object.

2000-06-26  Ettore Perazzoli  <ettore@helixcode.com>

	* htmlengine-edit-delete.c (html_engine_delete): Relayout the
	following paragraph too.

2000-06-26  Radek Doulik  <rodo@helixcode.com>

	* htmlengine-edit-fontstyle.c
	(html_engine_update_insertion_color): test for NULL new_color

	* gtkhtml.c (gtk_html_set_paragraph_alignment): renamed
	(gtk_html_get_paragraph_alignment): new wrapper function
	(gtk_html_get_paragraph_style): likewise

2000-06-23  Radek Doulik  <rodo@helixcode.com>

	* htmlengine-edit-fontstyle.c
	(html_engine_update_insertion_color): new function, used in
	update_styles
	(html_engine_get_color): new function, simply returns engine
	insertion color
	(html_engine_get_document_color): new function, returns color of
	text under cursor or in selection

	* gtkhtml.c: added signal insertion_color_changed
	(update_styles): emit insertion_color_changed signal when needed

	* htmlengine-edit-insert.c (html_engine_insert): use insertion color
	(create_action_data): remember color
	(do_redo): use remebered color
	(do_insert): use color
	(insert_chars): test also color equality along with style equality
	(insert_chars_at_not_text): use color
	(insert_chars_different_style): use color
	(insert_para): use insertion color

	* htmlengine.h: added insertion color to engine

	* htmlengine-edit.c (html_engine_cut_and_paste_begin): new
	function, initialization of cut&paste
	(html_engine_cut_and_paste_end): new function, finishes cut&paste

	* htmlengine-edit-fontstyle.c (html_engine_set_color): as below
	(html_engine_set_color): use new cut&paste functions

	* htmlengine-edit-insert.c (html_engine_insert_link): use push/pop
	selection
	(html_engine_remove_link): likewise

	* htmlengine-edit.c (html_engine_selection_push): new function to
	store current selection on stack
	(html_engine_selection_pop): new function to restore selection
	from stack

	* htmlengine.h: added insertion color

	* htmlengine-edit-fontstyle.c
	(html_engine_get_document_font_style): new function, returns
	fontstyle from document (HTMLText or selection)
	(html_engine_get_font_style): new function, returns current font
	style (insertion style or if it is default then document font style)
	(html_engine_font_style_toggle): updated to use html_engine_get_font_style
	(html_engine_update_insertion_font_style): updated to use
	html_engine_get_document_font_style

	* gtkhtml.c (key_press_event): update styles only if cursor
	changed position

	* keybindingsrc.ms: same as below

	* keybindingsrc.emacs: added new bindings (Alt 1..7 sets font sizes)

	* gtkhtml.c (command): new commands implementation

	* gtkhtml-properties.c: added new commands for size setting/increasing/decreasing

2000-06-22  Larry Ewing  <lewing@helixcode.com>

	* htmlclueflow.c (draw_background): draw our parent in the region
	we are drawing our background bacause we may be flowing around
	something.  This "fixes" bug #6 but now the image drawing code
	needs to be written properly to only draw the region we actually
	request otherwise we will get odd effects on images with
	tranparency.

	* htmlengine.c (html_engine_end): make sure we end the tokenizer
	before we update the engine, otherwise we do not parse trailing
	text because it is only appended after html_tokenizer_end is
	called.

	* htmliframe.c (html_iframe_init): inherit the colorset from the
	parent gtkhtml.

2000-06-21  Radek Doulik  <rodo@helixcode.com>

	* htmlimage.c (html_image_init): make sure url/target is always !=
	NULL

	* htmlengine-edit-insert.c (html_engine_remove_link_object): use
	html_object_get_length here

	* htmltext.c (get_length): new method, returns text_len
	(html_text_class_init): set get_length method

	* htmlobject.c (get_length): method for htmlobject, returns 1
	(html_object_get_length): new function, returns object length
	(html_object_class_init): set get_length

	* htmlobject.h: added new virtual method get_length

	* htmlengine-edit-insert.c (html_engine_remove_link): new
	function, removes link(s) from selection
	(html_engine_remove_link_object): new function, removes link from
	obj arg

	* htmlimage.c (remove_link): new function, clears url/target
	attributes

	* htmllinktextmaster.c (remove_link): new function, returns text
	master with the same content/style
	(html_link_text_master_class_init): set remove_link method

	* htmlobject.c (html_object_remove_link): new function, returns
	linked object replacement, otherwise NULL

	* htmlobject.h: new virtual method remove_link

	* htmlengine-edit-insert.c (html_engine_insert_link): same as below

	* htmlengine-edit-paste.c (html_engine_paste_object): use
	cut_buffer push/pop functions

	* htmlengine-edit.c (html_engine_cut_buffer_push): new function lo
	"legalize" cut_buffer switching hack
	(html_engine_cut_buffer_pop): opposite to previous one

	* keybindingsrc.ms: added undo/redo to MS like bindings, changed
	alignment modifiers to <Ctrl><Alt>

	* htmlimage.c (set_link): new function, sets urt and target for
	image

	* htmlengine-edit-insert.c (html_engine_insert_link): rewritten,
	now it does copy, modify cut buffer to contain linked objects and
	then paste it back. In case of empty selection, it paste empty
	link text master object

	* htmllinktext.c (set_link): new function, sets url and target,
	returns NULL
	(html_link_text_class_init): set set_link

	* htmltextmaster.c (set_link): new virt. function - returns
	created linktextmaster
	(html_text_master_class_init): set set_link

	* htmlobject.c (html_object_set_link): new function for link setting
	(html_object_class_init): set set_link virtual function to NULL

2000-06-19  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml.c (clean_bindings_set): I must clean all 3 possible
	binding_set's - this maybe fixed by adding new functions to gtk
	(load_keybindings): now it could load custom bindings

	* keybindingsrc.emacs: same as below

	* keybindingsrc.ms: removed binding to GtkHTML class, done in
	gtkhtml.c now

2000-06-19  Ettore Perazzoli  <ettore@helixcode.com>

	* gtkhtml.c (load_keybindings): Map shift+backspace to
	`DELETE_BACK'.

2000-06-19  Ettore Perazzoli  <ettore@helixcode.com>

	* htmlengine-edit-delete.c (html_engine_delete_selection): Update
	the selection before deleting it.

	* htmlengine-edit-copy.c (html_engine_copy): Update the selection
	before copying.
	(html_engine_copy_to_buffer): Likewise.

	* keybindingsrc.emacs: Bind "cut-line" to "<Ctrl>k".

	* gtkhtml-properties.c: Add a "cut-line" command and bind it as
	`GTK_HTML_COMMAND_CUT_LINE'.

	* gtkhtml.c (command): Handle `GTK_HTML_COMMAND_CUT_LINE'.

	* gtkhtml.h: New command `GTK_HTML_COMMAND_CUT_LINE'.

	* gtkhtml-keybinding.c (cut_line): New.

	* htmlengine-edit-cut.c (html_engine_cut): Update the selection
	before doing anything.
	(html_engine_cut_line): New.

	* gtkhtml.c (load_keybindings): Load the keybindings from
	$(prefix)/share/gtkhtml instead of using the gnome_datadir.

2000-06-18  Ettore Perazzoli  <ettore@helixcode.com>

	* htmlengine.c (html_engine_set_editable): Bring the cursor home
	only after ensuring the thing is actually editing-compatible
	[i.e., after calling `ensure_editable()'].

2000-06-17  Ettore Perazzoli  <ettore@helixcode.com>

	* gtkhtml.c (gtk_html_set_editable): If the widget has become
	editable, update the styles with `update_styles()'.
	(gtk_html_begin): Added precondition: @html is not editable.

	* gtkhtml.c (command): Delete the selection appropriately for
	`COMMAND_INSERT_PARAGRAPH', `COMMAND_DELETE',
	`COMMAND_DELETE_BACK'.
	(selection_received): Delete the selection before inserting.
	(key_press_event): Likewise.

	* htmlengine-edit-delete.c (html_engine_delete_selection): New.

2000-06-16  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml.c: moved enum some defs to gtkhtml-properties.c + some
	minor keybindings changes

2000-06-14  Larry Ewing  <lewing@helixcode.com>

	* htmliframe.c (html_iframe_init): place the widget offscreen
	initialy so that it can size allocate.

2000-06-15  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml-properties.c (gtk_html_class_properties_load): use val
	== NULL test instead of !dflt

	* keybindingsrc.emacs: same as in keybindingsrc.ms

2000-06-14  Radek Doulik  <rodo@helixcode.com>

	* keybindingsrc.ms: paragraph styles binded to Ctrl 1..8 + 0 and
	Ctrl-Alt 1..3

	* gtkhtml.c: more keybindings - paragraph styles

	* Makefile.am (testgtkhtml_LDADD): removed -lgconf-gtk which was
	hack and is fixed now

	* testgtkhtml.c (main): call gtkhtmllib_init

        keybindings support + gtkhtml config capplet using gconf
	
	* gtkhtml.c (key_press_event): so, finnaly insert everything which
	nas state not containing Ctrl,Alt
	(gtkhtmllib_init): new function, please call it before using
	gtkhtml widget (we need this for gconf init)

2000-06-12  Ettore Perazzoli  <ettore@helixcode.com>

	* htmlclueflow.c (save_plain): For indented paragraphs, emit as
	many tabs as the level of indentation before the actual contents.

2000-06-12  Radek Doulik  <rodo@helixcode.com>

	* gtkhtml.c (key_press_event): insert text also with LOCK_MASK bit
	turned on
	(key_press_event): queue draw + update style every time we handle key_press

2000-06-12  Ettore Perazzoli  <ettore@helixcode.com>

	* htmlclueflow.c (get_tag_for_item_group): Removed.
	(save): Don't use it anymore.  This will make us produce somewhat
	invalid HTML, but at least indentation will look right.

	* htmlengine.c (html_engine_queue_clear): Call
	`html_colorset_get_color_allocated' instead of
	`html_colorset_get_color', so that we get an allocated color.
	This fixes the "black box when deleting" bug.

	* htmlengine.h: Remove `bDrawBackground' from `HTMLEngine'.  It
	was not being used anywhere.

	* htmlclueflow.c (calc_size): Remove all the text slaves before
	doing anything else.
	(get_pre_padding): New.
	(add_pre_padding): Rewritten to use it.
	(get_post_padding): New.
	(add_post_padding): Rewritten to use it.
	(save_plain): If the pre padding is greater than zero, emit a
	newline before the body of the paragraph.  Likewise, if the post
	padding is greater than zero, emit an extra newline after the body
	of the paragraph.  This way, the plaintext output mimics the
	appearance of the graphically rendered HTML at least a little bit.
	(relayout_with_siblings): Renamed from
	`relayout_for_level_change'.
	(html_clueflow_set_style): Use it.  This way a style change
	updates the padding for the siblings too when necessary.
	(html_clueflow_set_indentation): Use it.
	(html_clueflow_indent): Use it.

	* htmlengine.c (html_engine_normalize_cursor): New.

	* htmlengine-edit-fontstyle.c (set_font_style_in_selection):
	Update the selection before doing anything else.
	(merge_safely): New arg @engine.  Removed args @cursor and @mark.
	(merge_backward): New arg @engine.  Removed args @cursor and
	@mark.
	(merge_forward): Likewise.
	(set_font_style): Call
	`html_engine_edit_selection_updater_cursor_changed'.

	* htmlengine-edit-selection-updater.c
	(html_engine_edit_selection_updater_update_now): Renamed from
	`html_engine_edit_selection_update_now'.
